(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[   1679221,      24463]
NotebookOptionsPosition[   1677155,      24392]
NotebookOutlinePosition[   1677512,      24408]
CellTagsIndexPosition[   1677469,      24405]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Utils", "Title",
 CellChangeTimes->{{3.506638606182107*^9, 3.5066386114370317`*^9}, {
  3.506643296100642*^9, 3.506643296739168*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"graphCoords", "[", "g_Graph", "]"}], ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{"Thread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"VertexList", "[", "g", "]"}], "->", "VertexCoordinates"}], "/.", 
       RowBox[{"AbsoluteOptions", "[", "g", "]"}]}], "]"}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"getPR", "[", "lst_", "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xs", ",", "ys"}], "}"}], "=", 
       RowBox[{"Transpose", "[", "lst", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"two", " ", "extra", " ", 
        RowBox[{"1", "/", "scale"}], " ", "offsets", " ", "needed", " ", 
        "for", " ", "exact", " ", "match"}], "*)"}], 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Min", "[", "xs", "]"}], ",", 
          RowBox[{"Max", "[", "xs", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Min", "[", "ys", "]"}], ",", 
          RowBox[{"Max", "[", "ys", "]"}]}], "}"}]}], "}"}]}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"getPR", "[", 
     RowBox[{"lst_", ",", "pad_"}], "]"}], ":=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"xs", ",", "ys"}], "}"}], "=", 
       RowBox[{"Transpose", "[", "lst", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"two", " ", "extra", " ", 
        RowBox[{"1", "/", "scale"}], " ", "offsets", " ", "needed", " ", 
        "for", " ", "exact", " ", "match"}], "*)"}], 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Min", "[", "xs", "]"}], "-", "pad"}], ",", 
          RowBox[{
           RowBox[{"Max", "[", "xs", "]"}], "+", "pad"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Min", "[", "ys", "]"}], "-", "pad"}], ",", 
          RowBox[{
           RowBox[{"Max", "[", "ys", "]"}], "+", "pad"}]}], "}"}]}], "}"}]}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"getPR", "[", "g_Graph", "]"}], ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vcoords", "=", 
       RowBox[{"graphCoords", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"getPR", "[", 
       RowBox[{
        RowBox[{"VertexList", "[", "g", "]"}], "/.", "vcoords"}], "]"}]}], 
     "\[IndentingNewLine]", ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"getPR", "[", 
     RowBox[{"g_Graph", ",", "pad_"}], "]"}], ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"vcoords", "=", 
       RowBox[{"graphCoords", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"getPR", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"VertexList", "[", "g", "]"}], "/.", "vcoords"}], ",", 
        "pad"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"getIS", "[", 
     RowBox[{"g_Graph", ",", "scale_"}], "]"}], ":=", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"pr", "=", 
       RowBox[{"getPR", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"is", "=", 
       RowBox[{
        RowBox[{"-", "scale"}], " ", 
        RowBox[{"Subtract", "@@@", "pr"}]}]}]}], "\[IndentingNewLine]", 
     ")"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pr2points", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"xmin_", ",", "xmax_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ymin_", ",", "ymax_"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"(", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"xmin", ",", "ymin"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"xmin", ",", "ymax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"xmax", ",", "ymax"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"xmax", ",", "ymin"}], "}"}]}], "}"}], "\[IndentingNewLine]", 
   ")"}]}]}], "Input",
 CellChangeTimes->{{3.506643301223143*^9, 3.506643331722148*^9}, {
  3.5066437545153513`*^9, 3.506643820522586*^9}, {3.506643879710598*^9, 
  3.506643879989571*^9}, {3.5066439605076838`*^9, 3.5066439696512117`*^9}, {
  3.506651652067404*^9, 3.5066517029496403`*^9}}],

Cell["makeClusterGraph", "Section",
 CellChangeTimes->{{3.506638659150736*^9, 3.506638662752294*^9}}],

Cell[CellGroupData[{

Cell["highlightClusters", "Section",
 CellChangeTimes->{{3.506638664860579*^9, 3.506638673287034*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"highlightClusters", "[", 
    RowBox[{"g_", ",", 
     RowBox[{"{", 
      RowBox[{"jnodes_", ",", "jedges_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.506638674576148*^9, 3.506638690248057*^9}, 
   3.506638745712619*^9, {3.506638821256956*^9, 3.506638830866316*^9}, {
   3.5066388666418533`*^9, 3.506638907318433*^9}, {3.506638961165485*^9, 
   3.506638979623865*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ComputationalGeometry`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"highlightCl", "[", 
   RowBox[{"g_", ",", "cl_", ",", "color_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vcoords", "=", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"VertexList", "[", "g", "]"}], "->", "VertexCoordinates"}], "/.", 
        RowBox[{"AbsoluteOptions", "[", "g", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"points", "=", 
      RowBox[{"cl", "/.", "vcoords"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"hull", "=", 
      RowBox[{"ConvexHull", "[", 
       RowBox[{"points", ",", 
        RowBox[{"AllPoints", "\[Rule]", "False"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Opacity", "[", ".3", "]"}], ",", "color", ",", 
        RowBox[{"Thickness", "[", 
         RowBox[{"1", "/", "2"}], "]"}], ",", 
        RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], ",", 
        RowBox[{"JoinedCurve", "[", 
         RowBox[{
          RowBox[{"Line", "[", 
           RowBox[{"points", "[", 
            RowBox[{"[", "hull", "]"}], "]"}], "]"}], ",", 
          RowBox[{"CurveClosed", "\[Rule]", "True"}]}], "]"}]}], "}"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 CellChangeTimes->{{3.506638967456777*^9, 3.506639014784068*^9}, {
  3.506641148188686*^9, 3.5066411532924213`*^9}, {3.506641890654769*^9, 
  3.506641893134519*^9}, {3.506641986874002*^9, 3.506642036692297*^9}, {
  3.506642103860752*^9, 3.5066421128016453`*^9}, {3.506642148159794*^9, 
  3.506642156765401*^9}, {3.506642230530738*^9, 3.506642231286995*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"drawOutline", "[", 
    RowBox[{"points_", ",", "thickness_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 CellChangeTimes->{3.506638829807271*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Outline cluster", "Section",
 CellChangeTimes->{{3.506702774333061*^9, 3.5067027817453213`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"outlineCl", "[", 
    RowBox[{
    "g_", ",", "cl_", ",", "color_", ",", "radius_", ",", "thickness_", ",", 
     "scale_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vcoords", "=", 
      RowBox[{"Thread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"VertexList", "[", "g", "]"}], "->", "VertexCoordinates"}], "/.", 
        RowBox[{"AbsoluteOptions", "[", "g", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"points", "=", 
      RowBox[{"cl", "/.", "vcoords"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"points", "=", 
        RowBox[{"points", "+", 
         RowBox[{"RandomReal", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", ".01"}], ",", ".01"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Length", "@", "points"}], ",", "2"}], "}"}]}], 
          "]"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"pr", "=", 
      RowBox[{"getPR", "[", 
       RowBox[{"points", ",", "radius"}], "]"}]}], ";", "\[IndentingNewLine]",
      "\[IndentingNewLine]", 
     RowBox[{"hull", "=", 
      RowBox[{"ConvexHull", "[", 
       RowBox[{"points", ",", 
        RowBox[{"AllPoints", "\[Rule]", "False"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Graphics", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Opacity", "[", ".3", "]"}], ",", "color", ",", 
        RowBox[{"Thickness", "[", 
         RowBox[{"1", "/", "2"}], "]"}], ",", 
        RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], ",", 
        RowBox[{"JoinedCurve", "[", 
         RowBox[{
          RowBox[{"Line", "[", 
           RowBox[{"points", "[", 
            RowBox[{"[", "hull", "]"}], "]"}], "]"}], ",", 
          RowBox[{"CurveClosed", "\[Rule]", "True"}]}], "]"}]}], "}"}], "]"}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"is", "=", 
      RowBox[{
       RowBox[{"-", "scale"}], " ", 
       RowBox[{"Subtract", "@@@", "pr"}]}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"thick1", "=", "radius"}], ";", "\[IndentingNewLine]", 
     RowBox[{"thick2", "=", 
      RowBox[{"radius", "-", "thickness"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"outline1", "=", 
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"color", ",", 
          RowBox[{"AbsoluteThickness", "[", 
           RowBox[{"thick1", "*", "scale"}], "]"}], ",", 
          RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], ",", 
          RowBox[{"CapForm", "[", "\"\<Round\>\"", "]"}], ",", 
          RowBox[{"JoinedCurve", "[", 
           RowBox[{
            RowBox[{"Line", "[", 
             RowBox[{"points", "[", 
              RowBox[{"[", "hull", "]"}], "]"}], "]"}], ",", 
            RowBox[{"CurveClosed", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "pr"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"outline2", "=", 
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"White", ",", 
          RowBox[{"AbsoluteThickness", "[", 
           RowBox[{"thick2", "*", "scale"}], "]"}], ",", 
          RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], ",", 
          RowBox[{"CapForm", "[", "\"\<Round\>\"", "]"}], ",", 
          RowBox[{"JoinedCurve", "[", 
           RowBox[{
            RowBox[{"Line", "[", 
             RowBox[{"points", "[", 
              RowBox[{"[", "hull", "]"}], "]"}], "]"}], ",", 
            RowBox[{"CurveClosed", "\[Rule]", "True"}]}], "]"}]}], "}"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "pr"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"fill", "=", 
      RowBox[{"Graphics", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"White", ",", 
          RowBox[{"Polygon", "[", 
           RowBox[{"points", "[", 
            RowBox[{"[", "hull", "]"}], "]"}], "]"}]}], "}"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "pr"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{"outline1", ",", "outline2", ",", "fill"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"GridGraph", "[", 
    RowBox[{"{", 
     RowBox[{"3", ",", "3"}], "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"jnodes", ",", "jedges"}], "}"}], "=", 
   RowBox[{"findTreeDecomposition", "[", 
    RowBox[{"g", ",", 
     RowBox[{"PrimaryHeuristic", "\[Rule]", "\"\<grid\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"colorList", "=", 
   RowBox[{"ColorData", "[", 
    RowBox[{"\"\<Crayola\>\"", ",", "\"\<ColorList\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"outlines", "=", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"outlineCl", "[", 
      RowBox[{"g", ",", "#1", ",", "#2", ",", 
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{"1", "/", "8"}], ",", "100"}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{"jnodes", ",", 
      RowBox[{"colorList", "[", 
       RowBox[{"[", 
        RowBox[{";;", 
         RowBox[{"Length", "@", "jnodes"}]}], "]"}], "]"}]}], "}"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.506703040646287*^9, 3.506703057327256*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"outlines", "~", "Join", "~", 
    RowBox[{"{", "g", "}"}]}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"getPR", "[", 
     RowBox[{"g", ",", 
      RowBox[{"1", "/", "2"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{3.506703069123045*^9}],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[0.9372549019607843, 0.8705882352941177, 0.803921568627451], 
     AbsoluteThickness[50], Opacity[0.3], CapForm["Round"], JoinForm["Round"],
      JoinedCurveBox[Line[{{1., 0.}, {0., 1.}, {0., 0.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], AbsoluteThickness[
      NCache[
       Rational[75, 2], 37.5]], CapForm["Round"], JoinForm["Round"], 
     JoinedCurveBox[Line[{{1., 0.}, {0., 1.}, {0., 0.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], PolygonBox[{{1., 0.}, {0., 1.}, {0., 0.}}]}}, {
    {RGBColor[0.803921568627451, 0.5843137254901961, 0.4588235294117647], 
     AbsoluteThickness[50], Opacity[0.3], CapForm["Round"], JoinForm["Round"],
      JoinedCurveBox[Line[{{1., 2.}, {0., 2.}, {0., 1.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], AbsoluteThickness[
      NCache[
       Rational[75, 2], 37.5]], CapForm["Round"], JoinForm["Round"], 
     JoinedCurveBox[Line[{{1., 2.}, {0., 2.}, {0., 1.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], PolygonBox[{{1., 2.}, {0., 2.}, {0., 1.}}]}}, {
    {RGBColor[0.9921568627450981, 0.8509803921568627, 0.7098039215686275], 
     AbsoluteThickness[50], Opacity[0.3], CapForm["Round"], JoinForm["Round"],
      JoinedCurveBox[Line[{{2., 0.}, {2., 1.}, {1., 0.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], AbsoluteThickness[
      NCache[
       Rational[75, 2], 37.5]], CapForm["Round"], JoinForm["Round"], 
     JoinedCurveBox[Line[{{2., 0.}, {2., 1.}, {1., 0.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], PolygonBox[{{2., 0.}, {2., 1.}, {1., 0.}}]}}, {
    {RGBColor[0.47058823529411764`, 0.8588235294117647, 0.8862745098039215], 
     AbsoluteThickness[50], Opacity[0.3], CapForm["Round"], JoinForm["Round"],
      JoinedCurveBox[Line[{{2., 1.}, {2., 2.}, {1., 2.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], AbsoluteThickness[
      NCache[
       Rational[75, 2], 37.5]], CapForm["Round"], JoinForm["Round"], 
     JoinedCurveBox[Line[{{2., 1.}, {2., 2.}, {1., 2.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], PolygonBox[{{2., 1.}, {2., 2.}, {1., 2.}}]}}, {
    {RGBColor[0.5294117647058824, 0.6627450980392157, 0.4196078431372549], 
     AbsoluteThickness[50], Opacity[0.3], CapForm["Round"], JoinForm["Round"],
      JoinedCurveBox[Line[{{1., 0.}, {1., 2.}, {0., 1.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], AbsoluteThickness[
      NCache[
       Rational[75, 2], 37.5]], CapForm["Round"], JoinForm["Round"], 
     JoinedCurveBox[Line[{{1., 0.}, {1., 2.}, {0., 1.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], PolygonBox[{{1., 0.}, {1., 2.}, {0., 1.}}]}}, {
    {RGBColor[1., 0.6431372549019608, 0.4549019607843137], AbsoluteThickness[
     50], Opacity[0.3], CapForm["Round"], JoinForm["Round"], 
     JoinedCurveBox[Line[{{2., 1.}, {1., 2.}, {1., 0.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], AbsoluteThickness[
      NCache[
       Rational[75, 2], 37.5]], CapForm["Round"], JoinForm["Round"], 
     JoinedCurveBox[Line[{{2., 1.}, {1., 2.}, {1., 0.}}],
      CurveClosed->True]}, 
    {GrayLevel[1], PolygonBox[{{2., 1.}, {1., 2.}, {1., 0.}}]}}, {
    GraphicsGroupBox[{
      {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
       DiskBox[{0., 0.}, 0.02261146496815286], 
       DiskBox[{0., 1.}, 0.02261146496815286], 
       DiskBox[{0., 2.}, 0.02261146496815286], 
       DiskBox[{1., 0.}, 0.02261146496815286], 
       DiskBox[{1., 1.}, 0.02261146496815286], 
       DiskBox[{1., 2.}, 0.02261146496815286], 
       DiskBox[{2., 0.}, 0.02261146496815286], 
       DiskBox[{2., 1.}, 0.02261146496815286], 
       DiskBox[{2., 2.}, 0.02261146496815286]}, 
      {Hue[0.6, 0.7, 0.5], Opacity[0.7], LineBox[CompressedData["
1:eJxTTMoPSmVmYGDgAWImKJ4T++KBnPVcewYw2LBHdO8PDnWx93A+AxQ0oKhj
YBBEUcfAULawufpNyQc4vyuupkW4+789zPx//0HgvT3MfBgf1X4GB1T7GRwY
wdQHe5j9MD7M/goUezfs6YHaC+PD1MPcB+N3QtXB9MPc0w0Vh/FRzWdw6EYx
H+Y+BgdU9zE4wNwH46Paz+AAsx8Av/KIFw==
        "]]}}], {}}},
  ImageSize->{200., 200.},
  PlotRange->{{-0.5, 2.5}, {-0.5, 2.5}}]], "Output",
 CellChangeTimes->{3.506703070304693*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "gives", " ", "raster", " ", "outline", " ", "of", " ", "surrounding", " ",
     "point", " ", "set"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"rasterRes", "=", 
     RowBox[{"1", "/", "2"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"outlinePoints", "[", 
    RowBox[{
    "points_", ",", "color_", ",", "radius_", ",", "thickness_", ",", "pr_", 
     ",", "scale_", ",", 
     RowBox[{"rasterRes", ":", 
      RowBox[{"1", "/", "2"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "is", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"pr", "=", 
        RowBox[{"getPR", "[", 
         RowBox[{"points", ",", "radius"}], "]"}]}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"hull", "=", 
       RowBox[{"ConvexHull", "[", 
        RowBox[{"points", ",", 
         RowBox[{"AllPoints", "\[Rule]", "False"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"is", "=", 
       RowBox[{
        RowBox[{"-", "scale"}], " ", 
        RowBox[{"Subtract", "@@@", "pr"}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"thick1", "=", "radius"}], ";", "\[IndentingNewLine]", 
      RowBox[{"thick2", "=", 
       RowBox[{"radius", "-", "thickness"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"outline", "=", 
       RowBox[{"Graphics", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"color", ",", 
           RowBox[{"AbsoluteThickness", "[", 
            RowBox[{"thick1", "*", "scale"}], "]"}], ",", 
           RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], ",", 
           RowBox[{"CapForm", "[", "\"\<Round\>\"", "]"}], ",", 
           RowBox[{"JoinedCurve", "[", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"points", "[", 
               RowBox[{"[", "hull", "]"}], "]"}], "]"}], ",", 
             RowBox[{"CurveClosed", "\[Rule]", "True"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"PlotRange", "\[Rule]", "pr"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"outlineRaster", "=", 
       RowBox[{
        RowBox[{"Rasterize", "[", 
         RowBox[{"outline", ",", "\"\<Data\>\"", ",", 
          RowBox[{"RasterSize", "\[Rule]", 
           RowBox[{"is", "*", "rasterRes"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}], "/", "255"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"outlineRaster2", "=", 
       RowBox[{"Rasterize", "[", 
        RowBox[{"outline", ",", 
         RowBox[{"RasterSize", "\[Rule]", 
          RowBox[{"is", "*", "rasterRes"}]}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"fill1", "=", 
       RowBox[{"Graphics", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"AbsoluteThickness", "[", 
            RowBox[{"thick2", "*", "scale"}], "]"}], ",", 
           RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], ",", 
           RowBox[{"CapForm", "[", "\"\<Round\>\"", "]"}], ",", 
           RowBox[{"JoinedCurve", "[", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"points", "[", 
               RowBox[{"[", "hull", "]"}], "]"}], "]"}], ",", 
             RowBox[{"CurveClosed", "\[Rule]", "True"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"PlotRange", "\[Rule]", "pr"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"fill2", "=", 
       RowBox[{"Graphics", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"Polygon", "[", 
            RowBox[{"points", "[", 
             RowBox[{"[", "hull", "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "pr"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"fill3", "=", 
       RowBox[{"Graphics", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"Polygon", "[", 
            RowBox[{"pr2points", "[", "pr", "]"}], "]"}], ",", "White", ",", 
           RowBox[{"AbsoluteThickness", "[", 
            RowBox[{"thick1", "*", "scale"}], "]"}], ",", 
           RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], ",", 
           RowBox[{"CapForm", "[", "\"\<Round\>\"", "]"}], ",", 
           RowBox[{"JoinedCurve", "[", 
            RowBox[{
             RowBox[{"Line", "[", 
              RowBox[{"points", "[", 
               RowBox[{"[", "hull", "]"}], "]"}], "]"}], ",", 
             RowBox[{"CurveClosed", "\[Rule]", "True"}]}], "]"}]}], "}"}], 
         ",", 
         RowBox[{"PlotRange", "\[Rule]", "pr"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"fillMask1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Rasterize", "[", 
          RowBox[{"fill1", ",", "\"\<Data\>\"", ",", 
           RowBox[{"RasterSize", "\[Rule]", 
            RowBox[{"is", "*", "rasterRes"}]}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "/", "255"}]}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"fillMask2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Rasterize", "[", 
          RowBox[{"fill2", ",", "\"\<Data\>\"", ",", 
           RowBox[{"RasterSize", "\[Rule]", 
            RowBox[{"is", "*", "rasterRes"}]}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "/", "255"}]}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"fillMask3", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Rasterize", "[", 
          RowBox[{"fill3", ",", "\"\<Data\>\"", ",", 
           RowBox[{"RasterSize", "\[Rule]", 
            RowBox[{"is", "*", "rasterRes"}]}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}], "/", "255"}]}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Graphics", "[", 
       RowBox[{"Raster", "[", 
        RowBox[{"addAlpha", "[", 
         RowBox[{"outlineRaster", ",", 
          RowBox[{"fillMask1", "*", "fillMask2", "*", "fillMask3"}]}], "]"}], 
        "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.506703645940631*^9, 3.506703658620021*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"scale", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pr", "=", 
   RowBox[{"getPR", "[", 
    RowBox[{"g", ",", 
     RowBox[{"1", "/", "2"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"is", "=", 
   RowBox[{
    RowBox[{"-", "scale"}], "*", 
    RowBox[{"Subtract", "@@@", "pr"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rasterRes", "=", 
   RowBox[{"1", "/", "2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pics", "=", 
   RowBox[{"MapThread", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"outlinePoints", "[", 
       RowBox[{
        RowBox[{"#1", "/.", "vcoords"}], ",", "#2", ",", 
        RowBox[{"1", "/", "2"}], ",", 
        RowBox[{"1", "/", "8"}], ",", "pr", ",", "scale", ",", "rasterRes"}], 
       "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"jnodes", "[", 
        RowBox[{"[", 
         RowBox[{";;", "5"}], "]"}], "]"}], ",", 
       RowBox[{"colorList", "[", 
        RowBox[{"[", 
         RowBox[{";;", "5"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"graphRaster", "=", 
   RowBox[{"Rasterize", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{"g", ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"getPR", "[", 
         RowBox[{"g", ",", 
          RowBox[{"1", "/", "2"}]}], "]"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "is"}]}], "]"}], ",", 
     RowBox[{"RasterSize", "\[Rule]", 
      RowBox[{"is", "*", "rasterRes"}]}], ",", 
     RowBox[{"Background", "\[Rule]", "None"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{"pics", "~", "Join", "~", 
   RowBox[{"{", "graphRaster", "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.506703252924958*^9, 3.506703449082407*^9}, {
  3.506703519530004*^9, 3.506703520542261*^9}, {3.506703556070508*^9, 
  3.506703560133197*^9}, {3.506703603458029*^9, 3.506703640239148*^9}, {
  3.506703670753065*^9, 3.506703691206746*^9}}],

Cell[BoxData[
 GraphicsBox[{
   RasterBox[
    NCache[{{{1, 1, 1, Rational[64, 85]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[253, 255], Rational[84, 85], Rational[251, 255], Rational[
        16, 255]}, {
       Rational[251, 255], Rational[247, 255], Rational[244, 255], Rational[
        56, 255]}, {
       Rational[251, 255], Rational[247, 255], Rational[81, 85], Rational[
        58, 255]}, {
       Rational[253, 255], Rational[84, 85], Rational[251, 255], Rational[
        19, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0},
        {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[84, 85], Rational[248, 255], Rational[49, 51], Rational[
        47, 255]}, {
       Rational[81, 85], Rational[77, 85], Rational[73, 85], Rational[
        181, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        254, 255]}, {
       Rational[81, 85], Rational[77, 85], Rational[218, 255], Rational[
        37, 51]}, {
       Rational[84, 85], Rational[248, 255], Rational[49, 51], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        29, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[206, 255], Rational[
        83, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        82, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        3, 5]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        92, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        29, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        48, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        241, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[206, 255], Rational[
        248, 255]}, {
       Rational[83, 85], Rational[81, 85], Rational[14, 15], Rational[
        86, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[251, 255], Rational[248, 255], Rational[49, 51], Rational[
        10, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[206, 255], Rational[
        83, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        71, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        31, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        9, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        69, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[81, 85], Rational[46, 51], Rational[218, 255], Rational[
        62, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        49, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        28, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[253, 255], Rational[84, 85], Rational[251, 255], Rational[
        16, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        254, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        148, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[251, 255], Rational[248, 255], Rational[244, 255], Rational[
        18, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        6, 17]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[49, 51], Rational[47, 51], Rational[15, 17], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], 0}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], 0}, {1, 1, 1, 
       0}, {Rational[83, 85], Rational[81, 85], Rational[79, 85], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[247, 255], Rational[16, 17], Rational[233, 255], 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], 0}, {
       Rational[49, 51], Rational[47, 51], Rational[15, 17], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        41, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[14, 15], Rational[
        86, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        1, 15]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        69, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[206, 255], Rational[
        248, 255]}, {
       Rational[84, 85], Rational[248, 255], Rational[49, 51], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        9, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        241, 255]}, {
       Rational[81, 85], Rational[77, 85], Rational[218, 255], Rational[
        37, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        48, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        254, 255]}, {
       Rational[253, 255], Rational[84, 85], Rational[251, 255], Rational[
        19, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        29, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[251, 255], Rational[247, 255], Rational[81, 85], Rational[
        58, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[251, 255], Rational[248, 255], Rational[49, 51], Rational[
        1, 5]}, {Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        92, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        92, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[251, 255], Rational[247, 255], Rational[244, 255], Rational[
        56, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[253, 255], Rational[84, 85], Rational[
        1, 17]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        251, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        149, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        3, 5]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[84, 85], Rational[251, 255], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[81, 85], Rational[77, 85], Rational[73, 85], Rational[
        179, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        244, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        29, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        31, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        82, 85]}, {
       Rational[81, 85], Rational[77, 85], Rational[73, 85], Rational[
        181, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[84, 85], Rational[83, 85], Rational[82, 85], Rational[
        3, 17]}, {
       Rational[239, 255], Rational[223, 255], Rational[206, 255], Rational[
        247, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        209, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        29, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 0}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        28, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        71, 85]}, {
       Rational[239, 255], Rational[74, 85], Rational[206, 255], Rational[
        83, 85]}, {
       Rational[84, 85], Rational[248, 255], Rational[49, 51], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[83, 85], Rational[244, 255], Rational[14, 15], Rational[
        82, 255]}, {
       Rational[239, 255], Rational[223, 255], Rational[206, 255], Rational[
        247, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        244, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        149, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        92, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        79, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        6, 17]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        148, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        49, 51]}, {
       Rational[239, 255], Rational[74, 85], Rational[206, 255], Rational[
        83, 85]}, {
       Rational[83, 85], Rational[81, 85], Rational[79, 85], Rational[
        29, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[84, 85], Rational[83, 85], Rational[82, 85], Rational[
        3, 17]}, {
       Rational[81, 85], Rational[77, 85], Rational[73, 85], Rational[
        179, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        251, 255]}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], 1}, {
       Rational[239, 255], Rational[74, 85], Rational[41, 51], Rational[
        254, 255]}, {
       Rational[81, 85], Rational[77, 85], Rational[218, 255], Rational[
        37, 51]}, {
       Rational[251, 255], Rational[248, 255], Rational[49, 51], Rational[
        10, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[253, 255], Rational[84, 85], Rational[
        1, 17]}, {
       Rational[251, 255], Rational[248, 255], Rational[49, 51], Rational[
        1, 5]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[50, 51], Rational[82, 85], Rational[242, 255], Rational[
        64, 255]}, {
       Rational[251, 255], Rational[248, 255], Rational[244, 255], Rational[
        18, 85]}, {
       Rational[253, 255], Rational[84, 85], Rational[251, 255], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1,
       1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 
      1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1,
       1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 
      1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}}}, {{{1, 1, 1, 0.7529411764705882}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9921568627450981, 0.9882352941176471, 0.984313725490196, 
       0.06274509803921569}, {0.984313725490196, 0.9686274509803922, 
       0.9568627450980393, 0.2196078431372549}, {0.984313725490196, 
       0.9686274509803922, 0.9529411764705882, 0.22745098039215686`}, {
       0.9921568627450981, 0.9882352941176471, 0.984313725490196, 
       0.07450980392156863}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.9882352941176471, 0.9725490196078431, 
       0.9607843137254902, 0.1843137254901961}, {0.9529411764705882, 
       0.9058823529411765, 0.8588235294117647, 0.7098039215686275}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.9882352941176471}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.996078431372549}, {0.9529411764705882, 0.9058823529411765, 
       0.8549019607843137, 0.7254901960784313}, {0.9882352941176471, 
       0.9725490196078431, 0.9607843137254902, 0.1843137254901961}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {0.9764705882352941, 0.9529411764705882, 
       0.9294117647058824, 0.3411764705882353}, {0.9372549019607843, 
       0.8705882352941177, 0.807843137254902, 0.9764705882352941}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.9647058823529412}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.6}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.3607843137254902}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.3411764705882353}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.5647058823529412}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.9450980392156862}, {0.9372549019607843, 
       0.8705882352941177, 0.807843137254902, 0.9725490196078431}, {
       0.9764705882352941, 0.9529411764705882, 0.9333333333333333, 
       0.33725490196078434`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.984313725490196, 
       0.9725490196078431, 0.9607843137254902, 0.19607843137254902`}, {
       0.9372549019607843, 0.8705882352941177, 0.807843137254902, 
       0.9764705882352941}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.8352941176470589}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.12156862745098039`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.10588235294117647`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.8117647058823529}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.9529411764705882, 0.9019607843137255, 0.8549019607843137, 
       0.7294117647058823}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.9607843137254902}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.10980392156862745`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9921568627450981, 0.9882352941176471, 0.984313725490196, 
       0.06274509803921569}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.996078431372549}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.5803921568627451}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.984313725490196, 
       0.9725490196078431, 0.9568627450980393, 0.21176470588235294`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.35294117647058826`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9607843137254902, 0.9215686274509803, 0.8823529411764706, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 0}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 0}, {1, 1, 
       1, 0}, {0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
        0}, {0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9686274509803922, 0.9411764705882353, 0.9137254901960784, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 0}, {
       0.9607843137254902, 0.9215686274509803, 0.8823529411764706, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9294117647058824, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.803921568627451}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.9882352941176471}, {
       0.9764705882352941, 0.9529411764705882, 0.9333333333333333, 
       0.33725490196078434`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.06666666666666667}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.8117647058823529}, {0.9372549019607843, 
       0.8705882352941177, 0.807843137254902, 0.9725490196078431}, {
       0.9882352941176471, 0.9725490196078431, 0.9607843137254902, 
       0.1843137254901961}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.10588235294117647`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.9450980392156862}, {0.9529411764705882, 
       0.9058823529411765, 0.8549019607843137, 0.7254901960784313}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.5647058823529412}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.996078431372549}, {0.9921568627450981, 
       0.9882352941176471, 0.984313725490196, 0.07450980392156863}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.3411764705882353}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.984313725490196, 0.9686274509803922, 0.9529411764705882, 
       0.22745098039215686`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.984313725490196, 0.9725490196078431, 0.9607843137254902, 0.2}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.3607843137254902}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.3607843137254902}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.984313725490196, 0.9686274509803922, 0.9568627450980393, 
       0.2196078431372549}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9921568627450981, 0.9882352941176471, 
       0.058823529411764705`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.984313725490196}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.5843137254901961}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0.6}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.9882352941176471}, {0.9921568627450981, 0.9882352941176471, 
       0.984313725490196, 0.06274509803921569}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9529411764705882, 
       0.9058823529411765, 0.8588235294117647, 0.7019607843137254}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.9568627450980393}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.11372549019607843`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.12156862745098039`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.9647058823529412}, {0.9529411764705882, 
       0.9058823529411765, 0.8588235294117647, 0.7098039215686275}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9882352941176471, 
       0.9764705882352941, 0.9647058823529412, 0.17647058823529413`}, {
       0.9372549019607843, 0.8745098039215686, 0.807843137254902, 
       0.9686274509803922}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.8196078431372549}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.11372549019607843`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 0}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.10980392156862745`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.8352941176470589}, {0.9372549019607843, 
       0.8705882352941177, 0.807843137254902, 0.9764705882352941}, {
       0.9882352941176471, 0.9725490196078431, 0.9607843137254902, 
       0.1843137254901961}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.9764705882352941, 0.9568627450980393, 
       0.9333333333333333, 0.3215686274509804}, {0.9372549019607843, 
       0.8745098039215686, 0.807843137254902, 0.9686274509803922}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.9568627450980393}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.5843137254901961}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.3607843137254902}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.30980392156862746`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.30980392156862746`}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.30980392156862746`}, {0.9372549019607843, 0.8705882352941177, 
       0.803921568627451, 0.35294117647058826`}, {0.9372549019607843, 
       0.8705882352941177, 0.803921568627451, 0.5803921568627451}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.9607843137254902}, {0.9372549019607843, 0.8705882352941177, 
       0.807843137254902, 0.9764705882352941}, {0.9764705882352941, 
       0.9529411764705882, 0.9294117647058824, 0.3411764705882353}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {0.9882352941176471, 0.9764705882352941, 
       0.9647058823529412, 0.17647058823529413`}, {0.9529411764705882, 
       0.9058823529411765, 0.8588235294117647, 0.7019607843137254}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.984313725490196}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 1}, {
       0.9372549019607843, 0.8705882352941177, 0.803921568627451, 
       0.996078431372549}, {0.9529411764705882, 0.9058823529411765, 
       0.8549019607843137, 0.7254901960784313}, {0.984313725490196, 
       0.9725490196078431, 0.9607843137254902, 0.19607843137254902`}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9921568627450981, 0.9882352941176471, 
       0.058823529411764705`}, {0.984313725490196, 0.9725490196078431, 
       0.9607843137254902, 0.2}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.9803921568627451, 
       0.9647058823529412, 0.9490196078431372, 0.25098039215686274`}, {
       0.9803921568627451, 0.9647058823529412, 0.9490196078431372, 
       0.25098039215686274`}, {0.9803921568627451, 0.9647058823529412, 
       0.9490196078431372, 0.25098039215686274`}, {0.984313725490196, 
       0.9725490196078431, 0.9568627450980393, 0.21176470588235294`}, {
       0.9921568627450981, 0.9882352941176471, 0.984313725490196, 
       0.06274509803921569}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}}}]], 
   RasterBox[
    NCache[{{{1, 1, 1, Rational[64, 85]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[84, 85], Rational[248, 255], Rational[82, 85], Rational[
        1, 17]}, {
       Rational[49, 51], Rational[233, 255], Rational[227, 255], Rational[
        1, 5]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[244, 255], Rational[232, 255], Rational[15, 17], Rational[
        18, 85]}, {
       Rational[251, 255], Rational[248, 255], Rational[82, 85], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[82, 85], Rational[236, 255], Rational[46, 51], Rational[
        3, 17]}, {
       Rational[73, 85], Rational[12, 17], Rational[158, 255], Rational[
        179, 255]}, {
       Rational[41, 51], Rational[10, 17], Rational[7, 15], Rational[
        251, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        254, 255]}, {
       Rational[218, 255], Rational[178, 255], Rational[154, 255], Rational[
        37, 51]}, {
       Rational[49, 51], Rational[78, 85], Rational[227, 255], Rational[
        10, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[14, 15], Rational[44, 51], Rational[14, 17], Rational[
        82, 255]}, {
       Rational[206, 255], Rational[152, 255], Rational[121, 255], Rational[
        247, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        244, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        149, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        92, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        6, 17]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        148, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        49, 51]}, {
       Rational[206, 255], Rational[151, 255], Rational[8, 17], Rational[
        83, 85]}, {
       Rational[79, 85], Rational[218, 255], Rational[69, 85], Rational[
        29, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[82, 85], Rational[236, 255], Rational[46, 51], Rational[
        3, 17]}, {
       Rational[206, 255], Rational[152, 255], Rational[121, 255], Rational[
        247, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        209, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        29, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        28, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        71, 85]}, {
       Rational[206, 255], Rational[151, 255], Rational[8, 17], Rational[
        83, 85]}, {
       Rational[49, 51], Rational[47, 51], Rational[229, 255], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[73, 85], Rational[12, 17], Rational[158, 255], Rational[
        179, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        244, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        29, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        31, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        82, 85]}, {
       Rational[73, 85], Rational[179, 255], Rational[157, 255], Rational[
        181, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[84, 85], Rational[248, 255], Rational[82, 85], Rational[
        1, 17]}, {
       Rational[41, 51], Rational[10, 17], Rational[7, 15], Rational[
        251, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        149, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        3, 5]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[251, 255], Rational[248, 255], Rational[82, 85], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[49, 51], Rational[233, 255], Rational[227, 255], Rational[
        1, 5]}, {Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        92, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        92, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[244, 255], Rational[77, 85], Rational[224, 255], Rational[
        56, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0},
        {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        29, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[81, 85], Rational[46, 51], Rational[223, 255], Rational[
        58, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        48, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        254, 255]}, {
       Rational[251, 255], Rational[247, 255], Rational[244, 255], Rational[
        19, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        9, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        241, 255]}, {
       Rational[218, 255], Rational[178, 255], Rational[154, 255], Rational[
        37, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        69, 85]}, {
       Rational[206, 255], Rational[151, 255], Rational[8, 17], Rational[
        248, 255]}, {
       Rational[49, 51], Rational[47, 51], Rational[229, 255], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[14, 15], Rational[73, 85], Rational[208, 255], Rational[
        86, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[233, 255], Rational[208, 255], Rational[194, 255], 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], 0}, {
       Rational[15, 17], Rational[191, 255], Rational[172, 255], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], 0}, {1, 1, 1, 
       0}, {Rational[79, 85], Rational[217, 255], Rational[206, 255], 0}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], 0}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], 0}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[15, 17], Rational[191, 255], Rational[172, 255], 0}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[242, 255], Rational[76, 85], Rational[44, 51], Rational[
        64, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        79, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[244, 255], Rational[232, 255], Rational[15, 17], Rational[
        18, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        6, 17]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[251, 255], Rational[248, 255], Rational[82, 85], Rational[
        16, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        254, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        148, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[218, 255], Rational[59, 85], Rational[154, 255], Rational[
        62, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        49, 51]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        28, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        1, 15]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        41, 51]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[49, 51], Rational[78, 85], Rational[227, 255], Rational[
        10, 51]}, {
       Rational[206, 255], Rational[151, 255], Rational[8, 17], Rational[
        83, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        71, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        31, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 0}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        9, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        69, 85]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[79, 85], Rational[217, 255], Rational[206, 255], Rational[
        6, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[79, 85], Rational[218, 255], Rational[69, 85], Rational[
        29, 85]}, {
       Rational[206, 255], Rational[151, 255], Rational[8, 17], Rational[
        83, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        82, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        3, 5]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        92, 255]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        29, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        48, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        241, 255]}, {
       Rational[206, 255], Rational[151, 255], Rational[8, 17], Rational[
        248, 255]}, {
       Rational[14, 15], Rational[73, 85], Rational[208, 255], Rational[
        86, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[49, 51], Rational[47, 51], Rational[229, 255], Rational[
        47, 255]}, {
       Rational[73, 85], Rational[179, 255], Rational[157, 255], Rational[
        181, 255]}, {
       Rational[41, 51], Rational[10, 17], Rational[118, 255], Rational[
        84, 85]}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], 1}, {
       Rational[41, 51], Rational[149, 255], Rational[39, 85], Rational[
        254, 255]}, {
       Rational[218, 255], Rational[178, 255], Rational[154, 255], Rational[
        37, 51]}, {
       Rational[49, 51], Rational[47, 51], Rational[229, 255], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[251, 255], Rational[248, 255], Rational[82, 85], Rational[
        16, 255]}, {
       Rational[244, 255], Rational[77, 85], Rational[224, 255], Rational[
        56, 255]}, {
       Rational[81, 85], Rational[46, 51], Rational[223, 255], Rational[
        58, 255]}, {
       Rational[251, 255], Rational[247, 255], Rational[244, 255], Rational[
        19, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 
      1}}}, {{{1, 1, 1, 0.7529411764705882}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9882352941176471, 
       0.9725490196078431, 0.9647058823529412, 0.058823529411764705`}, {
       0.9607843137254902, 0.9137254901960784, 0.8901960784313725, 0.2}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9490196078431372, 0.8941176470588236, 
       0.8627450980392157, 0.25098039215686274`}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {0.9568627450980393, 0.9098039215686274, 
       0.8823529411764706, 0.21176470588235294`}, {0.984313725490196, 
       0.9725490196078431, 0.9647058823529412, 0.06274509803921569}, {1, 1, 1,
        0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.9647058823529412, 0.9254901960784314, 0.9019607843137255, 
       0.17647058823529413`}, {0.8588235294117647, 0.7058823529411765, 
       0.6196078431372549, 0.7019607843137254}, {0.803921568627451, 
       0.5882352941176471, 0.4666666666666667, 0.984313725490196}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.996078431372549}, {0.8549019607843137, 0.6980392156862745, 
       0.6039215686274509, 0.7254901960784313}, {0.9607843137254902, 
       0.9176470588235294, 0.8901960784313725, 0.19607843137254902`}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.9333333333333333, 0.8627450980392157, 
       0.8235294117647058, 0.3215686274509804}, {0.807843137254902, 
       0.596078431372549, 0.4745098039215686, 0.9686274509803922}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.9568627450980393}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.5843137254901961}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.3607843137254902}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.30980392156862746`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.35294117647058826`}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.5803921568627451}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.9607843137254902}, {0.807843137254902, 0.592156862745098, 
       0.47058823529411764`, 0.9764705882352941}, {0.9294117647058824, 
       0.8549019607843137, 0.8117647058823529, 0.3411764705882353}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9647058823529412, 0.9254901960784314, 0.9019607843137255, 
       0.17647058823529413`}, {0.807843137254902, 0.596078431372549, 
       0.4745098039215686, 0.9686274509803922}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.8196078431372549}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.11372549019607843`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.10980392156862745`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.8352941176470589}, {0.807843137254902, 
       0.592156862745098, 0.47058823529411764`, 0.9764705882352941}, {
       0.9607843137254902, 0.9215686274509803, 0.8980392156862745, 
       0.1843137254901961}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8588235294117647, 0.7058823529411765, 0.6196078431372549, 
       0.7019607843137254}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.9568627450980393}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.11372549019607843`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.12156862745098039`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.9647058823529412}, {0.8588235294117647, 
       0.7019607843137254, 0.615686274509804, 0.7098039215686275}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9882352941176471, 
       0.9725490196078431, 0.9647058823529412, 0.058823529411764705`}, {
       0.803921568627451, 0.5882352941176471, 0.4666666666666667, 
       0.984313725490196}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.5843137254901961}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0.6}, {
       0.803921568627451, 0.5882352941176471, 0.4627450980392157, 
       0.9882352941176471}, {0.984313725490196, 0.9725490196078431, 
       0.9647058823529412, 0.06274509803921569}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9607843137254902, 
       0.9137254901960784, 0.8901960784313725, 0.2}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.3607843137254902}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.3607843137254902}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.9568627450980393, 0.9058823529411765, 0.8784313725490196, 
       0.2196078431372549}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.3411764705882353}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.9529411764705882, 0.9019607843137255, 0.8745098039215686, 
       0.22745098039215686`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.5647058823529412}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.996078431372549}, {0.984313725490196, 
       0.9686274509803922, 0.9568627450980393, 0.07450980392156863}, {1, 1, 1,
        0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.10588235294117647`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.9450980392156862}, {0.8549019607843137, 
       0.6980392156862745, 0.6039215686274509, 0.7254901960784313}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.8117647058823529}, {0.807843137254902, 
       0.592156862745098, 0.47058823529411764`, 0.9725490196078431}, {
       0.9607843137254902, 0.9215686274509803, 0.8980392156862745, 
       0.1843137254901961}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9333333333333333, 0.8588235294117647, 0.8156862745098039, 
       0.33725490196078434`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.9137254901960784, 0.8156862745098039, 0.7607843137254902, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 0}, {
       0.8823529411764706, 0.7490196078431373, 0.6745098039215687, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 0}, {1, 1, 
       1, 0}, {0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
        0}, {0.803921568627451, 0.5882352941176471, 0.4627450980392157, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 0}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 0}, {
       0.803921568627451, 0.5882352941176471, 0.4627450980392157, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.8823529411764706, 0.7490196078431373, 0.6745098039215687, 0}, {
       0.803921568627451, 0.5882352941176471, 0.4627450980392157, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9490196078431372, 
       0.8941176470588236, 0.8627450980392157, 0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9490196078431372, 0.8941176470588236, 0.8627450980392157, 
       0.25098039215686274`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.30980392156862746`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9568627450980393, 
       0.9098039215686274, 0.8823529411764706, 0.21176470588235294`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.35294117647058826`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.984313725490196, 0.9725490196078431,
        0.9647058823529412, 0.06274509803921569}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.996078431372549}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.5803921568627451}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8549019607843137, 0.6941176470588235, 0.6039215686274509, 
       0.7294117647058823}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.9607843137254902}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.10980392156862745`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.06666666666666667}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.803921568627451}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9607843137254902, 0.9176470588235294, 0.8901960784313725, 
       0.19607843137254902`}, {0.807843137254902, 0.592156862745098, 
       0.47058823529411764`, 0.9764705882352941}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.8352941176470589}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.12156862745098039`}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 0}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.10588235294117647`}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.8117647058823529}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.9294117647058824, 0.8509803921568627, 0.807843137254902, 
       0.35294117647058826`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.9294117647058824, 0.8549019607843137, 
       0.8117647058823529, 0.3411764705882353}, {0.807843137254902, 
       0.592156862745098, 0.47058823529411764`, 0.9764705882352941}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.9647058823529412}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.6}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.3607843137254902}, {0.803921568627451, 
       0.5843137254901961, 0.4588235294117647, 0.3411764705882353}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.5647058823529412}, {0.803921568627451, 0.5843137254901961, 
       0.4588235294117647, 0.9450980392156862}, {0.807843137254902, 
       0.592156862745098, 0.47058823529411764`, 0.9725490196078431}, {
       0.9333333333333333, 0.8588235294117647, 0.8156862745098039, 
       0.33725490196078434`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.9607843137254902, 0.9215686274509803, 0.8980392156862745, 
       0.1843137254901961}, {0.8588235294117647, 0.7019607843137254, 
       0.615686274509804, 0.7098039215686275}, {0.803921568627451, 
       0.5882352941176471, 0.4627450980392157, 0.9882352941176471}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 1}, {
       0.803921568627451, 0.5843137254901961, 0.4588235294117647, 
       0.996078431372549}, {0.8549019607843137, 0.6980392156862745, 
       0.6039215686274509, 0.7254901960784313}, {0.9607843137254902, 
       0.9215686274509803, 0.8980392156862745, 0.1843137254901961}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.984313725490196, 0.9725490196078431, 0.9647058823529412, 
       0.06274509803921569}, {0.9568627450980393, 0.9058823529411765, 
       0.8784313725490196, 0.2196078431372549}, {0.9529411764705882, 
       0.9019607843137255, 0.8745098039215686, 0.22745098039215686`}, {
       0.984313725490196, 0.9686274509803922, 0.9568627450980393, 
       0.07450980392156863}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1,
       1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 
      1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}}}]], 
   RasterBox[
    NCache[{{{1, 1, 1, Rational[64, 85]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[84, 85], Rational[83, 85], Rational[
        19, 255]}, {
       Rational[254, 255], Rational[82, 85], Rational[14, 15], Rational[
        58, 255]}, {
       Rational[254, 255], Rational[82, 85], Rational[14, 15], Rational[
        56, 255]}, {
       Rational[254, 255], Rational[84, 85], Rational[50, 51], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[247, 255], Rational[241, 255], Rational[
        47, 255]}, {
       Rational[253, 255], Rational[227, 255], Rational[67, 85], Rational[
        37, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        254, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[76, 85], Rational[202, 255], Rational[
        181, 255]}, {
       Rational[254, 255], Rational[247, 255], Rational[241, 255], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[242, 255], Rational[46, 51], Rational[
        86, 255]}, {
       Rational[253, 255], Rational[218, 255], Rational[61, 85], Rational[
        248, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        241, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        48, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        29, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        92, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        3, 5]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        82, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[182, 255], Rational[
        83, 85]}, {
       Rational[254, 255], Rational[242, 255], Rational[229, 255], Rational[
        29, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        69, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        9, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        31, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        71, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[182, 255], Rational[
        83, 85]}, {
       Rational[254, 255], Rational[247, 255], Rational[16, 17], Rational[
        10, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        28, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        49, 51]}, {
       Rational[253, 255], Rational[227, 255], Rational[67, 85], Rational[
        37, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        148, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        254, 255]}, {
       Rational[254, 255], Rational[84, 85], Rational[50, 51], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[82, 85], Rational[239, 255], Rational[
        18, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[254, 255], Rational[241, 255], Rational[76, 85], 
        Rational[6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[254, 255], Rational[241, 255], Rational[76, 85], 
        Rational[6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[254, 255], Rational[241, 255], Rational[76, 85], 
        Rational[6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[254, 255], Rational[241, 255], Rational[76, 85], 
        Rational[6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[232, 255], Rational[14, 17], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], 0}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], 0}, {1, 1, 1,
        0}, {Rational[254, 255], Rational[49, 51], Rational[236, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[232, 255], Rational[14, 17], 0}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], 0}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], 0}, {
       Rational[254, 255], Rational[14, 15], Rational[74, 85], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[241, 255], Rational[76, 85], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[254, 255], Rational[242, 255], Rational[46, 51], 
        Rational[86, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        41, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[247, 255], Rational[241, 255], Rational[
        47, 255]}, {
       Rational[253, 255], Rational[218, 255], Rational[61, 85], Rational[
        248, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        69, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        1, 15]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[253, 255], Rational[227, 255], Rational[67, 85], Rational[
        37, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        241, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        9, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[84, 85], Rational[83, 85], Rational[
        19, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        254, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        48, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[82, 85], Rational[14, 15], Rational[
        58, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        29, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[82, 85], Rational[14, 15], Rational[
        56, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        92, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        31, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[254, 255], Rational[247, 255], Rational[16, 17], Rational[
        10, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[84, 85], Rational[50, 51], Rational[
        16, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        84, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        3, 5]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        149, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[182, 255], Rational[
        251, 255]}, {
       Rational[254, 255], Rational[84, 85], Rational[50, 51], Rational[
        1, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[253, 255], Rational[76, 85], Rational[202, 255], Rational[
        181, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        82, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        31, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        29, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        244, 255]}, {
       Rational[253, 255], Rational[76, 85], Rational[203, 255], Rational[
        179, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[254, 255], Rational[247, 255], Rational[241, 255], 
        Rational[47, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[182, 255], Rational[
        83, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        71, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        28, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 0}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        29, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        209, 255]}, {
       Rational[253, 255], Rational[218, 255], Rational[61, 85], Rational[
        247, 255]}, {
       Rational[254, 255], Rational[248, 255], Rational[241, 255], Rational[
        3, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[242, 255], Rational[229, 255], Rational[
        29, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[182, 255], Rational[
        83, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        49, 51]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        148, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        6, 17]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        79, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        92, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        149, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        244, 255]}, {
       Rational[253, 255], Rational[218, 255], Rational[61, 85], Rational[
        247, 255]}, {
       Rational[254, 255], Rational[242, 255], Rational[77, 85], Rational[
        82, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[254, 255], Rational[247, 255], Rational[16, 17], 
        Rational[10, 51]}, {
       Rational[253, 255], Rational[227, 255], Rational[67, 85], Rational[
        62, 85]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], Rational[
        254, 255]}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[181, 255], 1}, {
       Rational[253, 255], Rational[217, 255], Rational[182, 255], Rational[
        251, 255]}, {
       Rational[253, 255], Rational[76, 85], Rational[203, 255], Rational[
        179, 255]}, {
       Rational[254, 255], Rational[248, 255], Rational[241, 255], Rational[
        3, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[254, 255], Rational[84, 85], Rational[50, 51], Rational[
        16, 255]}, {
       Rational[254, 255], Rational[82, 85], Rational[239, 255], Rational[
        18, 85]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[49, 51], Rational[236, 255], Rational[
        64, 255]}, {
       Rational[254, 255], Rational[247, 255], Rational[16, 17], Rational[
        1, 5]}, {
       Rational[254, 255], Rational[84, 85], Rational[50, 51], Rational[
        1, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1,
       1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 
      1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1,
       1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 
      1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}}}, {{{1, 1, 1, 0.7529411764705882}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9882352941176471, 0.9764705882352941, 
       0.07450980392156863}, {0.996078431372549, 0.9647058823529412, 
       0.9333333333333333, 0.22745098039215686`}, {0.996078431372549, 
       0.9647058823529412, 0.9333333333333333, 0.2196078431372549}, {
       0.996078431372549, 0.9882352941176471, 0.9803921568627451, 
       0.06274509803921569}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9686274509803922, 
       0.9450980392156862, 0.1843137254901961}, {0.9921568627450981, 
       0.8901960784313725, 0.788235294117647, 0.7254901960784313}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.996078431372549}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9882352941176471}, {0.9921568627450981, 0.8941176470588236, 
       0.792156862745098, 0.7098039215686275}, {0.996078431372549, 
       0.9686274509803922, 0.9450980392156862, 0.1843137254901961}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9490196078431372, 
       0.9019607843137255, 0.33725490196078434`}, {0.9921568627450981, 
       0.8549019607843137, 0.7176470588235294, 0.9725490196078431}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9450980392156862}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.5647058823529412}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.3411764705882353}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.3607843137254902}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.6}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9647058823529412}, {0.9921568627450981, 
       0.8509803921568627, 0.7137254901960784, 0.9764705882352941}, {
       0.996078431372549, 0.9490196078431372, 0.8980392156862745, 
       0.3411764705882353}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 
       0.9450980392156862, 0.8941176470588236, 0.35294117647058826`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9882352941176471}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.8117647058823529}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.10588235294117647`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.12156862745098039`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.8352941176470589}, {0.9921568627450981, 
       0.8509803921568627, 0.7137254901960784, 0.9764705882352941}, {
       0.996078431372549, 0.9686274509803922, 0.9411764705882353, 
       0.19607843137254902`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.10980392156862745`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9607843137254902}, {0.9921568627450981, 
       0.8901960784313725, 0.788235294117647, 0.7254901960784313}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.5803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.996078431372549}, {0.996078431372549, 
       0.9882352941176471, 0.9803921568627451, 0.06274509803921569}, {1, 1, 1,
        0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.35294117647058826`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9647058823529412, 0.9372549019607843, 
       0.21176470588235294`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 
       0.9450980392156862, 0.8941176470588236, 0.35294117647058826`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9882352941176471}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.803921568627451}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 
       0.9450980392156862, 0.8941176470588236, 0.35294117647058826`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9882352941176471}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.803921568627451}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 
       0.9450980392156862, 0.8941176470588236, 0.35294117647058826`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9882352941176471}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.803921568627451}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.9098039215686274, 0.8235294117647058, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 0}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 
       0.35294117647058826`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.803921568627451}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.996078431372549, 0.9450980392156862, 0.8941176470588236, 0}, {1, 1, 
       1, 0}, {0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
        0}, {0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 
       0.9450980392156862, 0.8941176470588236, 0.35294117647058826`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9882352941176471}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.803921568627451}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.9098039215686274, 0.8235294117647058, 0}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 0}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 0}, {
       0.996078431372549, 0.9333333333333333, 0.8705882352941177, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9450980392156862, 
       0.8941176470588236, 0.35294117647058826`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.996078431372549, 0.9490196078431372, 
       0.9019607843137255, 0.33725490196078434`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.9882352941176471}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.803921568627451}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9686274509803922, 0.9450980392156862, 
       0.1843137254901961}, {0.9921568627450981, 0.8549019607843137, 
       0.7176470588235294, 0.9725490196078431}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.8117647058823529}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.06666666666666667}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9921568627450981, 0.8901960784313725, 0.788235294117647, 
       0.7254901960784313}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9450980392156862}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.10588235294117647`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9882352941176471, 0.9764705882352941, 
       0.07450980392156863}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.996078431372549}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.5647058823529412}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9647058823529412, 0.9333333333333333, 
       0.22745098039215686`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.3411764705882353}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9647058823529412, 0.9333333333333333, 
       0.2196078431372549}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.3607843137254902}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.36470588235294116`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.996078431372549, 0.9686274509803922, 0.9411764705882353, 
       0.19607843137254902`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9882352941176471, 0.9803921568627451, 
       0.06274509803921569}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9882352941176471}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.6}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.5843137254901961}, {0.9921568627450981, 0.8509803921568627, 
       0.7137254901960784, 0.984313725490196}, {0.996078431372549, 
       0.9882352941176471, 0.9803921568627451, 0.058823529411764705`}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9921568627450981, 
       0.8941176470588236, 0.792156862745098, 0.7098039215686275}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9647058823529412}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.12156862745098039`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.11372549019607843`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.9568627450980393}, {0.9921568627450981, 
       0.8941176470588236, 0.796078431372549, 0.7019607843137254}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 
       0.9686274509803922, 0.9450980392156862, 0.1843137254901961}, {
       0.9921568627450981, 0.8509803921568627, 0.7137254901960784, 
       0.9764705882352941}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.8352941176470589}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.10980392156862745`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 0}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.11372549019607843`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.8196078431372549}, {0.9921568627450981, 
       0.8549019607843137, 0.7176470588235294, 0.9686274509803922}, {
       0.996078431372549, 0.9725490196078431, 0.9450980392156862, 
       0.17647058823529413`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9490196078431372, 
       0.8980392156862745, 0.3411764705882353}, {0.9921568627450981, 
       0.8509803921568627, 0.7137254901960784, 0.9764705882352941}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9607843137254902}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.5803921568627451}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.35294117647058826`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.30980392156862746`}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.30980392156862746`}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.30980392156862746`}, {0.9921568627450981, 0.8509803921568627, 
       0.7098039215686275, 0.3607843137254902}, {0.9921568627450981, 
       0.8509803921568627, 0.7098039215686275, 0.5843137254901961}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.9568627450980393}, {0.9921568627450981, 0.8549019607843137, 
       0.7176470588235294, 0.9686274509803922}, {0.996078431372549, 
       0.9490196078431372, 0.9058823529411765, 0.3215686274509804}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {0.996078431372549, 0.9686274509803922, 
       0.9411764705882353, 0.19607843137254902`}, {0.9921568627450981, 
       0.8901960784313725, 0.788235294117647, 0.7294117647058823}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 
       0.996078431372549}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7098039215686275, 1}, {
       0.9921568627450981, 0.8509803921568627, 0.7137254901960784, 
       0.984313725490196}, {0.9921568627450981, 0.8941176470588236, 
       0.796078431372549, 0.7019607843137254}, {0.996078431372549, 
       0.9725490196078431, 0.9450980392156862, 0.17647058823529413`}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.996078431372549, 0.9882352941176471, 0.9803921568627451, 
       0.06274509803921569}, {0.996078431372549, 0.9647058823529412, 
       0.9372549019607843, 0.21176470588235294`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9607843137254902, 0.9254901960784314, 
       0.25098039215686274`}, {0.996078431372549, 0.9607843137254902, 
       0.9254901960784314, 0.25098039215686274`}, {0.996078431372549, 
       0.9607843137254902, 0.9254901960784314, 0.25098039215686274`}, {
       0.996078431372549, 0.9686274509803922, 0.9411764705882353, 0.2}, {
       0.996078431372549, 0.9882352941176471, 0.9803921568627451, 
       0.058823529411764705`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}}}]], 
   RasterBox[
    NCache[{{{1, 1, 1, Rational[64, 85]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[82, 85], Rational[84, 85], Rational[253, 255], Rational[
        16, 255]}, {
       Rational[226, 255], Rational[247, 255], Rational[248, 255], Rational[
        18, 85]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {
       Rational[76, 85], Rational[247, 255], Rational[83, 85], Rational[
        1, 5]}, {
       Rational[247, 255], Rational[84, 85], Rational[253, 255], Rational[
        1, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[76, 85], Rational[247, 255], Rational[83, 85], Rational[
        10, 51]}, {
       Rational[157, 255], Rational[76, 85], Rational[233, 255], Rational[
        37, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        254, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[122, 255], Rational[73, 85], Rational[226, 255], Rational[
        251, 255]}, {
       Rational[32, 51], Rational[229, 255], Rational[78, 85], Rational[
        179, 255]}, {
       Rational[77, 85], Rational[248, 255], Rational[83, 85], Rational[
        3, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[208, 255], Rational[242, 255], Rational[49, 51], Rational[
        29, 85]}, {
       Rational[41, 85], Rational[73, 85], Rational[226, 255], Rational[
        83, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        49, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        148, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        6, 17]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        92, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        149, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        244, 255]}, {
       Rational[124, 255], Rational[44, 51], Rational[226, 255], Rational[
        247, 255]}, {
       Rational[211, 255], Rational[81, 85], Rational[49, 51], Rational[
        82, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[46, 51], Rational[248, 255], Rational[83, 85], Rational[
        47, 255]}, {
       Rational[122, 255], Rational[73, 85], Rational[226, 255], Rational[
        50, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        71, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        28, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        29, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        209, 255]}, {
       Rational[124, 255], Rational[44, 51], Rational[226, 255], Rational[
        247, 255]}, {
       Rational[77, 85], Rational[248, 255], Rational[83, 85], Rational[
        3, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[53, 85], Rational[229, 255], Rational[78, 85], Rational[
        181, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        82, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        2, 17]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        29, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        244, 255]}, {
       Rational[32, 51], Rational[229, 255], Rational[78, 85], Rational[
        179, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[82, 85], Rational[84, 85], Rational[253, 255], Rational[
        16, 255]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        3, 5]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        149, 255]}, {
       Rational[122, 255], Rational[73, 85], Rational[226, 255], Rational[
        251, 255]}, {
       Rational[247, 255], Rational[84, 85], Rational[253, 255], Rational[
        1, 17]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[15, 17], Rational[247, 255], Rational[248, 255], Rational[
        56, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        92, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        92, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[76, 85], Rational[247, 255], Rational[83, 85], Rational[
        1, 5]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[82, 85], Rational[248, 255], Rational[
        58, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        29, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[244, 255], Rational[84, 85], Rational[84, 85], Rational[
        19, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        254, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        48, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[157, 255], Rational[76, 85], Rational[233, 255], Rational[
        37, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        241, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        9, 85]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[46, 51], Rational[248, 255], Rational[83, 85], Rational[
        47, 255]}, {
       Rational[41, 85], Rational[73, 85], Rational[226, 255], Rational[
        248, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        69, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[209, 255], Rational[242, 255], Rational[49, 51], 
        Rational[86, 255]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[58, 85], Rational[233, 255], Rational[79, 85], 0}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], 0}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], 0}, {
       Rational[13, 17], Rational[239, 255], Rational[242, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], 0}, {1, 1, 1,
        0}, {Rational[13, 15], Rational[49, 51], Rational[247, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], 0}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[69, 85], Rational[242, 255], Rational[244, 255], 
        Rational[6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[58, 85], Rational[233, 255], Rational[79, 85], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[69, 85], Rational[242, 255], Rational[244, 255], 
        Rational[6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[69, 85], Rational[242, 255], Rational[244, 255], 
        Rational[6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[69, 85], Rational[242, 255], Rational[244, 255], 
        Rational[6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        79, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[13, 15], Rational[49, 51], Rational[247, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        6, 17]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[226, 255], Rational[247, 255], Rational[248, 255], Rational[
        18, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        148, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        254, 255]}, {
       Rational[82, 85], Rational[84, 85], Rational[253, 255], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[69, 85], Rational[242, 255], Rational[244, 255], Rational[
        6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        41, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        1, 15]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        28, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        49, 51]}, {
       Rational[157, 255], Rational[76, 85], Rational[233, 255], Rational[
        37, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[69, 85], Rational[242, 255], Rational[244, 255], 
        Rational[6, 17]}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        69, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        9, 85]}, {Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 0}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        31, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        71, 85]}, {
       Rational[41, 85], Rational[73, 85], Rational[226, 255], Rational[
        83, 85]}, {
       Rational[76, 85], Rational[247, 255], Rational[83, 85], Rational[
        10, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[209, 255], Rational[242, 255], Rational[49, 51], Rational[
        86, 255]}, {
       Rational[41, 85], Rational[73, 85], Rational[226, 255], Rational[
        248, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        241, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        48, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        29, 85]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        92, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        3, 5]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        82, 85]}, {
       Rational[41, 85], Rational[73, 85], Rational[226, 255], Rational[
        83, 85]}, {
       Rational[208, 255], Rational[242, 255], Rational[49, 51], Rational[
        29, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[46, 51], Rational[248, 255], Rational[83, 85], Rational[
        47, 255]}, {
       Rational[157, 255], Rational[76, 85], Rational[233, 255], Rational[
        37, 51]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], Rational[
        254, 255]}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[8, 17], Rational[73, 85], Rational[226, 255], 1}, {
       Rational[121, 255], Rational[73, 85], Rational[226, 255], Rational[
        84, 85]}, {
       Rational[53, 85], Rational[229, 255], Rational[78, 85], Rational[
        181, 255]}, {
       Rational[46, 51], Rational[248, 255], Rational[83, 85], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[244, 255], Rational[84, 85], Rational[84, 85], Rational[
        19, 255]}, {
       Rational[224, 255], Rational[82, 85], Rational[248, 255], Rational[
        58, 255]}, {
       Rational[15, 17], Rational[247, 255], Rational[248, 255], Rational[
        56, 255]}, {
       Rational[82, 85], Rational[84, 85], Rational[253, 255], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 
      1}}}, {{{1, 1, 1, 0.7529411764705882}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9647058823529412, 
       0.9882352941176471, 0.9921568627450981, 0.06274509803921569}, {
       0.8862745098039215, 0.9686274509803922, 0.9725490196078431, 
       0.21176470588235294`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8666666666666667, 
       0.9607843137254902, 0.9686274509803922, 0.25098039215686274`}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {0.8666666666666667, 0.9607843137254902, 
       0.9686274509803922, 0.25098039215686274`}, {0.8941176470588236, 
       0.9686274509803922, 0.9764705882352941, 0.2}, {0.9686274509803922, 
       0.9882352941176471, 0.9921568627450981, 0.058823529411764705`}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.8941176470588236, 0.9686274509803922, 0.9764705882352941, 
       0.19607843137254902`}, {0.615686274509804, 0.8941176470588236, 
       0.9137254901960784, 0.7254901960784313}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.996078431372549}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47843137254901963`, 0.8588235294117647, 0.8862745098039215, 
       0.984313725490196}, {0.6274509803921569, 0.8980392156862745, 
       0.9176470588235294, 0.7019607843137254}, {0.9058823529411765, 
       0.9725490196078431, 0.9764705882352941, 0.17647058823529413`}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8156862745098039, 0.9490196078431372, 
       0.9607843137254902, 0.3411764705882353}, {0.4823529411764706, 
       0.8588235294117647, 0.8862745098039215, 0.9764705882352941}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.9607843137254902}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.5803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.35294117647058826`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.30980392156862746`}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.3607843137254902}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.5843137254901961}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.9568627450980393}, {0.48627450980392156`, 0.8627450980392157, 
       0.8862745098039215, 0.9686274509803922}, {0.8274509803921568, 
       0.9529411764705882, 0.9607843137254902, 0.3215686274509804}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9019607843137255, 0.9725490196078431, 0.9764705882352941, 
       0.1843137254901961}, {0.47843137254901963`, 0.8588235294117647, 
       0.8862745098039215, 0.9803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.8352941176470589}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.10980392156862745`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.11372549019607843`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.8196078431372549}, {0.48627450980392156`, 
       0.8627450980392157, 0.8862745098039215, 0.9686274509803922}, {
       0.9058823529411765, 0.9725490196078431, 0.9764705882352941, 
       0.17647058823529413`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.6235294117647059, 0.8980392156862745, 
       0.9176470588235294, 0.7098039215686275}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.9647058823529412}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.11764705882352941`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.11372549019607843`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.9568627450980393}, {0.6274509803921569, 
       0.8980392156862745, 0.9176470588235294, 0.7019607843137254}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9647058823529412, 
       0.9882352941176471, 0.9921568627450981, 0.06274509803921569}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.6}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.5843137254901961}, {0.47843137254901963`, 0.8588235294117647, 
       0.8862745098039215, 0.984313725490196}, {0.9686274509803922, 
       0.9882352941176471, 0.9921568627450981, 0.058823529411764705`}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8823529411764706, 
       0.9686274509803922, 0.9725490196078431, 0.2196078431372549}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.3607843137254902}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.3607843137254902}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8941176470588236, 0.9686274509803922, 0.9764705882352941, 0.2}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8784313725490196, 
       0.9647058823529412, 0.9725490196078431, 0.22745098039215686`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.3411764705882353}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9568627450980393, 0.9882352941176471, 0.9882352941176471, 
       0.07450980392156863}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.996078431372549}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.5647058823529412}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.615686274509804, 0.8941176470588236, 0.9137254901960784, 
       0.7254901960784313}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.9450980392156862}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.10588235294117647`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9019607843137255, 0.9725490196078431, 0.9764705882352941, 
       0.1843137254901961}, {0.4823529411764706, 0.8588235294117647, 
       0.8862745098039215, 0.9725490196078431}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.8117647058823529}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.8196078431372549, 0.9490196078431372, 
       0.9607843137254902, 0.33725490196078434`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 
       0.9490196078431372, 0.9568627450980393, 0.35294117647058826`}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.6823529411764706, 0.9137254901960784, 0.9294117647058824, 0}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 0}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 0}, {
       0.7647058823529411, 0.9372549019607843, 0.9490196078431372, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 0}, {1, 1, 
       1, 0}, {0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
        0}, {0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
        0}, {0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
        0}, {0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
        0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 0}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.6823529411764706, 0.9137254901960784, 0.9294117647058824, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 
       0.9490196078431372, 0.9568627450980393, 0.35294117647058826`}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 
       0.9490196078431372, 0.9568627450980393, 0.35294117647058826`}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 
       0.9490196078431372, 0.9568627450980393, 0.35294117647058826`}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8117647058823529, 0.9490196078431372, 0.9568627450980393, 
       0.35294117647058826`}, {0.4745098039215686, 0.8588235294117647, 
       0.8862745098039215, 0.9882352941176471}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.803921568627451}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.30980392156862746`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8666666666666667, 0.9607843137254902, 0.9686274509803922, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 0.9490196078431372, 
       0.9568627450980393, 0.35294117647058826`}, {0.4745098039215686, 
       0.8588235294117647, 0.8862745098039215, 0.9882352941176471}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.35294117647058826`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.8862745098039215, 0.9686274509803922, 0.9725490196078431, 
       0.21176470588235294`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 
       0.9490196078431372, 0.9568627450980393, 0.35294117647058826`}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.5803921568627451}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.996078431372549}, {0.9647058823529412, 
       0.9882352941176471, 0.9921568627450981, 0.06274509803921569}, {1, 1, 1,
        0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 
       0.9490196078431372, 0.9568627450980393, 0.35294117647058826`}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.803921568627451}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.06666666666666667}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.10980392156862745`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.9607843137254902}, {0.615686274509804, 
       0.8941176470588236, 0.9137254901960784, 0.7254901960784313}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8117647058823529, 
       0.9490196078431372, 0.9568627450980393, 0.35294117647058826`}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.8117647058823529}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.10588235294117647`}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 0}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.12156862745098039`}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.8352941176470589}, {0.4823529411764706, 
       0.8588235294117647, 0.8862745098039215, 0.9764705882352941}, {
       0.8941176470588236, 0.9686274509803922, 0.9764705882352941, 
       0.19607843137254902`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       1, 1, 1, 0}, {1, 1, 1, 0}, {0.8196078431372549, 0.9490196078431372, 
       0.9607843137254902, 0.33725490196078434`}, {0.4823529411764706, 
       0.8588235294117647, 0.8862745098039215, 0.9725490196078431}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.9450980392156862}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.5647058823529412}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.3411764705882353}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 
       0.3607843137254902}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.6}, {0.47058823529411764`, 0.8588235294117647, 
       0.8862745098039215, 0.9647058823529412}, {0.4823529411764706, 
       0.8588235294117647, 0.8862745098039215, 0.9764705882352941}, {
       0.8156862745098039, 0.9490196078431372, 0.9607843137254902, 
       0.3411764705882353}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.9019607843137255, 0.9725490196078431, 0.9764705882352941, 
       0.1843137254901961}, {0.615686274509804, 0.8941176470588236, 
       0.9137254901960784, 0.7254901960784313}, {0.47058823529411764`, 
       0.8588235294117647, 0.8862745098039215, 0.996078431372549}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.47058823529411764`, 0.8588235294117647, 0.8862745098039215, 1}, {
       0.4745098039215686, 0.8588235294117647, 0.8862745098039215, 
       0.9882352941176471}, {0.6235294117647059, 0.8980392156862745, 
       0.9176470588235294, 0.7098039215686275}, {0.9019607843137255, 
       0.9725490196078431, 0.9764705882352941, 0.1843137254901961}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9568627450980393, 0.9882352941176471, 0.9882352941176471, 
       0.07450980392156863}, {0.8784313725490196, 0.9647058823529412, 
       0.9725490196078431, 0.22745098039215686`}, {0.8823529411764706, 
       0.9686274509803922, 0.9725490196078431, 0.2196078431372549}, {
       0.9647058823529412, 0.9882352941176471, 0.9921568627450981, 
       0.06274509803921569}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1,
       1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 
      1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}}}]], 
   RasterBox[
    NCache[{{{1, 1, 1, Rational[64, 85]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, Rational[128, 255]}, {
       1, 1, 1, Rational[128, 255]}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[82, 85], Rational[248, 255], Rational[81, 85], Rational[
        19, 255]}, {
       Rational[227, 255], Rational[47, 51], Rational[13, 15], Rational[
        58, 255]}, {
       Rational[76, 85], Rational[236, 255], Rational[74, 85], Rational[
        56, 255]}, {
       Rational[247, 255], Rational[83, 85], Rational[49, 51], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[232, 255], Rational[239, 255], Rational[227, 255], Rational[
        47, 255]}, {
       Rational[167, 255], Rational[64, 85], Rational[49, 85], Rational[
        37, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        254, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[169, 255], Rational[193, 255], Rational[149, 255], Rational[
        181, 255]}, {
       Rational[232, 255], Rational[239, 255], Rational[227, 255], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[214, 255], Rational[15, 17], Rational[41, 51], Rational[
        86, 255]}, {
       Rational[46, 85], Rational[57, 85], Rational[37, 85], Rational[
        248, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        241, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        48, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        29, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        92, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        3, 5]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        82, 85]}, {
       Rational[137, 255], Rational[57, 85], Rational[22, 51], Rational[
        83, 85]}, {
       Rational[214, 255], Rational[15, 17], Rational[4, 5], Rational[
        29, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        69, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        9, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        31, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        71, 85]}, {
       Rational[137, 255], Rational[57, 85], Rational[22, 51], Rational[
        83, 85]}, {
       Rational[77, 85], Rational[14, 15], Rational[15, 17], Rational[
        10, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        28, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        49, 51]}, {
       Rational[167, 255], Rational[64, 85], Rational[49, 85], Rational[
        37, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        148, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        254, 255]}, {
       Rational[247, 255], Rational[83, 85], Rational[49, 51], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        6, 17]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[229, 255], Rational[236, 255], Rational[223, 255], Rational[
        18, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[61, 85], Rational[203, 255], Rational[166, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {Rational[224, 255], Rational[233, 255], Rational[217, 255], 
        0}, {Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[214, 255], Rational[15, 17], Rational[41, 51], Rational[
        86, 255]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[233, 255], Rational[239, 255], Rational[76, 85], Rational[
        3, 17]}, {
       Rational[46, 85], Rational[57, 85], Rational[37, 85], Rational[
        247, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        69, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[2, 3], Rational[194, 255], Rational[151, 255], Rational[
        179, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        244, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        29, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {Rational[224, 255], Rational[233, 255], Rational[217, 255], 
        0}, {Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[247, 255], Rational[83, 85], Rational[82, 85], Rational[
        1, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[109, 255], Rational[
        251, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        149, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[77, 85], Rational[79, 85], Rational[15, 17], Rational[
        1, 5]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        92, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[77, 85], Rational[79, 85], Rational[15, 17], Rational[
        1, 5]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        92, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[247, 255], Rational[83, 85], Rational[82, 85], Rational[
        1, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[109, 255], Rational[
        251, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        149, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[2, 3], Rational[194, 255], Rational[151, 255], Rational[
        179, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        244, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        29, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[233, 255], Rational[239, 255], Rational[76, 85], Rational[
        3, 17]}, {
       Rational[46, 85], Rational[57, 85], Rational[37, 85], Rational[
        247, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        69, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[214, 255], Rational[15, 17], Rational[41, 51], Rational[
        86, 255]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {1, 1, 
       1, 0}, {Rational[224, 255], Rational[233, 255], Rational[217, 255], 
        0}, {Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], 0}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], 0}, {
       Rational[61, 85], Rational[203, 255], Rational[166, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        79, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[224, 255], Rational[233, 255], Rational[217, 255], Rational[
        64, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        6, 17]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[229, 255], Rational[236, 255], Rational[223, 255], Rational[
        18, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        148, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        254, 255]}, {
       Rational[247, 255], Rational[83, 85], Rational[49, 51], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[212, 255], Rational[224, 255], Rational[202, 255], Rational[
        6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        41, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        1, 15]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        28, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        49, 51]}, {
       Rational[167, 255], Rational[64, 85], Rational[49, 85], Rational[
        37, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[212, 255], Rational[224, 255], Rational[202, 255], 
        Rational[6, 17]}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        69, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        9, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 0}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        31, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        71, 85]}, {
       Rational[137, 255], Rational[57, 85], Rational[22, 51], Rational[
        83, 85]}, {
       Rational[77, 85], Rational[14, 15], Rational[15, 17], Rational[
        10, 51]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {
       Rational[214, 255], Rational[15, 17], Rational[41, 51], Rational[
        86, 255]}, {
       Rational[46, 85], Rational[57, 85], Rational[37, 85], Rational[
        248, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        241, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        48, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        29, 85]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        92, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        3, 5]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        82, 85]}, {
       Rational[137, 255], Rational[57, 85], Rational[22, 51], Rational[
        83, 85]}, {
       Rational[214, 255], Rational[15, 17], Rational[4, 5], Rational[
        29, 85]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {Rational[232, 255], Rational[239, 255], Rational[227, 255], 
        Rational[47, 255]}, {
       Rational[167, 255], Rational[64, 85], Rational[49, 85], Rational[
        37, 51]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], Rational[
        254, 255]}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[9, 17], Rational[169, 255], Rational[107, 255], 1}, {
       Rational[8, 15], Rational[2, 3], Rational[36, 85], Rational[84, 85]}, {
       Rational[169, 255], Rational[193, 255], Rational[149, 255], Rational[
        181, 255]}, {
       Rational[232, 255], Rational[239, 255], Rational[227, 255], Rational[
        47, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       Rational[82, 85], Rational[248, 255], Rational[81, 85], Rational[
        19, 255]}, {
       Rational[227, 255], Rational[47, 51], Rational[13, 15], Rational[
        58, 255]}, {
       Rational[76, 85], Rational[236, 255], Rational[74, 85], Rational[
        56, 255]}, {
       Rational[247, 255], Rational[83, 85], Rational[49, 51], Rational[
        16, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, Rational[128, 255]}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1,
       1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 
      1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1,
       1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 
      1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}}}, {{{1, 1, 1, 0.7529411764705882}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0.5019607843137255}, {
       1, 1, 1, 0.5019607843137255}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9647058823529412, 
       0.9725490196078431, 0.9529411764705882, 0.07450980392156863}, {
       0.8901960784313725, 0.9215686274509803, 0.8666666666666667, 
       0.22745098039215686`}, {0.8941176470588236, 0.9254901960784314, 
       0.8705882352941177, 0.2196078431372549}, {0.9686274509803922, 
       0.9764705882352941, 0.9607843137254902, 0.06274509803921569}, {1, 1, 1,
        0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.9098039215686274, 0.9372549019607843, 0.8901960784313725, 
       0.1843137254901961}, {0.6549019607843137, 0.7529411764705882, 
       0.5764705882352941, 0.7254901960784313}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.996078431372549}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.6627450980392157, 0.7568627450980392, 
       0.5843137254901961, 0.7098039215686275}, {0.9098039215686274, 
       0.9372549019607843, 0.8901960784313725, 0.1843137254901961}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {0.8392156862745098, 0.8823529411764706, 
       0.803921568627451, 0.33725490196078434`}, {0.5411764705882353, 
       0.6705882352941176, 0.43529411764705883`, 0.9725490196078431}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.9450980392156862}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.5647058823529412}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.3411764705882353}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.3607843137254902}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.6}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.9647058823529412}, {0.5372549019607843, 
       0.6705882352941176, 0.43137254901960786`, 0.9764705882352941}, {
       0.8392156862745098, 0.8823529411764706, 0.8, 0.3411764705882353}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.8117647058823529}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.10588235294117647`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.12156862745098039`}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.8352941176470589}, {0.5372549019607843, 
       0.6705882352941176, 0.43137254901960786`, 0.9764705882352941}, {
       0.9058823529411765, 0.9333333333333333, 0.8823529411764706, 
       0.19607843137254902`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.10980392156862745`}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.9607843137254902}, {0.6549019607843137, 
       0.7529411764705882, 0.5764705882352941, 0.7254901960784313}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.5803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.996078431372549}, {0.9686274509803922, 
       0.9764705882352941, 0.9607843137254902, 0.06274509803921569}, {1, 1, 1,
        0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.35294117647058826`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8980392156862745, 0.9254901960784314, 0.8745098039215686, 
       0.21176470588235294`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.7176470588235294, 0.796078431372549, 0.6509803921568628, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
        0}, {0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8392156862745098, 0.8823529411764706, 0.803921568627451, 
       0.33725490196078434`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9137254901960784, 0.9372549019607843, 0.8941176470588236, 
       0.17647058823529413`}, {0.5411764705882353, 0.6705882352941176, 
       0.43529411764705883`, 0.9686274509803922}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.8117647058823529}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.6666666666666666, 0.7607843137254902, 0.592156862745098, 
       0.7019607843137254}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.9568627450980393}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.11372549019607843`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
        0}, {0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9686274509803922, 0.9764705882352941, 0.9647058823529412, 
       0.058823529411764705`}, {0.5333333333333333, 0.6666666666666666, 
       0.42745098039215684`, 0.984313725490196}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.5843137254901961}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9058823529411765, 0.9294117647058824, 0.8823529411764706, 0.2}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.3607843137254902}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9058823529411765, 0.9294117647058824, 0.8823529411764706, 0.2}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.3607843137254902}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9686274509803922, 0.9764705882352941, 0.9647058823529412, 
       0.058823529411764705`}, {0.5333333333333333, 0.6666666666666666, 
       0.42745098039215684`, 0.984313725490196}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.5843137254901961}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.6666666666666666, 0.7607843137254902, 0.592156862745098, 
       0.7019607843137254}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.9568627450980393}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.11372549019607843`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
        0}, {0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9137254901960784, 0.9372549019607843, 0.8941176470588236, 
       0.17647058823529413`}, {0.5411764705882353, 0.6705882352941176, 
       0.43529411764705883`, 0.9686274509803922}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.8117647058823529}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8392156862745098, 0.8823529411764706, 0.803921568627451, 
       0.33725490196078434`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {1, 1, 
       1, 0}, {0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
        0}, {0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 0}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 0}, {
       0.7176470588235294, 0.796078431372549, 0.6509803921568628, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 0.792156862745098, 
       0.35294117647058826`}, {0.5333333333333333, 0.6666666666666666, 
       0.4235294117647059, 0.9882352941176471}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.803921568627451}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.30980392156862746`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8784313725490196, 0.9137254901960784, 0.8509803921568627, 
       0.25098039215686274`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 0.8784313725490196, 
       0.792156862745098, 0.35294117647058826`}, {0.5333333333333333, 
       0.6666666666666666, 0.4235294117647059, 0.9882352941176471}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.35294117647058826`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.8980392156862745, 0.9254901960784314, 0.8745098039215686, 
       0.21176470588235294`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.5803921568627451}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.996078431372549}, {0.9686274509803922, 
       0.9764705882352941, 0.9607843137254902, 0.06274509803921569}, {1, 1, 1,
        0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.803921568627451}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.06666666666666667}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.10980392156862745`}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.9607843137254902}, {0.6549019607843137, 
       0.7529411764705882, 0.5764705882352941, 0.7254901960784313}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.8313725490196079, 
       0.8784313725490196, 0.792156862745098, 0.35294117647058826`}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.8117647058823529}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.10588235294117647`}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 0}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.12156862745098039`}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.8352941176470589}, {0.5372549019607843, 
       0.6705882352941176, 0.43137254901960786`, 0.9764705882352941}, {
       0.9058823529411765, 0.9333333333333333, 0.8823529411764706, 
       0.19607843137254902`}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {0.8392156862745098, 0.8823529411764706, 
       0.803921568627451, 0.33725490196078434`}, {0.5411764705882353, 
       0.6705882352941176, 0.43529411764705883`, 0.9725490196078431}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.9450980392156862}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.5647058823529412}, {0.5294117647058824, 
       0.6627450980392157, 0.4196078431372549, 0.3411764705882353}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 
       0.3607843137254902}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.6}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.9647058823529412}, {0.5372549019607843, 
       0.6705882352941176, 0.43137254901960786`, 0.9764705882352941}, {
       0.8392156862745098, 0.8823529411764706, 0.8, 0.3411764705882353}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {0.9098039215686274, 
       0.9372549019607843, 0.8901960784313725, 0.1843137254901961}, {
       0.6549019607843137, 0.7529411764705882, 0.5764705882352941, 
       0.7254901960784313}, {0.5294117647058824, 0.6627450980392157, 
       0.4196078431372549, 0.996078431372549}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.5294117647058824, 0.6627450980392157, 0.4196078431372549, 1}, {
       0.5333333333333333, 0.6666666666666666, 0.4235294117647059, 
       0.9882352941176471}, {0.6627450980392157, 0.7568627450980392, 
       0.5843137254901961, 0.7098039215686275}, {0.9098039215686274, 
       0.9372549019607843, 0.8901960784313725, 0.1843137254901961}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {
       0.9647058823529412, 0.9725490196078431, 0.9529411764705882, 
       0.07450980392156863}, {0.8901960784313725, 0.9215686274509803, 
       0.8666666666666667, 0.22745098039215686`}, {0.8941176470588236, 
       0.9254901960784314, 0.8705882352941177, 0.2196078431372549}, {
       0.9686274509803922, 0.9764705882352941, 0.9607843137254902, 
       0.06274509803921569}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1,
        1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 
       1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{1, 1, 1, 0.5019607843137255}, {1,
        1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 
       1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}}, {{
       1, 1, 1, 0.5019607843137255}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 0}, {1, 1, 1, 
       0}, {1, 1, 1, 0}}, {{1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1,
       1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 1}, {1, 1, 1, 
      1}, {1, 1, 1, 1}}}]], RasterBox[CompressedData["
1:eJzt2z9LQlEcx+EDBUKLtEd/dHAKgjQIboTgIopD2Bu40BTokGOvOmrvHLit
UcLvDtfnAwc3H87B7YtX9fapPkopLfNZ5HOcJEmSJOng6+Wzbj4Zv7eeVPPP
/tnN22j+fh1xTk7PX9ow7qrZR77Pc9RDXd7XF/kOu+F0cxt1j8Hj67gNo7xX
Cvxd/VhR389gMBgMBoPBYDAYDAaDwWAwGAwGg8HYr7JDld0uBW5FXTHKpjZ+
WH1F7pxlG2zDKHttsqX+ybClMhgMBoPBYDAYDAaDwWAwGAwGg8FgHKbRlZ3T
lvo/I3pLzfXKe0XunGWvbcNo3iny/86SJEmSpA70DTpkgOs=
    
    "], {{0, 0}, {150., 152.}}, {0, 255},
    ColorFunction->RGBColor]}]], "Output",
 CellChangeTimes->{
  3.506703256361059*^9, 3.5067032869509373`*^9, 3.50670338482236*^9, 
   3.5067034525310497`*^9, 3.506703524079484*^9, {3.506703674976927*^9, 
   3.506703694536063*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Blog", "Title",
 CellChangeTimes->{{3.506647566615986*^9, 3.506647570949039*^9}}],

Cell[BoxData[
 RowBox[{"Outline", " ", "separators"}]], "Input",
 CellChangeTimes->{{3.506647576802372*^9, 3.506647581273732*^9}}],

Cell[BoxData[
 RowBox[{"Fill", " ", "separators"}]], "Input",
 CellChangeTimes->{{3.506647583696616*^9, 3.5066475859155703`*^9}}],

Cell[BoxData[
 RowBox[{"Cluster", " ", "decomposition"}]], "Input",
 CellChangeTimes->{{3.5066475897391577`*^9, 3.506647592165036*^9}}],

Cell[BoxData[
 RowBox[{"Cluster", " ", "decomposition", " ", "3", "d"}]], "Input",
 CellChangeTimes->{{3.5066475958490553`*^9, 3.50664759909132*^9}}],

Cell[BoxData["oneColorPlot"], "Input",
 CellChangeTimes->{{3.506647612792777*^9, 3.506647614417613*^9}}],

Cell[BoxData["splitPlot"], "Input",
 CellChangeTimes->{{3.506647615312847*^9, 3.506647616577279*^9}}],

Cell[CellGroupData[{

Cell[BoxData["jnodes"], "Input",
 CellChangeTimes->{{3.506788471865834*^9, 3.506788473080822*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.506788473452985*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Two color graph", "Section",
 CellChangeTimes->{{3.506791625345533*^9, 3.506791628551646*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"twoColorGraph", "[", 
    RowBox[{"g_", ",", "seen_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vcoords", "=", 
      RowBox[{"graphCoords", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"verts", "=", 
      RowBox[{"VertexList", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"edges", "=", 
      RowBox[{"EdgeList", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"frag$vsf", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x_", ",", "y_"}], "}"}], ",", "v_", ",", 
        RowBox[{"{", 
         RowBox[{"w_", ",", "h_"}], "}"}]}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{"Black", ",", 
        RowBox[{"EdgeForm", "[", "Thick", "]"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{"seen", ",", "v"}], "]"}], ",", "Pink", ",", "White"}], 
         "]"}], ",", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}], ",", 
          RowBox[{"1", "/", "4"}]}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graph", "[", 
      RowBox[{"verts", ",", "edges", ",", 
       RowBox[{"VertexShapeFunction", "\[Rule]", "frag$vsf"}], ",", 
       RowBox[{"VertexCoordinates", "\[Rule]", "vcoords"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "60"}]}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.506791014450574*^9, {3.506791100222427*^9, 3.506791137570088*^9}, {
   3.506791325034627*^9, 3.506791333624028*^9}, {3.506791373400401*^9, 
   3.506791578583208*^9}, {3.506791861170806*^9, 3.5067918811290703`*^9}, {
   3.5067923299885*^9, 3.506792330817546*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"twoColorGraph", "[", 
  RowBox[{"gg", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4}, {Null, {{1, 2}, {3, 4}}}, {
      ImageSize -> 60, 
       VertexCoordinates -> {{0., 0.}, {0., 1.}, {1., 0.}, {1., 1.}}, 
       VertexShapeFunction -> {$CellContext`frag$vsf}}]], Typeset`boxes = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[{
         GrayLevel[0], 
         EdgeForm[
          Thickness[Large]], 
         RGBColor[1, 0.5, 0.5], 
         DiskBox[{0., 0.}, 
          NCache[
           Rational[1, 4], 0.25]]}, "DynamicName", BoxID -> "VertexID$1"], 
       TagBox[{
         GrayLevel[0], 
         EdgeForm[
          Thickness[Large]], 
         RGBColor[1, 0.5, 0.5], 
         DiskBox[{0., 1.}, 
          NCache[
           Rational[1, 4], 0.25]]}, "DynamicName", BoxID -> "VertexID$2"], 
       TagBox[{
         GrayLevel[0], 
         EdgeForm[
          Thickness[Large]], 
         GrayLevel[1], 
         DiskBox[{1., 0.}, 
          NCache[
           Rational[1, 4], 0.25]]}, "DynamicName", BoxID -> "VertexID$3"], 
       TagBox[{
         GrayLevel[0], 
         EdgeForm[
          Thickness[Large]], 
         GrayLevel[1], 
         DiskBox[{1., 1.}, 
          NCache[
           Rational[1, 4], 0.25]]}, "DynamicName", BoxID -> "VertexID$4"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{0.17999999999999972`, 
      58.81999999999999}, {-31.867199999999997`, 26.772800000000004`}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None,
  ImageSize->60]], "Output",
 CellChangeTimes->{3.506791651075247*^9, 3.5067918922920218`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"gg", "=", 
   RowBox[{"Graph", "[", 
    RowBox[{
     RowBox[{"Range", "@", "4"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[UndirectedEdge]", "2"}], ",", 
       RowBox[{"3", "\[UndirectedEdge]", "4"}]}], "}"}], ",", 
     RowBox[{"VertexCoordinates", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"2", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], ",", 
        RowBox[{"3", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}], ",", 
        RowBox[{"4", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Show", "[", 
        RowBox[{"twoColorGraph", "[", 
         RowBox[{"gg", ",", "#"}], "]"}], "]"}], "&"}], ",", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "1", "}"}], ",", 
          RowBox[{"{", "2", "}"}], ",", 
          RowBox[{"{", "3", "}"}], ",", 
          RowBox[{"{", "4", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3"}], "}"}]}], "}"}], ",", "3"}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], ",", 
    RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}]], "Input",
 CellChangeTimes->{3.5067919051768703`*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60]},
    {
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60]},
    {
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{3.5067917290380983`*^9, 3.506791907609573*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{"Row", "[", 
   RowBox[{"rowExpr", "~", "Join", "~", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<\[Times]\>\"", ",", "30"}], "]"}], "}"}], "~", "Join", "~",
     "rowExpr"}], "]"}]}]], "Input"],

Cell[BoxData[
 TemplateBox[{
  StyleBox["\"(\"", StripOnInput -> False, FontSize -> 30],TemplateBox[{
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25]}, "Row", 
    DisplayFunction -> (
     RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
       "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5}]& ), 
    InterpretationFunction -> (RowBox[{"Row", "[", 
       RowBox[{"{", 
         RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5}], "}"}], "]"}]& )],
   StyleBox["\")\"", StripOnInput -> False, FontSize -> 30],StyleBox[
   "\"\[Times]\"", StripOnInput -> False, FontSize -> 30],StyleBox[
   "\"(\"", StripOnInput -> False, FontSize -> 30],TemplateBox[{
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25]}, "Row", 
    DisplayFunction -> (
     RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
       "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5}]& ), 
    InterpretationFunction -> (RowBox[{"Row", "[", 
       RowBox[{"{", 
         RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5}], "}"}], "]"}]& )],
   StyleBox["\")\"", StripOnInput -> False, FontSize -> 30]},
  "Row",
  DisplayFunction->(
   RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
     "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
     "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7}], 
       "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{3.506792247538589*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"twoColorGraph", "[", 
    RowBox[{
     RowBox[{"CycleGraph", "[", "4", "]"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5067922980125313`*^9, 3.506792303789339*^9}, {
  3.506792343070878*^9, 3.506792362131414*^9}}],

Cell[BoxData[
 GraphicsBox[{GraphicsGroupBox[{
     {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{1., 6.123233995736766*^-17}, 0.25]}, 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{1.2246467991473532`*^-16, -1.}, 0.25]}, 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{-1., -1.8369701987210297`*^-16}, 0.25]}, 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{-2.4492935982947064`*^-16, 1.}, 0.25]}}, 
     {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
      LineBox[{{{0.7920127299687871, -0.2079872700312126}, {
       0.20798727003121237`, -0.7920127299687874}}, {{0.7920127299687871, 
       0.20798727003121256`}, {0.20798727003121212`, 
       0.7920127299687872}}, {{-0.20798727003121265`, -0.7920127299687874}, \
{-0.7920127299687874, -0.20798727003121298`}}, {{-0.7920127299687875, 
       0.2079872700312122}, {-0.20798727003121292`, 
       0.7920127299687871}}}]}}], {}},
  FrameTicks->None,
  ImageSize->100]], "Output",
 CellChangeTimes->{
  3.506792304260956*^9, {3.506792338369906*^9, 3.50679236253659*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{740, 752},
WindowMargins->{{111, Automatic}, {23, Automatic}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 6, \
2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 139, 2, 76, "Title"],
Cell[721, 26, 4781, 135, 493, "Input"],
Cell[5505, 163, 101, 1, 67, "Section"],
Cell[CellGroupData[{
Cell[5631, 168, 102, 1, 37, "Section"],
Cell[5736, 171, 486, 11, 43, "Input"],
Cell[6225, 184, 1841, 43, 133, "Input"],
Cell[8069, 229, 231, 6, 43, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8337, 240, 102, 1, 67, "Section"],
Cell[8442, 243, 4516, 112, 373, "Input"],
Cell[12961, 357, 1152, 34, 88, "Input"],
Cell[CellGroupData[{
Cell[14138, 395, 316, 9, 27, "Input"],
Cell[14457, 406, 4071, 81, 215, "Output"]
}, Open  ]],
Cell[18543, 490, 7076, 166, 673, "Input"],
Cell[CellGroupData[{
Cell[25644, 660, 2036, 57, 148, "Input"],
Cell[27683, 719, 1626946, 23084, 379, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1654690, 23810, 87, 1, 76, "Title"],
Cell[1654780, 23813, 130, 2, 27, "Input"],
Cell[1654913, 23817, 129, 2, 27, "Input"],
Cell[1655045, 23821, 135, 2, 27, "Input"],
Cell[1655183, 23825, 149, 2, 27, "Input"],
Cell[1655335, 23829, 104, 1, 27, "Input"],
Cell[1655442, 23832, 101, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[1655568, 23837, 98, 1, 27, "Input"],
Cell[1655669, 23840, 559, 15, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1656265, 23860, 100, 1, 67, "Section"],
Cell[1656368, 23863, 1807, 44, 148, "Input"],
Cell[CellGroupData[{
Cell[1658200, 23911, 139, 4, 27, "Input"],
Cell[1658342, 23917, 2348, 65, 75, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1660727, 23987, 1784, 52, 88, "Input"],
Cell[1662514, 24041, 7124, 136, 217, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1669675, 24182, 262, 7, 27, "Input"],
Cell[1669940, 24191, 5619, 158, 86, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1675596, 24354, 364, 9, 27, "Input"],
Cell[1675963, 24365, 1152, 22, 115, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
