(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      5508,        173]
NotebookOptionsPosition[      5133,        156]
NotebookOutlinePosition[      5491,        172]
CellTagsIndexPosition[      5448,        169]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Bulatov`common`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Bulatov`dictionary`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Bulatov`treeDecomposition`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"On", "[", "Assert", "]"}]}], "Input",
 CellChangeTimes->{{3.5063884740864277`*^9, 3.506388475707403*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "convergence", " ", "happens", " ", "after", " ", "1", " ", "iteration"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"initHardcore", "[", 
     RowBox[{"PathGraph", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"initMessages", "[", 
     RowBox[{"findTreeDecomposition", "[", "g", "]"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{"getMarginals", "[", "]"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "3"}], ",", 
       RowBox[{"1", "/", "3"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{"parallelUpdate", "[", "1", "]"}], "\[Equal]", 
     RowBox[{"2", "/", "3"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{"getMarginals", "[", "]"}], "\[Equal]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", "/", "5"}], ",", 
       RowBox[{"1", "/", "5"}], ",", 
       RowBox[{"2", "/", "5"}]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{"parallelUpdate", "[", "1", "]"}], "\[Equal]", "0"}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Assert", "[", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"betheFreeEnergy", "[", "]"}], "]"}], "\[Equal]", "5"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5063884291265583`*^9, 3.50638849068575*^9}, {
  3.5063895289591293`*^9, 3.5063895576629868`*^9}, {3.506390412671688*^9, 
  3.5063904264870853`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"initHardcore", "[", 
   RowBox[{"CycleGraph", "[", "4", "]"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initMessages", "[", 
   RowBox[{"findTreeDecomposition", "[", "g", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Assert", "[", 
   RowBox[{
    RowBox[{"getMarginals", "[", "]"}], "\[Equal]", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["2", "5"], ",", 
      FractionBox["1", "5"], ",", 
      FractionBox["2", "5"], ",", 
      FractionBox["1", "5"]}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Assert", "[", 
  RowBox[{
   RowBox[{"parallelUpdate", "[", "1", "]"}], "\[Equal]", 
   RowBox[{"3", "/", "5"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Assert", "[", 
  RowBox[{
   RowBox[{"getMarginals", "[", "]"}], "\[Equal]", 
   RowBox[{"{", 
    RowBox[{
     FractionBox["2", "7"], ",", 
     FractionBox["2", "7"], ",", 
     FractionBox["2", "7"], ",", 
     FractionBox["2", "7"]}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Assert", "[", 
  RowBox[{
   RowBox[{"parallelUpdate", "[", "1", "]"}], "\[Equal]", "0"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Assert", "[", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{"betheFreeEnergy", "[", "]"}], "]"}], "\[Equal]", "7"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.506391611424446*^9, 3.5063916135123243`*^9}, {
  3.5063916479516277`*^9, 3.506391648671063*^9}, {3.506391695388877*^9, 
  3.5063917277790213`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"initHardcore", "@", 
   RowBox[{"GraphData", "[", 
    RowBox[{"{", 
     RowBox[{"7", ",", "317"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"initMessages", "[", 
   RowBox[{"findTreeDecomposition", "@", "g"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"parallelUpdate", "[", "3", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Assert", "[", 
   RowBox[{
    RowBox[{"getTotalResidual", "[", "]"}], "\[Equal]", "0"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Assert", "[", 
  RowBox[{
   RowBox[{"Exp", "[", 
    RowBox[{"betheFreeEnergy", "[", "]"}], "]"}], "\[Equal]", "23"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.5063925165425053`*^9, 3.506392550810801*^9}}]
},
WindowSize->{740, 752},
WindowMargins->{{163, Automatic}, {-97, Automatic}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 6, \
2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 578, 15, 88, "Input"],
Cell[1138, 37, 1722, 48, 145, "Input"],
Cell[2863, 87, 1489, 42, 173, "Input"],
Cell[4355, 131, 774, 23, 100, "Input"]
}
]
*)

(* End of internal cache information *)
