(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    258161,       6672]
NotebookOptionsPosition[    252252,       6475]
NotebookOutlinePosition[    252867,       6500]
CellTagsIndexPosition[    252780,       6495]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"g", "=", 
  RowBox[{"GridGraph", "[", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5067380827443438`*^9, 3.506738085818074*^9}}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9}, {Null, 
       SparseArray[
       Automatic, {9, 9}, 0, {
        1, {{0, 2, 5, 7, 10, 14, 17, 19, 22, 24}, {{4}, {2}, {1}, {3}, {5}, {
          2}, {6}, {1}, {5}, {7}, {2}, {4}, {6}, {8}, {3}, {5}, {9}, {4}, {
          8}, {5}, {7}, {9}, {6}, {8}}}, Pattern}]}, {
      VertexCoordinates -> {{0., 0.}, {0., 1.}, {0., 2.}, {1., 0.}, {1., 
        1.}, {1., 2.}, {2., 0.}, {2., 1.}, {2., 2.}}}]], Typeset`boxes = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        DiskBox[{0., 0.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$1"], 
       TagBox[
        DiskBox[{0., 1.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$2"], 
       TagBox[
        DiskBox[{0., 2.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$3"], 
       TagBox[
        DiskBox[{1., 0.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$4"], 
       TagBox[
        DiskBox[{1., 1.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$5"], 
       TagBox[
        DiskBox[{1., 2.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$6"], 
       TagBox[
        DiskBox[{2., 0.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$7"], 
       TagBox[
        DiskBox[{2., 1.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$8"], 
       TagBox[
        DiskBox[{2., 2.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$9"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$6", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{6.180000000000001, 352.82}, {-176.10720000000003`, 
      170.5327999999999}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.506738086202104*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"jnodes", ",", "jedges"}], "}"}], "=", 
   RowBox[{"findTreeDecomposition", "[", 
    RowBox[{"g", ",", 
     RowBox[{"PrimaryHeuristic", "\[Rule]", "\"\<grid\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.506738087751721*^9, 3.506738095679063*^9}, {
  3.5067381576146393`*^9, 3.506738163561282*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"makeClusterGraph", "[", 
  RowBox[{"g", ",", 
   RowBox[{"{", 
    RowBox[{"jnodes", ",", "jedges"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.506738165609293*^9, 3.5067381728756037`*^9}}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{{1, 2, 4}, {2, 3, 6}, {4, 7, 8}, {6, 8, 9}, {2, 4, 5, 6}, {4, 5, 
       6, 8}}, {Null, {{1, 5}, {2, 5}, {3, 6}, {4, 6}, {5, 6}}}, {
      VertexShapeFunction -> {$CellContext`vsf}, 
       VertexCoordinates -> {{0.3333331356494829, 0.3333330372144415}, {
        0.33333313564948297`, 1.6666669627855584`}, {1.6666668643505171`, 
        0.3333330372144415}, {1.6666668643505171`, 1.6666669627855586`}, {
        0.6464456838901884, 1.0000000000000002`}, {1.3535543161098114`, 
        0.9999999999999998}}}]], Typeset`boxes = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{1, 2, 4}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 2, 3, 4}, {{2}, {3}, {1}, {1}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", ImageSize -> {60., 60.}, 
                   PlotRange -> {{-0.5, 1.5}, {-0.5, 1.5}}, 
                   VertexCoordinates -> {{0., 0.}, {0., 1.}, {1., 0.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["1", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, ImageSize -> {60., 60.}, 
             PlotRange -> {{-0.5, 1.5}, {-0.5, 1.5}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {0.3333331356494829, 
         0.3333330372144415}], "DynamicName", BoxID -> "VertexID$1"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{2, 3, 6}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 1, 3, 4}, {{2}, {1}, {3}, {2}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", ImageSize -> {60., 60.}, 
                   PlotRange -> {{-0.5, 1.5}, {0.5, 2.5}}, 
                   VertexCoordinates -> {{0., 1.}, {0., 2.}, {1., 2.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["3", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, ImageSize -> {60., 60.}, 
             PlotRange -> {{-0.5, 1.5}, {0.5, 2.5}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {0.33333313564948297`,
          1.6666669627855584`}], "DynamicName", BoxID -> "VertexID$2"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{4, 7, 8}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 1, 3, 4}, {{2}, {1}, {3}, {2}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", ImageSize -> {60., 60.}, 
                   PlotRange -> {{0.5, 2.5}, {-0.5, 1.5}}, 
                   VertexCoordinates -> {{1., 0.}, {2., 0.}, {2., 1.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["7", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["8", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, ImageSize -> {60., 60.}, 
             PlotRange -> {{0.5, 2.5}, {-0.5, 1.5}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {1.6666668643505171`, 
         0.3333330372144415}], "DynamicName", BoxID -> "VertexID$3"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{6, 8, 9}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 1, 2, 4}, {{3}, {3}, {1}, {2}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", ImageSize -> {60., 60.}, 
                   PlotRange -> {{0.5, 2.5}, {0.5, 2.5}}, 
                   VertexCoordinates -> {{1., 2.}, {2., 1.}, {2., 2.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["8", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["9", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, ImageSize -> {60., 60.}, 
             PlotRange -> {{0.5, 2.5}, {0.5, 2.5}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {1.6666668643505171`, 
         1.6666669627855586`}], "DynamicName", BoxID -> "VertexID$4"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{2, 4, 5, 6}, {Null, 
                   SparseArray[
                   Automatic, {4, 4}, 0, {
                    1, {{0, 1, 2, 5, 6}, {{3}, {3}, {1}, {2}, {4}, {3}}}, 
                    Pattern}]}, {
                  GraphStyle -> "SimpleLink", ImageSize -> {60., 90.}, 
                   PlotRange -> {{-0.5, 1.5}, {-0.5, 2.5}}, 
                   VertexCoordinates -> {{0., 1.}, {1., 0.}, {1., 1.}, {1., 
                    2.}}}]], Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$3"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$4"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$4", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$4"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$3", Automatic, Center], 
                    DynamicLocation["VertexID$4", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, ImageSize -> {60., 90.}, 
             PlotRange -> {{-0.5, 1.5}, {-0.5, 2.5}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {0.6464456838901884, 
         1.0000000000000002`}], "DynamicName", BoxID -> "VertexID$5"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{4, 5, 6, 8}, {Null, 
                   SparseArray[
                   Automatic, {4, 4}, 0, {
                    1, {{0, 1, 4, 5, 6}, {{2}, {1}, {3}, {4}, {2}, {2}}}, 
                    Pattern}]}, {
                  GraphStyle -> "SimpleLink", ImageSize -> {60., 90.}, 
                   PlotRange -> {{0.5, 2.5}, {-0.5, 2.5}}, 
                   VertexCoordinates -> {{1., 0.}, {1., 1.}, {1., 2.}, {2., 
                    1.}}}]], Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$3"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$4"], 
                    InsetBox[
                    FormBox["8", TraditionalForm], 
                    DynamicLocation["VertexID$4", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$4"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$4", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, ImageSize -> {60., 90.}, 
             PlotRange -> {{0.5, 2.5}, {-0.5, 2.5}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {1.3535543161098114`, 
         0.9999999999999998}], "DynamicName", BoxID -> "VertexID$6"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{30.000000000000007`, 329.}, {-152.00000000000006`, 
      147.0000352889519}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.506738173524242*^9, 3.506738212383596*^9, 
  3.506738465863803*^9, 3.5067385204270353`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.506738101157312*^9, 3.5067381019099607`*^9}, 
   3.506738142780006*^9}],

Cell[CellGroupData[{

Cell[BoxData["sol"], "Input",
 CellChangeTimes->{{3.506738216642539*^9, 3.506738216815798*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.021446992770448585`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"xcl", "[", "1", "]"}], "\[Rule]", "0.3333331356494829`"}], ",", 
     RowBox[{
      RowBox[{"ycl", "[", "1", "]"}], "\[Rule]", "0.3333330372144415`"}], ",", 
     RowBox[{
      RowBox[{"xcl", "[", "2", "]"}], "\[Rule]", "0.33333313564948297`"}], 
     ",", 
     RowBox[{
      RowBox[{"ycl", "[", "2", "]"}], "\[Rule]", "1.6666669627855584`"}], ",", 
     RowBox[{
      RowBox[{"xcl", "[", "3", "]"}], "\[Rule]", "1.6666668643505171`"}], ",", 
     RowBox[{
      RowBox[{"ycl", "[", "3", "]"}], "\[Rule]", "0.3333330372144415`"}], ",", 
     RowBox[{
      RowBox[{"xcl", "[", "4", "]"}], "\[Rule]", "1.6666668643505171`"}], ",", 
     RowBox[{
      RowBox[{"ycl", "[", "4", "]"}], "\[Rule]", "1.6666669627855586`"}], ",", 
     RowBox[{
      RowBox[{"xcl", "[", "5", "]"}], "\[Rule]", "0.6464456838901884`"}], ",", 
     RowBox[{
      RowBox[{"ycl", "[", "5", "]"}], "\[Rule]", "1.0000000000000002`"}], ",", 
     RowBox[{
      RowBox[{"xcl", "[", "6", "]"}], "\[Rule]", "1.3535543161098114`"}], ",", 
     RowBox[{
      RowBox[{"ycl", "[", "6", "]"}], "\[Rule]", "0.9999999999999998`"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.506738217096459*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["tempC"], "Input",
 CellChangeTimes->{{3.506738219695139*^9, 3.5067382201275997`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.3333331356494829`", ",", "0.3333330372144415`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.33333313564948297`", ",", "1.6666669627855584`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"1.6666668643505171`", ",", "0.3333330372144415`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.6666668643505171`", ",", "1.6666669627855586`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6464456838901884`", ",", "1.0000000000000002`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.3535543161098114`", ",", "0.9999999999999998`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5067382203671303`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["mcoords2"], "Input",
 CellChangeTimes->{{3.506738223183762*^9, 3.5067382240634747`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "4"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.3333331356494829`", ",", "0.3333330372144415`"}], "}"}]}], 
   ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "6"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.33333313564948297`", ",", "1.6666669627855584`"}], "}"}]}], 
   ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "7", ",", "8"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1.6666668643505171`", ",", "0.3333330372144415`"}], "}"}]}], 
   ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"6", ",", "8", ",", "9"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1.6666668643505171`", ",", "1.6666669627855586`"}], "}"}]}], 
   ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "4", ",", "5", ",", "6"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.6464456838901884`", ",", "1.0000000000000002`"}], "}"}]}], 
   ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "5", ",", "6", ",", "8"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1.3535543161098114`", ",", "0.9999999999999998`"}], "}"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.506738224375383*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Graph", "[", 
  RowBox[{"jnodes", ",", "Un"}]}]], "Input",
 CellChangeTimes->{{3.506738243466689*^9, 3.5067382463107157`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "vsf"}]], "Input",
 CellChangeTimes->{{3.5067382527476263`*^9, 3.5067382533417397`*^9}}],

Cell[CellGroupData[{

Cell["Global`vsf", "Print", "PrintUsage",
 CellChangeTimes->{3.5067382539222403`*^9},
 CellTags->"Info3506709453-9620136"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"vsf", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x_", ",", "y_"}], "}"}], ",", "v_", ",", 
           RowBox[{"{", 
            RowBox[{"w_", ",", "h_"}], "}"}]}], "]"}], ":=", 
         RowBox[{"Inset", "[", 
          RowBox[{
           RowBox[{"drawFragment", "[", 
            RowBox[{"v", ",", "30"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`vsf],
  Editable->False]], "Print",
 CellChangeTimes->{3.5067382539552927`*^9},
 CellTags->"Info3506709453-9620136"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graph", "[", 
  RowBox[{"jnodes", ",", 
   RowBox[{"UndirectedEdge", "@@@", "jedges"}], ",", 
   RowBox[{"VertexCoordinates", "\[Rule]", "mcoords2"}]}], "]"}]], "Input",
 CellChangeTimes->{3.5067382604972677`*^9}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{{1, 2, 4}, {2, 3, 6}, {4, 7, 8}, {6, 8, 9}, {2, 4, 5, 6}, {4, 5, 
       6, 8}}, {Null, {{1, 5}, {2, 5}, {3, 6}, {4, 6}, {5, 6}}}, {
      VertexCoordinates -> {{0.3333331356494829, 0.3333330372144415}, {
        0.33333313564948297`, 1.6666669627855584`}, {1.6666668643505171`, 
        0.3333330372144415}, {1.6666668643505171`, 1.6666669627855586`}, {
        0.6464456838901884, 1.0000000000000002`}, {1.3535543161098114`, 
        0.9999999999999998}}}]], Typeset`boxes = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        DiskBox[{0.3333331356494829, 0.3333330372144415}, 
         0.01696231122771258], "DynamicName", BoxID -> "VertexID$1"], 
       TagBox[
        DiskBox[{0.33333313564948297`, 1.6666669627855584`}, 
         0.01696231122771258], "DynamicName", BoxID -> "VertexID$2"], 
       TagBox[
        DiskBox[{1.6666668643505171`, 0.3333330372144415}, 
         0.01696231122771258], "DynamicName", BoxID -> "VertexID$3"], 
       TagBox[
        DiskBox[{1.6666668643505171`, 1.6666669627855586`}, 
         0.01696231122771258], "DynamicName", BoxID -> "VertexID$4"], 
       TagBox[
        DiskBox[{0.6464456838901884, 1.0000000000000002`}, 
         0.01696231122771258], "DynamicName", BoxID -> "VertexID$5"], 
       TagBox[
        DiskBox[{1.3535543161098114`, 0.9999999999999998}, 
         0.01696231122771258], "DynamicName", BoxID -> "VertexID$6"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{6.1800000000000175`, 
      352.82000000000016`}, {-176.10719999999995`, 170.53284962434887`}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.506738261030583*^9, 3.50673846167144*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graph", "[", 
  RowBox[{"jnodes", ",", 
   RowBox[{"UndirectedEdge", "@@@", "jedges"}], ",", 
   RowBox[{"VertexCoordinates", "\[Rule]", "mcoords2"}], ",", 
   RowBox[{"VertexShapeFunction", "\[Rule]", "vsf"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{{1, 2, 4}, {2, 3, 6}, {4, 7, 8}, {6, 8, 9}, {2, 4, 5, 6}, {4, 5, 
       6, 8}}, {Null, {{1, 5}, {2, 5}, {3, 6}, {4, 6}, {5, 6}}}, {
      VertexShapeFunction -> {$CellContext`vsf}, 
       VertexCoordinates -> {{0.3333331356494829, 0.3333330372144415}, {
        0.33333313564948297`, 1.6666669627855584`}, {1.6666668643505171`, 
        0.3333330372144415}, {1.6666668643505171`, 1.6666669627855586`}, {
        0.6464456838901884, 1.0000000000000002`}, {1.3535543161098114`, 
        0.9999999999999998}}}]], Typeset`boxes = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{1, 2, 4}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 2, 3, 4}, {{2}, {3}, {1}, {1}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", 
                   ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
                   PlotRange -> {{
                    0. + Rational[-1, 2] $CellContext`lineThickness, 1. + 
                    Rational[
                    1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
                    0. + Rational[-1, 
                    2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 1. + 
                    Rational[1, 2] $CellContext`lineThickness}}, 
                   VertexCoordinates -> {{0., 0.}, {0., 1.}, {1., 0.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["1", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, 
             ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
             PlotRange -> {{
               0. + Rational[-1, 2] $CellContext`lineThickness, 1. + 
                Rational[
                  1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
               0. + Rational[-1, 
                   2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 1. + 
                Rational[1, 2] $CellContext`lineThickness}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {0.3333331356494829, 
         0.3333330372144415}], "DynamicName", BoxID -> "VertexID$1"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{2, 3, 6}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 1, 3, 4}, {{2}, {1}, {3}, {2}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", 
                   ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
                   PlotRange -> {{
                    0. + Rational[-1, 2] $CellContext`lineThickness, 1. + 
                    Rational[
                    1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
                    1. + Rational[-1, 
                    2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                    Rational[1, 2] $CellContext`lineThickness}}, 
                   VertexCoordinates -> {{0., 1.}, {0., 2.}, {1., 2.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["3", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, 
             ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
             PlotRange -> {{
               0. + Rational[-1, 2] $CellContext`lineThickness, 1. + 
                Rational[
                  1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
               1. + Rational[-1, 
                   2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                Rational[1, 2] $CellContext`lineThickness}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {0.33333313564948297`,
          1.6666669627855584`}], "DynamicName", BoxID -> "VertexID$2"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{4, 7, 8}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 1, 3, 4}, {{2}, {1}, {3}, {2}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", 
                   ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
                   PlotRange -> {{
                    1. + Rational[-1, 2] $CellContext`lineThickness, 2. + 
                    Rational[
                    1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
                    0. + Rational[-1, 
                    2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 1. + 
                    Rational[1, 2] $CellContext`lineThickness}}, 
                   VertexCoordinates -> {{1., 0.}, {2., 0.}, {2., 1.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 0.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["7", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["8", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, 
             ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
             PlotRange -> {{
               1. + Rational[-1, 2] $CellContext`lineThickness, 2. + 
                Rational[
                  1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
               0. + Rational[-1, 
                   2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 1. + 
                Rational[1, 2] $CellContext`lineThickness}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {1.6666668643505171`, 
         0.3333330372144415}], "DynamicName", BoxID -> "VertexID$3"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{6, 8, 9}, {Null, 
                   SparseArray[
                   Automatic, {3, 3}, 0, {
                    1, {{0, 1, 2, 4}, {{3}, {3}, {1}, {2}}}, Pattern}]}, {
                  GraphStyle -> "SimpleLink", 
                   ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
                   PlotRange -> {{
                    1. + Rational[-1, 2] $CellContext`lineThickness, 2. + 
                    Rational[
                    1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
                    1. + Rational[-1, 
                    2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                    Rational[1, 2] $CellContext`lineThickness}}, 
                   VertexCoordinates -> {{1., 2.}, {2., 1.}, {2., 2.}}}]], 
               Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 1.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["8", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 2.}, 0.028284271247461905`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["9", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$3"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, 
             ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
             PlotRange -> {{
               1. + Rational[-1, 2] $CellContext`lineThickness, 2. + 
                Rational[
                  1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
               1. + Rational[-1, 
                   2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                Rational[1, 2] $CellContext`lineThickness}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {1.6666668643505171`, 
         1.6666669627855586`}], "DynamicName", BoxID -> "VertexID$4"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{2, 4, 5, 6}, {Null, 
                   SparseArray[
                   Automatic, {4, 4}, 0, {
                    1, {{0, 1, 2, 5, 6}, {{3}, {3}, {1}, {2}, {4}, {3}}}, 
                    Pattern}]}, {
                  GraphStyle -> "SimpleLink", 
                   ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-2. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
                   PlotRange -> {{
                    0. + Rational[-1, 2] $CellContext`lineThickness, 1. + 
                    Rational[
                    1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
                    0. + Rational[-1, 
                    2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                    Rational[1, 2] $CellContext`lineThickness}}, 
                   VertexCoordinates -> {{0., 1.}, {1., 0.}, {1., 1.}, {1., 
                    2.}}}]], Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{0., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["2", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$3"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$4"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$4", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$4"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$3", Automatic, Center], 
                    DynamicLocation["VertexID$4", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, 
             ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-2. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
             PlotRange -> {{
               0. + Rational[-1, 2] $CellContext`lineThickness, 1. + 
                Rational[
                  1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
               0. + Rational[-1, 
                   2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                Rational[1, 2] $CellContext`lineThickness}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {0.6464456838901884, 
         1.0000000000000002`}], "DynamicName", BoxID -> "VertexID$5"], 
       TagBox[
        InsetBox[
         BoxData[
          FormBox[
           GraphicsBox[
            NamespaceBox["NetworkGraphics", 
             DynamicModuleBox[{Typeset`graph = HoldComplete[
                 Graph[{4, 5, 6, 8}, {Null, 
                   SparseArray[
                   Automatic, {4, 4}, 0, {
                    1, {{0, 1, 4, 5, 6}, {{2}, {1}, {3}, {4}, {2}, {2}}}, 
                    Pattern}]}, {
                  GraphStyle -> "SimpleLink", 
                   ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-2. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
                   PlotRange -> {{
                    1. + Rational[-1, 2] $CellContext`lineThickness, 2. + 
                    Rational[
                    1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
                    0. + Rational[-1, 
                    2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                    Rational[1, 2] $CellContext`lineThickness}}, 
                   VertexCoordinates -> {{1., 0.}, {1., 1.}, {1., 2.}, {2., 
                    1.}}}]], Typeset`boxes = GraphicsGroupBox[{{
                   Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], 
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 0.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$1"], 
                    InsetBox[
                    FormBox["4", TraditionalForm], 
                    DynamicLocation["VertexID$1", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$1"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$2"], 
                    InsetBox[
                    FormBox["5", TraditionalForm], 
                    DynamicLocation["VertexID$2", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$2"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{1., 2.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$3"], 
                    InsetBox[
                    FormBox["6", TraditionalForm], 
                    DynamicLocation["VertexID$3", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> "VertexLabelID$3"], 
                   
                   TagBox[{
                    TagBox[
                    StyleBox[
                    DiskBox[{2., 1.}, 0.044721359549995794`], 
                    Directive[
                    GrayLevel[1], 
                    Opacity[0], 
                    EdgeForm[{}]], StripOnInput -> False], "DynamicName", 
                    BoxID -> "VertexID$4"], 
                    InsetBox[
                    FormBox["8", TraditionalForm], 
                    DynamicLocation["VertexID$4", None, Center], BaseStyle -> 
                    "Graphics"]}, "DynamicName", BoxID -> 
                    "VertexLabelID$4"]}, {
                   Directive[
                    GrayLevel[0], 
                    Opacity[1]], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$1", Automatic, Center], 
                    DynamicLocation["VertexID$2", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$3", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False], 
                   StyleBox[
                    LineBox[{
                    DynamicLocation["VertexID$2", Automatic, Center], 
                    DynamicLocation["VertexID$4", Automatic, Center]}], 
                    Directive[
                    GrayLevel[0], 
                    Opacity[1]], StripOnInput -> False]}}]}, 
              DynamicBox[
               GraphComputation`NetworkGraphicsBox[
               1, Typeset`graph, Typeset`boxes], {
               CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
                SynchronousUpdating -> False, TrackedSymbols :> {}}]]], {
            FrameTicks -> None, 
             ImageSize -> {(-30) (-1. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1)), (-30) (-2. - $CellContext`lineThickness - \
$CellContext`masterScale^(-1))}, 
             PlotRange -> {{
               1. + Rational[-1, 2] $CellContext`lineThickness, 2. + 
                Rational[
                  1, 2] $CellContext`lineThickness + \
$CellContext`masterScale^(-1)}, {
               0. + Rational[-1, 
                   2] $CellContext`lineThickness - \
$CellContext`masterScale^(-1), 2. + 
                Rational[1, 2] $CellContext`lineThickness}}, 
             DefaultBaseStyle -> {
              "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> 
               Hue[0.8, 1., 0.6]}}], TraditionalForm]], {1.3535543161098114`, 
         0.9999999999999998}], "DynamicName", BoxID -> "VertexID$6"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{4.503599627370496*^15, -4.503599627370496*^15}, {
      4.503599627370496*^15, -4.503599627370496*^15}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.5067383008786*^9, 3.5067384579321957`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["plotRange"], "Input",
 CellChangeTimes->{{3.506738313231023*^9, 3.506738314267194*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1.`", "\[VeryThinSpace]", "-", 
      FractionBox["lineThickness", "2"]}], ",", 
     RowBox[{"2.`", "\[VeryThinSpace]", "+", 
      FractionBox["lineThickness", "2"], "+", 
      FractionBox["1", "masterScale"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0.`", "\[VeryThinSpace]", "-", 
      FractionBox["lineThickness", "2"], "-", 
      FractionBox["1", "masterScale"]}], ",", 
     RowBox[{"2.`", "\[VeryThinSpace]", "+", 
      FractionBox["lineThickness", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.506738314557212*^9, 3.5067384043264227`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["plotRange"], "Input",
 CellChangeTimes->{{3.50673847166216*^9, 3.506738472608521*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1.`", "\[VeryThinSpace]", "-", 
      FractionBox["lineThickness", "2"]}], ",", 
     RowBox[{"2.`", "\[VeryThinSpace]", "+", 
      FractionBox["lineThickness", "2"], "+", 
      FractionBox["1", "masterScale"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0.`", "\[VeryThinSpace]", "-", 
      FractionBox["lineThickness", "2"], "-", 
      FractionBox["1", "masterScale"]}], ",", 
     RowBox[{"2.`", "\[VeryThinSpace]", "+", 
      FractionBox["lineThickness", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.506738472969624*^9}]
}, Open  ]],

Cell[BoxData["Quit"], "Input",
 CellChangeTimes->{{3.506738487521331*^9, 3.506738488791524*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "=", 
  RowBox[{"GraphData", "[", "\"\<IcosahedralGraph\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.5067385388524933`*^9, 3.506738544918734*^9}}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}, {Null, 
       SparseArray[
       Automatic, {12, 12}, 0, {
        1, {{0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60}, {{3}, {5}, {
          6}, {9}, {10}, {4}, {7}, {8}, {11}, {12}, {1}, {7}, {8}, {9}, {
          10}, {2}, {5}, {6}, {11}, {12}, {1}, {4}, {6}, {9}, {11}, {1}, {
          4}, {5}, {10}, {12}, {2}, {3}, {8}, {9}, {11}, {2}, {3}, {7}, {
          10}, {12}, {1}, {3}, {5}, {7}, {11}, {1}, {3}, {6}, {8}, {12}, {
          2}, {4}, {5}, {7}, {9}, {2}, {4}, {6}, {8}, {10}}}, Pattern}]}, {
      VertexCoordinates -> {{0., -0.314}, {0., 3.602}, {0., -1.165}, {0., 
        0.78}, {0.272, 0.157}, {-0.272, 0.157}, {
        3.12, -1.801}, {-3.12, -1.801}, {0.675, -0.39}, {-0.675, -0.39}, {
        1.009, 0.583}, {-1.009, 0.583}}}]], Typeset`boxes = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        DiskBox[{0., -0.314}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$1"], 
       TagBox[
        DiskBox[{0., 3.602}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$2"], 
       TagBox[
        DiskBox[{0., -1.165}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$3"], 
       TagBox[
        DiskBox[{0., 0.78}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$4"], 
       TagBox[
        DiskBox[{0.272, 0.157}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$5"], 
       TagBox[
        DiskBox[{-0.272, 0.157}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$6"], 
       TagBox[
        DiskBox[{3.12, -1.801}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$7"], 
       TagBox[
        DiskBox[{-3.12, -1.801}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$8"], 
       TagBox[
        DiskBox[{0.675, -0.39}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$9"], 
       TagBox[
        DiskBox[{-0.675, -0.39}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$10"], 
       TagBox[
        DiskBox[{1.009, 0.583}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$11"], 
       TagBox[
        DiskBox[{-1.009, 0.583}, 0.049699097291875605`], "DynamicName", BoxID -> 
        "VertexID$12"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}, {
          DynamicLocation["VertexID$6", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$6", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}, {
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}, {
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}, {
          DynamicLocation["VertexID$9", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}, {
          DynamicLocation["VertexID$10", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{6.179999999999993, 
      352.81999999999994`}, {-153.10719999999995`, 148.0294775795126}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.506738551304563*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "=", 
  RowBox[{"GridGraph", "[", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.506738556434457*^9, 3.506738559724411*^9}}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9}, {Null, 
       SparseArray[
       Automatic, {9, 9}, 0, {
        1, {{0, 2, 5, 7, 10, 14, 17, 19, 22, 24}, {{4}, {2}, {1}, {3}, {5}, {
          2}, {6}, {1}, {5}, {7}, {2}, {4}, {6}, {8}, {3}, {5}, {9}, {4}, {
          8}, {5}, {7}, {9}, {6}, {8}}}, Pattern}]}, {
      VertexCoordinates -> {{0., 0.}, {0., 1.}, {0., 2.}, {1., 0.}, {1., 
        1.}, {1., 2.}, {2., 0.}, {2., 1.}, {2., 2.}}}]], Typeset`boxes = 
    GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        DiskBox[{0., 0.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$1"], 
       TagBox[
        DiskBox[{0., 1.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$2"], 
       TagBox[
        DiskBox[{0., 2.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$3"], 
       TagBox[
        DiskBox[{1., 0.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$4"], 
       TagBox[
        DiskBox[{1., 1.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$5"], 
       TagBox[
        DiskBox[{1., 2.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$6"], 
       TagBox[
        DiskBox[{2., 0.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$7"], 
       TagBox[
        DiskBox[{2., 1.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$8"], 
       TagBox[
        DiskBox[{2., 2.}, 0.02261146496815286], "DynamicName", BoxID -> 
        "VertexID$9"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$6", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{6.180000000000001, 352.82}, {-176.10720000000003`, 
      170.5327999999999}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{3.506738560095826*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"jnodes", ",", "jedges"}], "}"}], "=", 
   RowBox[{"findTreeDecomposition", "@", "g"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.506738561573017*^9, 3.5067385679471693`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"initGraph", "[", 
  RowBox[{"GridGraph", "[", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"makeClusterGraph", "[", 
  RowBox[{"g", ",", 
   RowBox[{"{", 
    RowBox[{"jnodes", ",", "jedges"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.506738577483561*^9, 3.506738584030464*^9}, {
  3.506739610148779*^9, 3.506739614537301*^9}}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{{6, 8, 9}, {1, 2, 3, 4}, {2, 3, 4, 5}, {3, 4, 5, 6}, {4, 5, 6, 
       7}, {5, 6, 7, 8}}, {Null, {{1, 6}, {2, 3}, {3, 4}, {4, 5}, {5, 6}}}, {
      VertexShapeFunction -> {$CellContext`vsf}, 
       VertexCoordinates -> {{1.6667572784502263`, 1.7441803185357225`}, {
        0.014760372028896759`, 0.7352396339897076}, {0.720479345410603, 
        0.7795207430772806}, {0.7647602323502437, 1.4852397503698853`}, {
        1.0839786139926582`, 0.6354125108116571}, {1.6659308244340387`, 
        1.0370737098824139`}}}]], Typeset`boxes = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.9372549019607843, 0.8705882352941177, 0.803921568627451], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             Line[{{2., 1.}, {2., 2.}, {1., 2.}}], CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{1., 2.}, 0.2], 
                InsetBox["6", {1., 2.}]}, {
                GrayLevel[0], 
                CircleBox[{2., 1.}, 0.2], 
                InsetBox["8", {2., 1.}]}, {
                GrayLevel[0], 
                CircleBox[{2., 2.}, 0.2], 
                InsetBox["9", {2., 2.}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{1.2333333333333334`, 2.}, {1.7666666666666666`, 
                2.}}, {{2., 1.2333333333333334`}, {2., 
                1.7666666666666666`}}}]}}], {}}}, {
          PlotRange -> {{0.5, 2.5}, {0.5, 2.5}}, ImageSize -> {60., 60.}}], {
         1.6667572784502263`, 1.7441803185357225`}], "DynamicName", BoxID -> 
        "VertexID$1"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.803921568627451, 0.5843137254901961, 0.4588235294117647], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             Line[{{1., 0.}, {0., 2.}, {0., 0.}}], CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., 0.}, 0.2], 
                InsetBox["1", {0., 0.}]}, {
                GrayLevel[0], 
                CircleBox[{0., 1.}, 0.2], 
                InsetBox["2", {0., 1.}]}, {
                GrayLevel[0], 
                CircleBox[{0., 2.}, 0.2], 
                InsetBox["3", {0., 2.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 0.}, 0.2], 
                InsetBox["4", {1., 0.}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{5.551115123125783*^-17, 0.2333333333333334}, {
                5.551115123125783*^-17, 0.7666666666666666}}, {{
                0.2333333333333334, 0.}, {0.7666666666666666, 0.}}, {{
                5.551115123125783*^-17, 1.2333333333333334`}, {
                5.551115123125783*^-17, 1.7666666666666666`}}}]}}], {}}}, {
          PlotRange -> {{-0.5, 1.5}, {-0.5, 2.5}}, 
           ImageSize -> {60., 90.}}], {0.014760372028896759`, 
         0.7352396339897076}], "DynamicName", BoxID -> "VertexID$2"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.9921568627450981, 0.8509803921568627, 0.7098039215686275], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             Line[{{1., 0.}, {1., 1.}, {0., 2.}, {0., 1.}}], CurveClosed -> 
             True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., 1.}, 0.2], 
                InsetBox["2", {0., 1.}]}, {
                GrayLevel[0], 
                CircleBox[{0., 2.}, 0.2], 
                InsetBox["3", {0., 2.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 0.}, 0.2], 
                InsetBox["4", {1., 0.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 1.}, 0.2], 
                InsetBox["5", {1., 1.}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{5.551115123125783*^-17, 1.2333333333333334`}, {
                5.551115123125783*^-17, 1.7666666666666666`}}, {{
                0.2333333333333334, 1.}, {0.7666666666666666, 1.}}, {{1., 
                0.2333333333333334}, {1., 0.7666666666666666}}}]}}], {}}}, {
          PlotRange -> {{-0.5, 1.5}, {-0.5, 2.5}}, 
           ImageSize -> {60., 90.}}], {0.720479345410603, 
         0.7795207430772806}], "DynamicName", BoxID -> "VertexID$3"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.47058823529411764`, 0.8588235294117647, 0.8862745098039215], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             Line[{{1., 0.}, {1., 2.}, {0., 2.}}], CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., 2.}, 0.2], 
                InsetBox["3", {0., 2.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 0.}, 0.2], 
                InsetBox["4", {1., 0.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 1.}, 0.2], 
                InsetBox["5", {1., 1.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 2.}, 0.2], 
                InsetBox["6", {1., 2.}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{0.2333333333333334, 2.}, {0.7666666666666666, 
                2.}}, {{1., 0.2333333333333334}, {1., 0.7666666666666666}}, {{
                1., 1.2333333333333334`}, {1., 
                1.7666666666666666`}}}]}}], {}}}, {
          PlotRange -> {{-0.5, 1.5}, {-0.5, 2.5}}, 
           ImageSize -> {60., 90.}}], {0.7647602323502437, 
         1.4852397503698853`}], "DynamicName", BoxID -> "VertexID$4"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.5294117647058824, 0.6627450980392157, 0.4196078431372549], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             Line[{{2., 0.}, {1., 2.}, {1., 0.}}], CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{1., 0.}, 0.2], 
                InsetBox["4", {1., 0.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 1.}, 0.2], 
                InsetBox["5", {1., 1.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 2.}, 0.2], 
                InsetBox["6", {1., 2.}]}, {
                GrayLevel[0], 
                CircleBox[{2., 0.}, 0.2], 
                InsetBox["7", {2., 0.}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{1., 0.2333333333333334}, {1., 
                0.7666666666666666}}, {{1.2333333333333334`, 0.}, {
                1.7666666666666666`, 0.}}, {{1., 1.2333333333333334`}, {1., 
                1.7666666666666666`}}}]}}], {}}}, {
          PlotRange -> {{0.5, 2.5}, {-0.5, 2.5}}, ImageSize -> {60., 90.}}], {
         1.0839786139926582`, 0.6354125108116571}], "DynamicName", BoxID -> 
        "VertexID$5"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[1., 0.6431372549019608, 0.4549019607843137], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             Line[{{2., 0.}, {2., 1.}, {1., 2.}, {1., 1.}}], CurveClosed -> 
             True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{1., 1.}, 0.2], 
                InsetBox["5", {1., 1.}]}, {
                GrayLevel[0], 
                CircleBox[{1., 2.}, 0.2], 
                InsetBox["6", {1., 2.}]}, {
                GrayLevel[0], 
                CircleBox[{2., 0.}, 0.2], 
                InsetBox["7", {2., 0.}]}, {
                GrayLevel[0], 
                CircleBox[{2., 1.}, 0.2], 
                InsetBox["8", {2., 1.}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{1., 1.2333333333333334`}, {1., 
                1.7666666666666666`}}, {{1.2333333333333334`, 1.}, {
                1.7666666666666666`, 1.}}, {{2., 0.2333333333333334}, {2., 
                0.7666666666666666}}}]}}], {}}}, {
          PlotRange -> {{0.5, 2.5}, {-0.5, 2.5}}, ImageSize -> {60., 90.}}], {
         1.6659308244340387`, 1.0370737098824139`}], "DynamicName", BoxID -> 
        "VertexID$6"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{29.999999999999993`, 329.}, {-127.99999999999997`, 
      107.40920235141559`}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.506738584722834*^9, 3.506739175603868*^9, {3.506739300618524*^9, 
   3.506739319277255*^9}, {3.506739568051983*^9, 3.506739580285564*^9}, 
   3.506739615844994*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"initGraph", "[", 
   RowBox[{"GraphData", "[", "\"\<IcosahedralGraph\>\"", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"makeClusterGraph", "[", 
  RowBox[{"g", ",", 
   RowBox[{"{", 
    RowBox[{"jnodes", ",", "jedges"}], "}"}], ",", "3"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5067396664604053`*^9, 3.506739673217594*^9}, {
  3.506739788539905*^9, 3.5067398328994083`*^9}, {3.50673986643417*^9, 
  3.5067398846865253`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "incst"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(NMinimize\\)\[NoBreak] was unable to \
generate any initial points satisfying the inequality constraints \
\[NoBreak]\\!\\({\\(\\(\\(\\(3 - \\((\\(\\(xcl[2]\\)\\) - \\(\\(xcl[3]\\)\\))\
\\)\\^2 - \\((\\(\\(ycl[2]\\)\\) - \\(\\(ycl[3]\\)\\))\\)\\^2\\)\\) \
\[LessEqual] 0\\)\\), \\(\\(\\(\\(3 - \\((\\(\\(xcl[3]\\)\\) - \
\\(\\(xcl[4]\\)\\))\\)\\^2 - \\((\\(\\(ycl[3]\\)\\) - \
\\(\\(ycl[4]\\)\\))\\)\\^2\\)\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(3 - \
\\((\\(\\(xcl[1]\\)\\) - \\(\\(xcl[5]\\)\\))\\)\\^2 - \\((\\(\\(ycl[1]\\)\\) \
- \\(\\(ycl[5]\\)\\))\\)\\^2\\)\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(3 - \\((\
\\(\\(xcl[4]\\)\\) - \\(\\(xcl[6]\\)\\))\\)\\^2 - \\((\\(\\(ycl[4]\\)\\) - \
\\(\\(ycl[6]\\)\\))\\)\\^2\\)\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(3 - \
\\((\\(\\(xcl[5]\\)\\) - \\(\\(xcl[6]\\)\\))\\)\\^2 - \\((\\(\\(ycl[5]\\)\\) \
- \\(\\(ycl[6]\\)\\))\\)\\^2\\)\\) \[LessEqual] 0\\)\\)}\\)\[NoBreak]. The \
initial region specified may not contain any feasible points. Changing the \
initial region or specifying explicit initial points may provide a better \
solution. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/NMinimize/incst\\\", ButtonNote -> \
\\\"NMinimize::incst\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.5067398775864687`*^9, 3.506739885209643*^9}}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{{1, 3, 5, 6, 9, 10}, {2, 4, 6, 8, 10, 12}, {2, 3, 4, 6, 7, 8, 
       10}, {2, 3, 4, 6, 7, 10, 11}, {3, 4, 5, 6, 9, 10, 11}, {3, 4, 6, 7, 9, 
       10, 11}}, {Null, {{1, 5}, {2, 3}, {3, 4}, {4, 6}, {5, 6}}}, {
      VertexShapeFunction -> {$CellContext`vsf}, 
       VertexCoordinates -> {{-0.07671867465408833, -0.9128190792040121}, \
{-1.0194823511160083`, 
        0.7709871058777854}, {-0.11306784842459192`, -0.7049579786477557}, {
        0.6011629967129075, 0.8729758830387658}, {0.14712530478773203`, 
        0.8047065836072672}, {0.6294091441226201, -0.8588448956244317}}}]], 
    Typeset`boxes = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.9372549019607843, 0.8705882352941177, 0.803921568627451], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             
             Line[{{0.675, -0.39}, {0.272, 0.157}, {-0.272, 
              0.157}, {-0.675, -0.39}, {0., -1.165}}], CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., -0.314}, 0.25], 
                InsetBox["1", {0., -0.314}]}, {
                GrayLevel[0], 
                CircleBox[{0., -1.165}, 0.25], 
                InsetBox["3", {0., -1.165}]}, {
                GrayLevel[0], 
                CircleBox[{0.272, 0.157}, 0.25], 
                InsetBox["5", {0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{-0.272, 0.157}, 0.25], 
                InsetBox["6", {-0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{0.675, -0.39}, 0.25], 
                InsetBox["9", {0.675, -0.39}]}, {
                GrayLevel[0], 
                CircleBox[{-0.675, -0.39}, 0.25], 
                InsetBox["10", {-0.675, -0.39}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               LineBox[CompressedData["
1:eJxTTMoPSmVmYGDgAmImKIaADTZBbvmno2Qf74fxLS5kMs81e7N/lwK/IKPy
IXu9JskvNZM27u/OMPJ/svaA/aOg+K8r523bvwYiv98AKl8Dkd//ACrvIqwR
+4flkr1By6ZT3+Sv7f8hz33NTO+mvRd/mmX8u2v7bSDy+/Wh8l8g8vth8qeW
FDjtunjcXjVNjS2j8N3+6w9+CYZ53bdf2M8Uph74eP8eiPx+mPwliPx+mHzD
Bm2Hd6bt+6uy9pRMljhi37ARzLeH8Sc/7O94o3nHviXWequtyab9itxJa+9Y
PLDfbBF3/tKOI/v7IPL7YfLyEPn9W6DyAHFqnco=
                "]]}}], {}}}, {
          PlotRange -> {{-1.175, 1.175}, {-1.665, 0.657}}, 
           ImageSize -> {70.5, 
            69.66}}], {-0.07671867465408833, -0.9128190792040121}], 
        "DynamicName", BoxID -> "VertexID$1"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.803921568627451, 0.5843137254901961, 0.4588235294117647], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             
             Line[{{0., 0.78}, {0., 
              3.602}, {-3.12, -1.801}, {-0.675, -0.39}, {-0.272, 0.157}}], 
             CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., 3.602}, 0.25], 
                InsetBox["2", {0., 3.602}]}, {
                GrayLevel[0], 
                CircleBox[{0., 0.78}, 0.25], 
                InsetBox["4", {0., 0.78}]}, {
                GrayLevel[0], 
                CircleBox[{-0.272, 0.157}, 0.25], 
                InsetBox["6", {-0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{-3.12, -1.801}, 0.25], 
                InsetBox["8", {-3.12, -1.801}]}, {
                GrayLevel[0], 
                CircleBox[{-0.675, -0.39}, 0.25], 
                InsetBox["10", {-0.675, -0.39}]}, {
                GrayLevel[0], 
                CircleBox[{-1.009, 0.583}, 0.25], 
                InsetBox["12", {-1.009, 0.583}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               LineBox[CompressedData["
1:eJxTTMoPSmVmYGDgAmImKIaADXu+uPyVXtjD5QDjs8w1u5DJ/NHezu7btWNK
h/ZLmfrsT7nF5SBy9I3itMvsB34+CJN78vjH/ge8ksGP/m7b31cxv653FZfD
MdlLwv8y3+7flW+l4u/42j6x0E97B+ve/RffX78yfdkD+xkBs7w4/Y7s712e
pj9/1S17sX2XfaXPXNzP1Zfa8cfiuX1lgvf2NcnP9/87vmLJ1pQn9lMf9ne8
0byzPynWequtyab9KtxJa+9YPNi/wiLu/KUdR/a/K+KZva/3wf4L+qb74+Qv
2z/Ss5Q2LXixf0Z8r9kpmzv2dtf6r+j+Zzvw73u85qWeX/tbn5xqeVP8dv8z
s8Kt7MwP9xszcrKIlLIfuOQq5cmZ83O/5/sDrlZqn/fP8Dl+L2/PdXuLU5em
6Xe/2P9ir0VWrs3+/U/5/iSoRLzdvzphGpuF5hV7AFdlpV4=
                
                "]]}}], {}}}, {
          PlotRange -> {{-3.62, 0.5}, {-2.301, 4.102}}, 
           ImageSize -> {123.60000000000001`, 
            192.09}}], {-1.0194823511160083`, 0.7709871058777854}], 
        "DynamicName", BoxID -> "VertexID$2"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.9921568627450981, 0.8509803921568627, 0.7098039215686275], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             Line[{{3.12, -1.801}, {0., 3.602}, {-3.12, -1.801}}], 
             CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., 3.602}, 0.25], 
                InsetBox["2", {0., 3.602}]}, {
                GrayLevel[0], 
                CircleBox[{0., -1.165}, 0.25], 
                InsetBox["3", {0., -1.165}]}, {
                GrayLevel[0], 
                CircleBox[{0., 0.78}, 0.25], 
                InsetBox["4", {0., 0.78}]}, {
                GrayLevel[0], 
                CircleBox[{-0.272, 0.157}, 0.25], 
                InsetBox["6", {-0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{3.12, -1.801}, 0.25], 
                InsetBox["7", {3.12, -1.801}]}, {
                GrayLevel[0], 
                CircleBox[{-3.12, -1.801}, 0.25], 
                InsetBox["8", {-3.12, -1.801}]}, {
                GrayLevel[0], 
                CircleBox[{-0.675, -0.39}, 0.25], 
                InsetBox["10", {-0.675, -0.39}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               LineBox[CompressedData["
1:eJxTTMoPSmVmYGDgAmImKIaAA3u+uPyVXtjD5QDjs8w1u5DJ/NFe2e7btWNK
h+ylTH32p9zichA6+kZx2mV2h58PwuSePP6x3xkivx8mLwKRPwCT/396l/30
IxftM5ovL1/S/Xl/yfmU5fp72RyKylYfEn/5ez//GbD8fph8GUT+AEz+9JIC
p10Xj+9XSVNjyyh8t//Wg1+CYV7398/pZwpTD3y8P7PQT3sH6979F99fvzJ9
2QP7OQGzvDj9juzvW56mP3/VLfspD/s73mje2Z8Wa73V1mTTfmXupLV3LB7s
X2kRd/7SjiP7Nz4R967byOZg1umY8PTCn/2bIfwDML7ttf4ruv/ZDvz/Hq95
qefX/qYnp1reFL/d/8yscCs788P9AKSfrFs=
                "]]}}], {}}}, {
          PlotRange -> {{-3.62, 3.62}, {-2.301, 4.102}}, 
           ImageSize -> {217.20000000000002`, 
            192.09}}], {-0.11306784842459192`, -0.7049579786477557}], 
        "DynamicName", BoxID -> "VertexID$3"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.47058823529411764`, 0.8588235294117647, 0.8862745098039215], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             
             Line[{{3.12, -1.801}, {0., 3.602}, {-0.675, -0.39}, {
              0., -1.165}}], CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., 3.602}, 0.25], 
                InsetBox["2", {0., 3.602}]}, {
                GrayLevel[0], 
                CircleBox[{0., -1.165}, 0.25], 
                InsetBox["3", {0., -1.165}]}, {
                GrayLevel[0], 
                CircleBox[{0., 0.78}, 0.25], 
                InsetBox["4", {0., 0.78}]}, {
                GrayLevel[0], 
                CircleBox[{-0.272, 0.157}, 0.25], 
                InsetBox["6", {-0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{3.12, -1.801}, 0.25], 
                InsetBox["7", {3.12, -1.801}]}, {
                GrayLevel[0], 
                CircleBox[{-0.675, -0.39}, 0.25], 
                InsetBox["10", {-0.675, -0.39}]}, {
                GrayLevel[0], 
                CircleBox[{1.009, 0.583}, 0.25], 
                InsetBox["11", {1.009, 0.583}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{2.220446049250313*^-16, 3.318666666666667}, {
                2.220446049250313*^-16, 1.063333333333334}}, {{
                0.1416863011950102, 3.3566374726421033`}, {
                2.9783136988049908`, -1.5556374726421027`}}, {{
                0.08981146363026182, 3.3332776920715963`}, {
                0.9191885363697389, 0.8517223079284041}}, {{
                0.2776239511833304, -1.2215925746642935`}, {
                2.842376048816671, -1.7444074253357056`}}, \
{{-0.18608787769452373`, -0.9513435478322126}, {-0.4889121223054761, \
-0.6036564521677862}}, {{-0.11336852128301168`, 
                0.5203360707378075}, {-0.15863147871698796`, 
                0.4166639292621927}}, {{0.27808268165878874`, 
                0.7257063545225164}, {0.7309173183412119, 
                0.6372936454774842}}, {{-0.44005883537422436`, \
-0.07110963511091986}, {-0.5069411646257755, -0.1618903648890798}}, {{
                2.9321670832870494`, -1.5888760428973583`}, {
                1.1968329167129517`, 0.37087604289735887`}}}]}}], {}}}, {
          PlotRange -> {{-1.175, 3.62}, {-2.301, 4.102}}, 
           ImageSize -> {143.85, 192.09}}], {0.6011629967129075, 
         0.8729758830387658}], "DynamicName", BoxID -> "VertexID$4"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[
            0.5294117647058824, 0.6627450980392157, 0.4196078431372549], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             
             Line[{{1.009, 0.583}, {0., 0.78}, {-0.675, -0.39}, {
              0., -1.165}, {0.675, -0.39}}], CurveClosed -> True]}, {
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., -1.165}, 0.25], 
                InsetBox["3", {0., -1.165}]}, {
                GrayLevel[0], 
                CircleBox[{0., 0.78}, 0.25], 
                InsetBox["4", {0., 0.78}]}, {
                GrayLevel[0], 
                CircleBox[{0.272, 0.157}, 0.25], 
                InsetBox["5", {0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{-0.272, 0.157}, 0.25], 
                InsetBox["6", {-0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{0.675, -0.39}, 0.25], 
                InsetBox["9", {0.675, -0.39}]}, {
                GrayLevel[0], 
                CircleBox[{-0.675, -0.39}, 0.25], 
                InsetBox["10", {-0.675, -0.39}]}, {
                GrayLevel[0], 
                CircleBox[{1.009, 0.583}, 0.25], 
                InsetBox["11", {1.009, 0.583}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               LineBox[CompressedData["
1:eJxTTMoPSmVmYGDgAmImKN6zpMBp18Xj9ippamwZhe/2X3rwSzDM6779/H6m
MPXAx/sPQ+T3w+SvQOT3w+StCv20d7Dutb/y/vqV6cse2HcHzPLi9Dti37U8
TX/+qlv2vhD5/TD5aRD5/Z1Qed59l32lz1y05+5L7fhj8dy+JMF7+5rk5/Z/
j69YsjXliX3DRm2Hd6bt+5uy9pRMljhirwDh28P4XQ/7O95o3rHPibXeamuy
ab88d9LaOxYP7DdbxJ2/tOPI/pdFPLP39T6wP6dvuj9O/rL9HT1LadOCF/ZT
4nvNTtncsZ8A0b+/DKpfAaJ//waofuNTl6bpd7+w/7HXIivXZv/+B3x/ElQi
3tqvTJjGZqF5xR4A4lylAg==
                "]]}}], {}}}, {
          PlotRange -> {{-1.175, 1.509}, {-1.665, 1.28}}, 
           ImageSize -> {80.52000000000001, 88.35000000000001}}], {
         0.14712530478773203`, 0.8047065836072672}], "DynamicName", BoxID -> 
        "VertexID$5"], 
       TagBox[
        InsetBox[
         GraphicsBox[{{
            RGBColor[1., 0.6431372549019608, 0.4549019607843137], 
            AbsoluteThickness[15], 
            JoinForm["Round"], 
            JoinedCurveBox[
             
             Line[{{3.12, -1.801}, {1.009, 0.583}, {0., 
              0.78}, {-0.675, -0.39}, {0., -1.165}}], CurveClosed -> True]}, {
           
            GraphicsGroupBox[{{
               Hue[0.6, 0.2, 0.8], 
               EdgeForm[{
                 GrayLevel[0], 
                 Opacity[0.7]}], {
                GrayLevel[0], 
                CircleBox[{0., -1.165}, 0.25], 
                InsetBox["3", {0., -1.165}]}, {
                GrayLevel[0], 
                CircleBox[{0., 0.78}, 0.25], 
                InsetBox["4", {0., 0.78}]}, {
                GrayLevel[0], 
                CircleBox[{-0.272, 0.157}, 0.25], 
                InsetBox["6", {-0.272, 0.157}]}, {
                GrayLevel[0], 
                CircleBox[{3.12, -1.801}, 0.25], 
                InsetBox["7", {3.12, -1.801}]}, {
                GrayLevel[0], 
                CircleBox[{0.675, -0.39}, 0.25], 
                InsetBox["9", {0.675, -0.39}]}, {
                GrayLevel[0], 
                CircleBox[{-0.675, -0.39}, 0.25], 
                InsetBox["10", {-0.675, -0.39}]}, {
                GrayLevel[0], 
                CircleBox[{1.009, 0.583}, 0.25], 
                InsetBox["11", {1.009, 0.583}]}}, {
               Hue[0.6, 0.7, 0.5], 
               Opacity[0.7], 
               
               LineBox[{{{0.27762395118333016`, -1.2215925746642937`}, {
                2.84237604881667, -1.7444074253357056`}}, {{
                0.1860878776945239, -0.951343547832213}, {
                0.48891212230547604`, -0.6036564521677866}}, \
{{-0.1860878776945239, -0.951343547832213}, {-0.4889121223054761, \
-0.6036564521677866}}, {{-0.11336852128301202`, 
                0.5203360707378071}, {-0.15863147871698813`, 
                0.41666392926219276`}}, {{0.2780826816587885, 
                0.725706354522516}, {0.7309173183412114, 
                0.6372936454774839}}, {{-0.4400588353742245, \
-0.07110963511092}, {-0.5069411646257757, -0.16189036488907993`}}, {{
                2.8745991331477665`, -1.6593801132398764`}, {
                0.9204008668522334, -0.5316198867601233}}, {{
                2.932167083287049, -1.5888760428973585`}, {
                1.1968329167129512`, 0.37087604289735854`}}, {{
                0.766990465714406, -0.12201579898168541`}, {
                0.9170095342855938, 0.31501579898168536`}}}]}}], {}}}, {
          PlotRange -> {{-1.175, 3.62}, {-2.301, 1.28}}, 
           ImageSize -> {143.85, 107.43}}], {
         0.6294091441226201, -0.8588448956244317}], "DynamicName", BoxID -> 
        "VertexID$6"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{108.39999999999996`, 325.4}, {-122.04499999999999`, 
      116.95500000000001`}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.506739674852622*^9, {3.506739785923071*^9, 3.506739834274218*^9}, {
   3.506739874687011*^9, 3.5067398880282497`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["vcoords"], "Input",
 CellChangeTimes->{{3.506739903410926*^9, 3.5067399040617123`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.`", ",", 
      RowBox[{"-", "0.314`"}]}], "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.`", ",", "3.602`"}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.`", ",", 
      RowBox[{"-", "1.165`"}]}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.`", ",", "0.78`"}], "}"}]}], ",", 
   RowBox[{"5", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.272`", ",", "0.157`"}], "}"}]}], ",", 
   RowBox[{"6", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.272`"}], ",", "0.157`"}], "}"}]}], ",", 
   RowBox[{"7", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3.12`", ",", 
      RowBox[{"-", "1.801`"}]}], "}"}]}], ",", 
   RowBox[{"8", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "3.12`"}], ",", 
      RowBox[{"-", "1.801`"}]}], "}"}]}], ",", 
   RowBox[{"9", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0.675`", ",", 
      RowBox[{"-", "0.39`"}]}], "}"}]}], ",", 
   RowBox[{"10", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.675`"}], ",", 
      RowBox[{"-", "0.39`"}]}], "}"}]}], ",", 
   RowBox[{"11", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1.009`", ",", "0.583`"}], "}"}]}], ",", 
   RowBox[{"12", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1.009`"}], ",", "0.583`"}], "}"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.506739904480341*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"VertexList", "[", "g", "]"}], "/.", "vcoords"}]], "Input",
 CellChangeTimes->{{3.5067399233066177`*^9, 3.506739926769088*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "0.314`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "3.602`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", 
     RowBox[{"-", "1.165`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.78`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.272`", ",", "0.157`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.272`"}], ",", "0.157`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.12`", ",", 
     RowBox[{"-", "1.801`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "3.12`"}], ",", 
     RowBox[{"-", "1.801`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.675`", ",", 
     RowBox[{"-", "0.39`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.675`"}], ",", 
     RowBox[{"-", "0.39`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.009`", ",", "0.583`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.009`"}], ",", "0.583`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.50673992703452*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Point", "[", "%138", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.506739929668486*^9, 3.5067399363218*^9}}],

Cell[BoxData[
 GraphicsBox[
  PointBox[{{0., -0.314}, {0., 3.602}, {0., -1.165}, {0., 0.78}, {0.272, 
   0.157}, {-0.272, 0.157}, {3.12, -1.801}, {-3.12, -1.801}, {
   0.675, -0.39}, {-0.675, -0.39}, {1.009, 0.583}, {-1.009, 
   0.583}}]]], "Output",
 CellChangeTimes->{3.5067399366969967`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"gap", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"points", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.`", ",", 
       RowBox[{"-", "0.314`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.`", ",", "3.602`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.`", ",", 
       RowBox[{"-", "1.165`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.`", ",", "0.78`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.272`", ",", "0.157`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.272`"}], ",", "0.157`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.12`", ",", 
       RowBox[{"-", "1.801`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3.12`"}], ",", 
       RowBox[{"-", "1.801`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.675`", ",", 
       RowBox[{"-", "0.39`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.675`"}], ",", 
       RowBox[{"-", "0.39`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1.009`", ",", "0.583`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1.009`"}], ",", "0.583`"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "=", 
    RowBox[{"Length", "@", "points"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"objCl", "[", "k_", "]"}], ":=", 
   RowBox[{"Total", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"points", "[", 
        RowBox[{"[", "k", "]"}], "]"}], "-", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"x", "[", "k", "]"}], ",", 
         RowBox[{"y", "[", "k", "]"}]}], "}"}]}], ")"}], "^", "2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"consCl", "[", 
    RowBox[{"j_", ",", "k_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "j", "]"}], "-", 
        RowBox[{"x", "[", "k", "]"}]}], ")"}], "^", "2"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "j", "]"}], "-", 
        RowBox[{"y", "[", "k", "]"}]}], ")"}], "^", "2"}]}], ">", "gap"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"varList", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x", "[", "#", "]"}], ",", 
       RowBox[{"y", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
    RowBox[{"Range", "[", "n", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Flatten", "[", "varList", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"obj", "=", 
   RowBox[{"Total", "[", 
    RowBox[{"objCl", "/@", 
     RowBox[{"Range", "[", "n", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"cons", "=", 
    RowBox[{"Flatten", "@", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"consCl", "[", 
          RowBox[{"i", ",", "j"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"i", "+", "1"}], ",", "n"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"Minimize", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"obj", ",", "cons"}], "}"}], ",", "vars"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"newPoints", "=", 
    RowBox[{"varList", "/.", 
     RowBox[{"Last", "@", "sol"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"dist", "[", 
     RowBox[{"j_", ",", "k_", ",", "p_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "1"}], "]"}], "]"}], "-", 
        RowBox[{"p", "[", 
         RowBox[{"[", 
          RowBox[{"k", ",", "1"}], "]"}], "]"}]}], ")"}], "^", "2"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"p", "[", 
         RowBox[{"[", 
          RowBox[{"j", ",", "2"}], "]"}], "]"}], "-", 
        RowBox[{"p", "[", 
         RowBox[{"[", 
          RowBox[{"k", ",", "2"}], "]"}], "]"}]}], ")"}], "^", "2"}]}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"check", " ", "old", " ", "distances"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"oldDists", "=", 
   RowBox[{"Sort", "@", 
    RowBox[{"Flatten", "@", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"dist", "[", 
          RowBox[{"i", ",", "j", ",", "points"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"i", "+", "1"}], ",", "n"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"newDists", "=", 
    RowBox[{"Sort", "@", 
     RowBox[{"Flatten", "@", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"dist", "[", 
           RowBox[{"i", ",", "j", ",", "newPoints"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"i", "+", "1"}], ",", "n"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}]}]}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Plot", " ", "old", " ", "and", " ", "new", " ", "points"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"Graphics", "[", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Arrow", "[", 
      RowBox[{"{", 
       RowBox[{"#1", ",", "#2"}], "}"}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{"points", ",", "newPoints"}], "}"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.506739960869155*^9, 3.506739965612691*^9}, {
  3.506740136415389*^9, 3.506740140293831*^9}, {3.506740368836276*^9, 
  3.5067404026085033`*^9}, {3.5067405014694443`*^9, 3.506740611187503*^9}, {
  3.5067406484140787`*^9, 3.506740653905657*^9}, {3.506740707598119*^9, 
  3.506740752217431*^9}, {3.506740805555251*^9, 3.5067408699542713`*^9}, {
  3.5067409618277082`*^9, 3.5067409809797773`*^9}, {3.5067410172967873`*^9, 
  3.506741017948842*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "incst"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(NMinimize\\)\[NoBreak] was unable to \
generate any initial points satisfying the inequality constraints \
\[NoBreak]\\!\\({\\(\\(\\(\\(1 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[2]\\)\\)\\)\\) - \\(x[2]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[2]\\)\\)\\)\\) - \\(y[2]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1 - \\(x[2]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[2]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[2]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[2]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 45 \[RightSkeleton]\\)\\), \
\\(\\(\\(\\(1 - \\(x[4]\\)\\^2 + \\(\\(2\\\\ \\(\\(x[4]\\)\\)\\\\ \\(\\(x[11]\
\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \\(y[4]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(y[4]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \\(y[11]\\)\\^2\\)\\) \
\[LessEqual] 0\\)\\), \\(\\(\\(\\(1 - \\(x[5]\\)\\^2 + \\(\\(2\\\\ \\(\\(x[5]\
\\)\\)\\\\ \\(\\(x[11]\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \\(y[5]\\)\\^2 + \
\\(\\(2\\\\ \\(\\(y[5]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \\(y[11]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 16 \[RightSkeleton]\\)\\)}\\)\
\[NoBreak]. The initial region specified may not contain any feasible points. \
Changing the initial region or specifying explicit initial points may provide \
a better solution. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\
\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/NMinimize/incst\\\", ButtonNote -> \
\\\"NMinimize::incst\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.5067406120166407`*^9, 3.506740655332382*^9, 3.506740754652075*^9, {
   3.506740816535688*^9, 3.50674087125314*^9}, {3.5067409628524847`*^9, 
   3.506740981751452*^9}, 3.506741019020521*^9}],

Cell[BoxData[
 GraphicsBox[{
   ArrowBox[{{0., -0.314}, {-2.8589873058303465`*^-6, -0.5773769474887684}}], 
   ArrowBox[{{0., 3.602}, {-2.8348999742456848`*^-8, 3.601999954498233}}], 
   ArrowBox[{{0., -1.165}, {1.4166769159370987`*^-6, -1.5773769520432317`}}], 
   ArrowBox[{{0., 0.78}, {-1.5248643594779189`*^-6, 1.1546739067026548`}}], 
   ArrowBox[{{0.272, 0.157}, {0.4999977748625354, 0.2886480919120515}}], 
   ArrowBox[{{-0.272, 0.157}, {-0.500002227812843, 0.28864885185415673`}}], 
   ArrowBox[{{3.12, -1.801}, {3.119999973774666, -1.8010000554604602`}}], 
   ArrowBox[{{-3.12, -1.801}, {-3.1200000137806794`, -1.80099998364974}}], 
   ArrowBox[{{0.675, -0.39}, {0.9999971735369106, -0.5773776638062064}}], 
   ArrowBox[{{-0.675, -0.39}, {-1.0000028693608527`, -0.5773761808797045}}], 
   ArrowBox[{{1.009, 0.583}, {1.3656701167312904`, 0.7892591238356198}}], 
   ArrowBox[{{-1.009, 0.583}, {-1.3656744654031185`, 
    0.7892600567980829}}]}]], "Output",
 CellChangeTimes->{{3.506740505460229*^9, 3.506740543533238*^9}, {
   3.5067405851336613`*^9, 3.506740619719184*^9}, 3.506740662987958*^9, 
   3.506740762282537*^9, 3.506740824225987*^9, 3.50674085630175*^9, 
   3.5067408948152018`*^9, {3.506740977875182*^9, 3.506740994689888*^9}, 
   3.5067410321384573`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{"Red", ",", 
    RowBox[{"Point", "[", "points", "]"}], ",", "Blue", ",", 
    RowBox[{"Point", "[", "newPoints", "]"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.506740774009534*^9, 3.5067407947129297`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1, 0, 0], 
    PointBox[{{0., -0.314}, {0., 3.602}, {0., -1.165}, {0., 0.78}, {0.272, 
     0.157}, {-0.272, 0.157}, {3.12, -1.801}, {-3.12, -1.801}, {
     0.675, -0.39}, {-0.675, -0.39}, {1.009, 0.583}, {-1.009, 0.583}}]}, 
   {RGBColor[0, 0, 1], 
    PointBox[{{-5.647729761964257*^-7, -0.4082488134107296}, \
{-7.317847470801064*^-9, 
     3.6019999729059213`}, {-7.17585815153488*^-9, -1.1650000087203052`}, \
{-3.932087947360898*^-7, 0.8164960738838453}, {0.3535529002054381, 
     0.20412357760025854`}, {-0.3535538833168284, 0.2041236828396517}, {
     3.119999976545448, -1.8010000134324053`}, {-3.1200000229118157`, \
-1.8010000131937458`}, {
     0.7071062321614906, -0.4082488938507433}, {-0.7071073526041256, \
-0.4082487119263799}, {1.0089999923916673`, 
     0.5829999912598275}, {-1.009000006905062, 
     0.5829999956557642}}]}}]], "Output",
 CellChangeTimes->{{3.506740791667444*^9, 3.506740795031399*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.506740446254731*^9, 3.5067404746600027`*^9}, {
  3.506740673114786*^9, 3.506740725573307*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.49999999787075744`", ",", "0.5000000023282347`", ",", 
   "0.5000000033032166`", ",", "0.5000000054886421`", ",", 
   "0.5000000055165682`", ",", "0.5000000093968965`", ",", 
   "0.5000000156807543`", ",", "0.5000000222709277`", ",", 
   "0.500000023217294`", ",", "0.5726723716027823`", ",", 
   "0.5731568813399748`", ",", "0.5731582274829201`", ",", 
   "1.072600638987111`", ",", "1.0726021987426428`", ",", 
   "1.0726714835661326`", ",", "1.0726733231578987`", ",", 
   "1.0737131750041358`", ",", "1.0737141946988649`", ",", 
   "1.4999999928701446`", ",", "1.5000000389542307`", ",", 
   "1.5000000532489148`", ",", "1.9994990529370495`", ",", 
   "1.9995000261250686`", ",", "2.000000015633751`", ",", 
   "2.0000000423946442`", ",", "2.000000063335648`", ",", 
   "2.0000977648338454`", ",", "2.000100321290343`", ",", 
   "2.000654075698603`", ",", "2.000656317119369`", ",", "3.926326725375744`",
    ",", "3.9275949847110327`", ",", "3.9275984111168474`", ",", 
   "4.0723239971616`", ",", "4.07358499905781`", ",", "4.073585014752273`", 
   ",", "7.759031971467338`", ",", "7.761807225606516`", ",", 
   "7.761811902783208`", ",", "10.13244186180345`", ",", 
   "10.132441888592915`", ",", "10.138895904414742`", ",", 
   "10.138896103882592`", ",", "10.139776955469827`", ",", 
   "10.139777109774979`", ",", "11.670563625828422`", ",", 
   "11.670563656193575`", ",", "11.673745279674641`", ",", 
   "11.673750041505913`", ",", "11.674152523283682`", ",", 
   "11.674159282989079`", ",", "16.08209532815448`", ",", 
   "16.08609052405506`", ",", "16.086097454715834`", ",", 
   "16.58209520723372`", ",", "16.582095311957005`", ",", 
   "16.585683455213484`", ",", "16.585688074382492`", ",", 
   "16.586497968052413`", ",", "16.586506696677112`", ",", 
   "22.724288824824445`", ",", "22.732096906666705`", ",", 
   "22.732097147610794`", ",", "38.92680875167893`", ",", 
   "38.92680894709937`", ",", "38.93759999322665`"}], "}"}]], "Output",
 CellChangeTimes->{3.506740700966151*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.506740476586314*^9, 3.506740490480773*^9}, {
  3.506740633897895*^9, 3.506740636617675*^9}, {3.506740682879444*^9, 
  3.506740698548533*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.49999999787075744`", ",", "0.5000000023282347`", ",", 
   "0.5000000033032166`", ",", "0.5000000054886421`", ",", 
   "0.5000000055165682`", ",", "0.5000000093968965`", ",", 
   "0.5000000156807543`", ",", "0.5000000222709277`", ",", 
   "0.500000023217294`", ",", "0.5726723716027823`", ",", 
   "0.5731568813399748`", ",", "0.5731582274829201`", ",", 
   "1.072600638987111`", ",", "1.0726021987426428`", ",", 
   "1.0726714835661326`", ",", "1.0726733231578987`", ",", 
   "1.0737131750041358`", ",", "1.0737141946988649`", ",", 
   "1.4999999928701446`", ",", "1.5000000389542307`", ",", 
   "1.5000000532489148`", ",", "1.9994990529370495`", ",", 
   "1.9995000261250686`", ",", "2.000000015633751`", ",", 
   "2.0000000423946442`", ",", "2.000000063335648`", ",", 
   "2.0000977648338454`", ",", "2.000100321290343`", ",", 
   "2.000654075698603`", ",", "2.000656317119369`", ",", "3.926326725375744`",
    ",", "3.9275949847110327`", ",", "3.9275984111168474`", ",", 
   "4.0723239971616`", ",", "4.07358499905781`", ",", "4.073585014752273`", 
   ",", "7.759031971467338`", ",", "7.761807225606516`", ",", 
   "7.761811902783208`", ",", "10.13244186180345`", ",", 
   "10.132441888592915`", ",", "10.138895904414742`", ",", 
   "10.138896103882592`", ",", "10.139776955469827`", ",", 
   "10.139777109774979`", ",", "11.670563625828422`", ",", 
   "11.670563656193575`", ",", "11.673745279674641`", ",", 
   "11.673750041505913`", ",", "11.674152523283682`", ",", 
   "11.674159282989079`", ",", "16.08209532815448`", ",", 
   "16.08609052405506`", ",", "16.086097454715834`", ",", 
   "16.58209520723372`", ",", "16.582095311957005`", ",", 
   "16.585683455213484`", ",", "16.585688074382492`", ",", 
   "16.586497968052413`", ",", "16.586506696677112`", ",", 
   "22.724288824824445`", ",", "22.732096906666705`", ",", 
   "22.732097147610794`", ",", "38.92680875167893`", ",", 
   "38.92680894709937`", ",", "38.93759999322665`"}], "}"}]], "Output",
 CellChangeTimes->{{3.506740486277566*^9, 3.5067404908470297`*^9}, 
   3.506740637715714*^9, {3.5067406869100513`*^9, 3.506740691734292*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Arrow", "[", 
      RowBox[{"{", 
       RowBox[{"#1", ",", "#2"}], "}"}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{"points", ",", "newPoints"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5067399842726297`*^9, 3.506740028477806*^9}, {
   3.506740063053561*^9, 3.506740070187549*^9}, {3.506740124592098*^9, 
   3.506740129705632*^9}, {3.506740304910595*^9, 3.506740354762759*^9}, 
   3.506740392276478*^9, {3.506740916969508*^9, 3.506740949013599*^9}}],

Cell[BoxData[
 GraphicsBox[{
   ArrowBox[{{0., -0.314}, {0.16052931007788512`, -1.5656011041189328`}}], 
   ArrowBox[{{0., 3.602}, {0.7884686089986199, 4.420012718961748}}], 
   ArrowBox[{{0., -1.165}, {-1.5032262860092542`, -3.05956139139956}}], 
   ArrowBox[{{0., 0.78}, {1.3623551660962017`, 2.116193930940105}}], 
   ArrowBox[{{0.272, 0.157}, {2.2862146621711905`, -2.2594755921405354`}}], 
   ArrowBox[{{-0.272, 0.157}, {-1.9651560468057307`, -0.8717266277273115}}], 
   ArrowBox[{{3.12, -1.801}, {4.245598541856667, -1.1820643634017753`}}], 
   ArrowBox[{{-3.12, -1.801}, {-3.7072524413272188`, -2.2735469375232853`}}], 
   ArrowBox[{{0.675, -0.39}, {1.8242849206447809`, -0.07164082875252366}}], 
   ArrowBox[{{-0.675, -0.39}, {-2.427085801287326, 1.3161081300904665`}}], 
   ArrowBox[{{1.009, 0.583}, {-0.7633301918510522, 2.810068411686395}}], 
   ArrowBox[{{-1.009, 0.583}, {-0.3014004425647524, 
    0.6222336533852117}}]}]], "Output",
 CellChangeTimes->{3.506740949491222*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.506740130488558*^9, 3.506740146405252*^9}, {
   3.50674028813529*^9, 3.506740292917472*^9}, 3.506740395598609*^9}],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.506740297234432*^9, 3.506740399511791*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "incst"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(NMinimize\\)\[NoBreak] was unable to \
generate any initial points satisfying the inequality constraints \
\[NoBreak]\\!\\({\\(\\(\\(\\(1\\/2 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[2]\\)\\)\\)\\) - \\(x[2]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[2]\\)\\)\\)\\) - \\(y[2]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[2]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[2]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[2]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[2]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 45 \[RightSkeleton]\\)\\), \
\\(\\(\\(\\(1\\/2 - \\(x[4]\\)\\^2 + \\(\\(2\\\\ \\(\\(x[4]\\)\\)\\\\ \
\\(\\(x[11]\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \\(y[4]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(y[4]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \\(y[11]\\)\\^2\\)\\) \
\[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[5]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[5]\\)\\)\\\\ \\(\\(x[11]\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \
\\(y[5]\\)\\^2 + \\(\\(2\\\\ \\(\\(y[5]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \
\\(y[11]\\)\\^2\\)\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 16 \
\[RightSkeleton]\\)\\)}\\)\[NoBreak]. The initial region specified may not \
contain any feasible points. Changing the initial region or specifying \
explicit initial points may provide a better solution. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/NMinimize/incst\\\", \
ButtonNote -> \\\"NMinimize::incst\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5067403602914248`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "nnum"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The function value \[NoBreak]\\!\\({1.5197066906035321`, \
10.59393604331467`, 2.5411104581098343`, 2.380120279798131`, \
1.2114699093357297`, 0.0351814991117076`, 16.57914919244248`, \
20.11375257069424`, 0.15646873646280815`, 1.4248208370067788`, \
0.11936648284508103`, 1.7972387386954218`}\\)\[NoBreak] is not a number at \
\[NoBreak]\\!\\({\\(\\(x[1]\\)\\), \\(\\(x[2]\\)\\), \\(\\(x[3]\\)\\), \
\\(\\(x[4]\\)\\), \\(\\(x[5]\\)\\), \\(\\(x[6]\\)\\), \\(\\(x[7]\\)\\), \
\\(\\(x[8]\\)\\), \\(\\(x[9]\\)\\), \\(\\(x[10]\\)\\), \\(\\(x[11]\\)\\), \\(\
\\(x[12]\\)\\), \\(\\(y[1]\\)\\), \\(\\(y[2]\\)\\), \\(\\(y[3]\\)\\), \
\\(\\(y[4]\\)\\), \\(\\(y[5]\\)\\), \\(\\(y[6]\\)\\), \\(\\(y[7]\\)\\), \
\\(\\(y[8]\\)\\), \\(\\(y[9]\\)\\), \\(\\(y[10]\\)\\), \\(\\(y[11]\\)\\), \\(\
\\(y[12]\\)\\)}\\)\[NoBreak] = \
\[NoBreak]\\!\\({\\(\\(-0.17075989212102635`\\)\\), \
\\(\\(-0.26321370655412313`\\)\\), 0.3765209063235695`, \
\\(\\(-0.3811712085455714`\\)\\), \\(\\(-0.5907188010625567`\\)\\), \
\\(\\(-0.2670584255926072`\\)\\), \\(\\(-0.44650051467901963`\\)\\), \
0.5924918082010583`, \\(\\(\[LeftSkeleton] 9 \[RightSkeleton]\\)\\), \
0.34450221319782814`, 0.16349058822809512`, 0.7151790764439394`, \
\\(\\(-0.02416436126429948`\\)\\), \\(\\(-0.9424422751046627`\\)\\), \
0.3599893632655048`, \\(\\(-0.5217364198140259`\\)\\)}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/NMinimize\\\", ButtonNote -> \\\
\"NMinimize::nnum\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.50674036043472*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "incst"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(NMinimize\\)\[NoBreak] was unable to \
generate any initial points satisfying the inequality constraints \
\[NoBreak]\\!\\({\\(\\(\\(\\(1\\/2 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[2]\\)\\)\\)\\) - \\(x[2]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[2]\\)\\)\\)\\) - \\(y[2]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[2]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[2]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[2]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[2]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 45 \[RightSkeleton]\\)\\), \
\\(\\(\\(\\(1\\/2 - \\(x[4]\\)\\^2 + \\(\\(2\\\\ \\(\\(x[4]\\)\\)\\\\ \
\\(\\(x[11]\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \\(y[4]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(y[4]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \\(y[11]\\)\\^2\\)\\) \
\[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[5]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[5]\\)\\)\\\\ \\(\\(x[11]\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \
\\(y[5]\\)\\^2 + \\(\\(2\\\\ \\(\\(y[5]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \
\\(y[11]\\)\\^2\\)\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 16 \
\[RightSkeleton]\\)\\)}\\)\[NoBreak]. The initial region specified may not \
contain any feasible points. Changing the initial region or specifying \
explicit initial points may provide a better solution. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/NMinimize/incst\\\", \
ButtonNote -> \\\"NMinimize::incst\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.506740361275011*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "nnum"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The function value \[NoBreak]\\!\\({1.5197066906035321`, \
10.59393604331467`, 2.5411104581098343`, 2.380120279798131`, \
1.2114699093357297`, 0.0351814991117076`, 16.57914919244248`, \
20.11375257069424`, 0.15646873646280815`, 1.4248208370067788`, \
0.11936648284508103`, 1.7972387386954218`}\\)\[NoBreak] is not a number at \
\[NoBreak]\\!\\({\\(\\(x[1]\\)\\), \\(\\(x[2]\\)\\), \\(\\(x[3]\\)\\), \
\\(\\(x[4]\\)\\), \\(\\(x[5]\\)\\), \\(\\(x[6]\\)\\), \\(\\(x[7]\\)\\), \
\\(\\(x[8]\\)\\), \\(\\(x[9]\\)\\), \\(\\(x[10]\\)\\), \\(\\(x[11]\\)\\), \\(\
\\(x[12]\\)\\), \\(\\(y[1]\\)\\), \\(\\(y[2]\\)\\), \\(\\(y[3]\\)\\), \
\\(\\(y[4]\\)\\), \\(\\(y[5]\\)\\), \\(\\(y[6]\\)\\), \\(\\(y[7]\\)\\), \
\\(\\(y[8]\\)\\), \\(\\(y[9]\\)\\), \\(\\(y[10]\\)\\), \\(\\(y[11]\\)\\), \\(\
\\(y[12]\\)\\)}\\)\[NoBreak] = \
\[NoBreak]\\!\\({\\(\\(-0.17075989212102635`\\)\\), \
\\(\\(-0.26321370655412313`\\)\\), 0.3765209063235695`, \
\\(\\(-0.3811712085455714`\\)\\), \\(\\(-0.5907188010625567`\\)\\), \
\\(\\(-0.2670584255926072`\\)\\), \\(\\(-0.44650051467901963`\\)\\), \
0.5924918082010583`, \\(\\(\[LeftSkeleton] 9 \[RightSkeleton]\\)\\), \
0.34450221319782814`, 0.16349058822809512`, 0.7151790764439394`, \
\\(\\(-0.02416436126429948`\\)\\), \\(\\(-0.9424422751046627`\\)\\), \
0.3599893632655048`, \\(\\(-0.5217364198140259`\\)\\)}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/NMinimize\\\", ButtonNote -> \\\
\"NMinimize::nnum\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5067403613085823`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "incst"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(NMinimize\\)\[NoBreak] was unable to \
generate any initial points satisfying the inequality constraints \
\[NoBreak]\\!\\({\\(\\(\\(\\(1\\/2 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[2]\\)\\)\\)\\) - \\(x[2]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[2]\\)\\)\\)\\) - \\(y[2]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[1]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[1]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[1]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[1]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[2]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[2]\\)\\)\\\\ \\(\\(x[3]\\)\\)\\)\\) - \\(x[3]\\)\\^2 - \\(y[2]\\)\\^2 \
+ \\(\\(2\\\\ \\(\\(y[2]\\)\\)\\\\ \\(\\(y[3]\\)\\)\\)\\) - \\(y[3]\\)\\^2\\)\
\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 45 \[RightSkeleton]\\)\\), \
\\(\\(\\(\\(1\\/2 - \\(x[4]\\)\\^2 + \\(\\(2\\\\ \\(\\(x[4]\\)\\)\\\\ \
\\(\\(x[11]\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \\(y[4]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(y[4]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \\(y[11]\\)\\^2\\)\\) \
\[LessEqual] 0\\)\\), \\(\\(\\(\\(1\\/2 - \\(x[5]\\)\\^2 + \\(\\(2\\\\ \
\\(\\(x[5]\\)\\)\\\\ \\(\\(x[11]\\)\\)\\)\\) - \\(x[11]\\)\\^2 - \
\\(y[5]\\)\\^2 + \\(\\(2\\\\ \\(\\(y[5]\\)\\)\\\\ \\(\\(y[11]\\)\\)\\)\\) - \
\\(y[11]\\)\\^2\\)\\) \[LessEqual] 0\\)\\), \\(\\(\[LeftSkeleton] 16 \
\[RightSkeleton]\\)\\)}\\)\[NoBreak]. The initial region specified may not \
contain any feasible points. Changing the initial region or specifying \
explicit initial points may provide a better solution. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/NMinimize/incst\\\", \
ButtonNote -> \\\"NMinimize::incst\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5067403621375732`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(NMinimize \
:: incst\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.506740362142894*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMinimize", "::", "nnum"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The function value \[NoBreak]\\!\\({1.5197066906035321`, \
10.59393604331467`, 2.5411104581098343`, 2.380120279798131`, \
1.2114699093357297`, 0.0351814991117076`, 16.57914919244248`, \
20.11375257069424`, 0.15646873646280815`, 1.4248208370067788`, \
0.11936648284508103`, 1.7972387386954218`}\\)\[NoBreak] is not a number at \
\[NoBreak]\\!\\({\\(\\(x[1]\\)\\), \\(\\(x[2]\\)\\), \\(\\(x[3]\\)\\), \
\\(\\(x[4]\\)\\), \\(\\(x[5]\\)\\), \\(\\(x[6]\\)\\), \\(\\(x[7]\\)\\), \
\\(\\(x[8]\\)\\), \\(\\(x[9]\\)\\), \\(\\(x[10]\\)\\), \\(\\(x[11]\\)\\), \\(\
\\(x[12]\\)\\), \\(\\(y[1]\\)\\), \\(\\(y[2]\\)\\), \\(\\(y[3]\\)\\), \
\\(\\(y[4]\\)\\), \\(\\(y[5]\\)\\), \\(\\(y[6]\\)\\), \\(\\(y[7]\\)\\), \
\\(\\(y[8]\\)\\), \\(\\(y[9]\\)\\), \\(\\(y[10]\\)\\), \\(\\(y[11]\\)\\), \\(\
\\(y[12]\\)\\)}\\)\[NoBreak] = \
\[NoBreak]\\!\\({\\(\\(-0.17075989212102635`\\)\\), \
\\(\\(-0.26321370655412313`\\)\\), 0.3765209063235695`, \
\\(\\(-0.3811712085455714`\\)\\), \\(\\(-0.5907188010625567`\\)\\), \
\\(\\(-0.2670584255926072`\\)\\), \\(\\(-0.44650051467901963`\\)\\), \
0.5924918082010583`, \\(\\(\[LeftSkeleton] 9 \[RightSkeleton]\\)\\), \
0.34450221319782814`, 0.16349058822809512`, 0.7151790764439394`, \
\\(\\(-0.02416436126429948`\\)\\), \\(\\(-0.9424422751046627`\\)\\), \
0.3599893632655048`, \\(\\(-0.5217364198140259`\\)\\)}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/NMinimize\\\", ButtonNote -> \\\
\"NMinimize::nnum\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.506740362174161*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(NMinimize \
:: nnum\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5067403621780577`*^9}],

Cell[BoxData[
 RowBox[{"Minimize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "1", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "0.314`"}], "-", 
           RowBox[{"y", "[", "1", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "2", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"3.602`", "\[VeryThinSpace]", "-", 
           RowBox[{"y", "[", "2", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "3", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1.165`"}], "-", 
           RowBox[{"y", "[", "3", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "4", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.78`", "\[VeryThinSpace]", "-", 
           RowBox[{"y", "[", "4", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.272`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.157`", "\[VeryThinSpace]", "-", 
           RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "0.272`"}], "-", 
           RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.157`", "\[VeryThinSpace]", "-", 
           RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"3.12`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1.801`"}], "-", 
           RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "3.12`"}], "-", 
           RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1.801`"}], "-", 
           RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.675`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "0.39`"}], "-", 
           RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "0.675`"}], "-", 
           RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "0.39`"}], "-", 
           RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1.009`", "\[VeryThinSpace]", "-", 
           RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.583`", "\[VeryThinSpace]", "-", 
           RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ",", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1.009`"}], "-", 
           RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"0.583`", "\[VeryThinSpace]", "-", 
           RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "2", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "2", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "3", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "3", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "4", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "4", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "1", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "1", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "3", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "3", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "4", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "4", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "2", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "2", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "4", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "4", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "3", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "3", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "4", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "4", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "5", "]"}], "-", 
            RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "5", "]"}], "-", 
            RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "5", "]"}], "-", 
            RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "5", "]"}], "-", 
            RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "5", "]"}], "-", 
            RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "5", "]"}], "-", 
            RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "5", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "5", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "5", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "5", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "5", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "5", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "5", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "5", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "6", "]"}], "-", 
            RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "6", "]"}], "-", 
            RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "6", "]"}], "-", 
            RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "6", "]"}], "-", 
            RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "6", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "6", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "6", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "6", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "6", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "6", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "6", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "6", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "7", "]"}], "-", 
            RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "7", "]"}], "-", 
            RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "7", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "7", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "7", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "7", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "7", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "7", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "7", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "7", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "8", "]"}], "-", 
            RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "8", "]"}], "-", 
            RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "8", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "8", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "8", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "8", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "8", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "8", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "9", "]"}], "-", 
            RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "9", "]"}], "-", 
            RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "9", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "9", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "9", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "9", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "10", "]"}], "-", 
            RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "10", "]"}], "-", 
            RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "10", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "10", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", "11", "]"}], "-", 
            RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"y", "[", "11", "]"}], "-", 
            RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
        FractionBox["1", "2"]}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "[", "1", "]"}], ",", 
     RowBox[{"y", "[", "1", "]"}], ",", 
     RowBox[{"x", "[", "2", "]"}], ",", 
     RowBox[{"y", "[", "2", "]"}], ",", 
     RowBox[{"x", "[", "3", "]"}], ",", 
     RowBox[{"y", "[", "3", "]"}], ",", 
     RowBox[{"x", "[", "4", "]"}], ",", 
     RowBox[{"y", "[", "4", "]"}], ",", 
     RowBox[{"x", "[", "5", "]"}], ",", 
     RowBox[{"y", "[", "5", "]"}], ",", 
     RowBox[{"x", "[", "6", "]"}], ",", 
     RowBox[{"y", "[", "6", "]"}], ",", 
     RowBox[{"x", "[", "7", "]"}], ",", 
     RowBox[{"y", "[", "7", "]"}], ",", 
     RowBox[{"x", "[", "8", "]"}], ",", 
     RowBox[{"y", "[", "8", "]"}], ",", 
     RowBox[{"x", "[", "9", "]"}], ",", 
     RowBox[{"y", "[", "9", "]"}], ",", 
     RowBox[{"x", "[", "10", "]"}], ",", 
     RowBox[{"y", "[", "10", "]"}], ",", 
     RowBox[{"x", "[", "11", "]"}], ",", 
     RowBox[{"y", "[", "11", "]"}], ",", 
     RowBox[{"x", "[", "12", "]"}], ",", 
     RowBox[{"y", "[", "12", "]"}]}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.50674036309507*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"objCl", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.50674007122779*^9, 3.506740072913218*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{"0.`", "\[VeryThinSpace]", "-", 
     RowBox[{"x", "[", "1", "]"}]}], ")"}], "2"], "+", 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1.165`"}], "-", 
     RowBox[{"y", "[", "1", "]"}]}], ")"}], "2"]}]], "Output",
 CellChangeTimes->{3.5067400733014402`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["jedges"], "Input",
 CellChangeTimes->{{3.506740153089389*^9, 3.506740157556099*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "5", ",", "6", ",", "9", ",", "10"}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "5", ",", "6", ",", "9", ",", "10", ",", "11"}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "6", ",", "8", ",", "10", ",", "12"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10"}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "10", ",", "11"}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "10", ",", "11"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11"}], 
      "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "5", ",", "6", ",", "9", ",", "10", ",", "11"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "4", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11"}], 
      "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5067401580507727`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5067400834282*^9, 3.506740122958885*^9}}],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.506740196207518*^9, 3.506740276077965*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "2", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "2", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "3", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "3", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "4", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "4", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "1", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "1", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "3", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "3", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "4", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "4", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "2", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "2", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "4", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "4", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "3", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "3", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "5", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "5", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "4", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "4", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "5", "]"}], "-", 
        RowBox[{"x", "[", "6", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "5", "]"}], "-", 
        RowBox[{"y", "[", "6", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "5", "]"}], "-", 
        RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "5", "]"}], "-", 
        RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "5", "]"}], "-", 
        RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "5", "]"}], "-", 
        RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "5", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "5", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "5", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "5", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "5", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "5", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "5", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "5", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "6", "]"}], "-", 
        RowBox[{"x", "[", "7", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "6", "]"}], "-", 
        RowBox[{"y", "[", "7", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "6", "]"}], "-", 
        RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "6", "]"}], "-", 
        RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "6", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "6", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "6", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "6", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "6", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "6", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "6", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "6", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "7", "]"}], "-", 
        RowBox[{"x", "[", "8", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "7", "]"}], "-", 
        RowBox[{"y", "[", "8", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "7", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "7", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "7", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "7", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "7", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "7", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "7", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "7", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "8", "]"}], "-", 
        RowBox[{"x", "[", "9", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "8", "]"}], "-", 
        RowBox[{"y", "[", "9", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "8", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "8", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "8", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "8", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "8", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "8", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "9", "]"}], "-", 
        RowBox[{"x", "[", "10", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "9", "]"}], "-", 
        RowBox[{"y", "[", "10", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "9", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "9", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "9", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "9", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "10", "]"}], "-", 
        RowBox[{"x", "[", "11", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "10", "]"}], "-", 
        RowBox[{"y", "[", "11", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "10", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "10", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"x", "[", "11", "]"}], "-", 
        RowBox[{"x", "[", "12", "]"}]}], ")"}], "2"], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"y", "[", "11", "]"}], "-", 
        RowBox[{"y", "[", "12", "]"}]}], ")"}], "2"]}], ">", 
    FractionBox["1", "2"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.506740249816285*^9, 3.506740269736986*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["jnodes"], "Input",
 CellChangeTimes->{{3.506788481516962*^9, 3.506788482093026*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.506788482350294*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fl1", "@", 
  RowBox[{"Outer", "[", 
   RowBox[{"List", ",", "jnodes", ",", "jnodes", ",", "1"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.506788491830948*^9, 3.506788536318512*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "8", ",", "9"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4", ",", "5", ",", "6"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "5", ",", "6", ",", "7"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.50678853048092*^9, 3.5067885368724937`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "%", "]"}]], "Input",
 CellChangeTimes->{{3.506788542360466*^9, 3.506788545837297*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"36", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.506788546218696*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "@", "jnodes"}]], "Input",
 CellChangeTimes->{{3.506788551675214*^9, 3.5067885536198673`*^9}}],

Cell[BoxData["6"], "Output",
 CellChangeTimes->{3.506788553980933*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graph", "[", 
  RowBox[{
   RowBox[{"Range", "[", "4", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "\[UndirectedEdge]", "2"}], ",", 
     RowBox[{"3", "\[UndirectedEdge]", "4"}]}], "}"}], ",", 
   RowBox[{"VertexShapeFunction", "\[Rule]", "frag$vsf"}], ",", 
   RowBox[{"VertexCoordinates", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"1", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"2", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], ",", 
      RowBox[{"3", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], ",", 
      RowBox[{"4", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.506790970802593*^9, 3.506790986182181*^9}, {
  3.506791023014585*^9, 3.506791085772806*^9}}],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4}, {Null, {{1, 2}, {3, 4}}}, {
      VertexShapeFunction -> {$CellContext`frag$vsf}, 
       VertexCoordinates -> {{0., 0.}, {0., 1.}, {1., 0.}, {1., 1.}}}]], 
    Typeset`boxes = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[{
         GrayLevel[0], 
         CircleBox[{0., 0.}, 
          NCache[
           Rational[1, 4], 0.25]], 
         InsetBox[
          FormBox["1", TraditionalForm], {0., 0.}]}, "DynamicName", BoxID -> 
        "VertexID$1"], 
       TagBox[{
         GrayLevel[0], 
         CircleBox[{0., 1.}, 
          NCache[
           Rational[1, 4], 0.25]], 
         InsetBox[
          FormBox["2", TraditionalForm], {0., 1.}]}, "DynamicName", BoxID -> 
        "VertexID$2"], 
       TagBox[{
         GrayLevel[0], 
         CircleBox[{1., 0.}, 
          NCache[
           Rational[1, 4], 0.25]], 
         InsetBox[
          FormBox["3", TraditionalForm], {1., 0.}]}, "DynamicName", BoxID -> 
        "VertexID$3"], 
       TagBox[{
         GrayLevel[0], 
         CircleBox[{1., 1.}, 
          NCache[
           Rational[1, 4], 0.25]], 
         InsetBox[
          FormBox["4", TraditionalForm], {1., 1.}]}, "DynamicName", BoxID -> 
        "VertexID$4"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$2", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}}]}}]}, 
    DynamicBox[GraphComputation`NetworkGraphicsBox[
     1, Typeset`graph, Typeset`boxes], {
     CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
      SynchronousUpdating -> False, TrackedSymbols :> {}},
     ImageSizeCache->{{2.6799999999999997`, 181.32}, {-92.46719999999999, 
      86.1728}}]]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None,
  ImageSize->{185., Automatic}]], "Output",
 CellChangeTimes->{3.50679098663871*^9, 3.506791054974386*^9, 
  3.5067910863078947`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"twoColorGraph", "[", 
    RowBox[{"g_", ",", "seen_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vcoords", "=", 
      RowBox[{"graphCoords", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"verts", "=", 
      RowBox[{"VertexList", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"edges", "=", 
      RowBox[{"EdgeList", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"frag$vsf", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x_", ",", "y_"}], "}"}], ",", "v_", ",", 
        RowBox[{"{", 
         RowBox[{"w_", ",", "h_"}], "}"}]}], "]"}], ":=", 
      RowBox[{"{", 
       RowBox[{"Black", ",", 
        RowBox[{"EdgeForm", "[", "Thick", "]"}], ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{"seen", ",", "v"}], "]"}], ",", "Pink", ",", "White"}], 
         "]"}], ",", 
        RowBox[{"Disk", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}], ",", 
          RowBox[{"1", "/", "4"}]}], "]"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Graph", "[", 
      RowBox[{"verts", ",", "edges", ",", 
       RowBox[{"VertexShapeFunction", "\[Rule]", "frag$vsf"}], ",", 
       RowBox[{"VertexCoordinates", "\[Rule]", "vcoords"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "60"}]}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.506791014450574*^9, {3.506791100222427*^9, 3.506791137570088*^9}, {
   3.506791325034627*^9, 3.506791333624028*^9}, {3.506791373400401*^9, 
   3.506791578583208*^9}, {3.506791861170806*^9, 3.5067918811290703`*^9}, {
   3.5067923299885*^9, 3.506792330817546*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"seen", "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "4"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.506791361490369*^9, 3.5067913652321033`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.506791365771042*^9, 3.506791399036203*^9, 
  3.506791440302289*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.506791584745891*^9, 3.50679160067807*^9}, 
   3.506791897800021*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"gg", "=", 
   RowBox[{"Graph", "[", 
    RowBox[{
     RowBox[{"Range", "@", "4"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[UndirectedEdge]", "2"}], ",", 
       RowBox[{"3", "\[UndirectedEdge]", "4"}]}], "}"}], ",", 
     RowBox[{"VertexCoordinates", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"2", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], ",", 
        RowBox[{"3", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}], ",", 
        RowBox[{"4", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}]}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Show", "[", 
        RowBox[{"twoColorGraph", "[", 
         RowBox[{"gg", ",", "#"}], "]"}], "]"}], "&"}], ",", 
      RowBox[{"Partition", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "1", "}"}], ",", 
          RowBox[{"{", "2", "}"}], ",", 
          RowBox[{"{", "3", "}"}], ",", 
          RowBox[{"{", "4", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "3"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3"}], "}"}]}], "}"}], ",", "3"}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], ",", 
    RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.506791640798786*^9, 3.506791769137452*^9}, {
   3.506791802680419*^9, 3.506791828159034*^9}, 3.506791898964758*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60]},
    {
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60]},
    {
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 1.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{1., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60], 
     GraphicsBox[{GraphicsGroupBox[{
         {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
          {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}, 
          {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 0.}, 0.25]}, 
          {GrayLevel[1], EdgeForm[Thickness[Large]], 
           DiskBox[{1., 1.}, 0.25]}}, 
         {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
          LineBox[{{{5.551115123125783*^-17, 0.2764830508474574}, {
           5.551115123125783*^-17, 0.7235169491525424}}, {{1., 
           0.2764830508474574}, {1., 0.7235169491525424}}}]}}], {}},
      FrameTicks->None,
      ImageSize->60]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.5067916465632143`*^9, 3.5067917201027403`*^9}, 
   3.506791753811357*^9, 3.5067918309235*^9, {3.506791864513468*^9, 
   3.50679187639572*^9}, 3.5067923349417477`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"gg1", "=", 
   RowBox[{"Graph", "[", 
    RowBox[{
     RowBox[{"Range", "@", "2"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", "\[UndirectedEdge]", "2"}], "}"}], ",", 
     RowBox[{"VertexCoordinates", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"2", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}]}], "}"}]}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.506791925987788*^9, 3.5067919531917067`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"twoColorGraph", "[", 
      RowBox[{"gg1", ",", "#"}], "]"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "25"}]}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "1", "}"}], ",", 
    RowBox[{"{", "2", "}"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.506791956970118*^9, 3.506792025514192*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{GraphicsGroupBox[{
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
        {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
        {GrayLevel[1], EdgeForm[Thickness[Large]], 
         DiskBox[{0., 1.}, 0.25]}}, 
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
        LineBox[{{-5.551115123125783*^-17, 
         0.258827683615819}, {-5.551115123125783*^-17, 
         0.7411723163841804}}]}}], {}},
    FrameTicks->None,
    ImageSize->25], ",", 
   GraphicsBox[{GraphicsGroupBox[{
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
        {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
         DiskBox[{0., 0.}, 0.25]}, 
        {GrayLevel[1], EdgeForm[Thickness[Large]], 
         DiskBox[{0., 1.}, 0.25]}}, 
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
        LineBox[{{-5.551115123125783*^-17, 
         0.258827683615819}, {-5.551115123125783*^-17, 
         0.7411723163841804}}]}}], {}},
    FrameTicks->None,
    ImageSize->25], ",", 
   GraphicsBox[{GraphicsGroupBox[{
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
        {GrayLevel[1], EdgeForm[Thickness[Large]], DiskBox[{0., 0.}, 0.25]}, 
        {RGBColor[1, 0.5, 0.5], EdgeForm[Thickness[Large]], 
         DiskBox[{0., 1.}, 0.25]}}, 
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
        LineBox[{{-5.551115123125783*^-17, 
         0.258827683615819}, {-5.551115123125783*^-17, 
         0.7411723163841804}}]}}], {}},
    FrameTicks->None,
    ImageSize->25]}], "}"}]], "Output",
 CellChangeTimes->{{3.5067919870599813`*^9, 3.5067920262517014`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Format", "[", 
   RowBox[{"myPlus", "[", "expr__", "]"}], "]"}], ":=", 
  RowBox[{"Row", "[", 
   RowBox[{"Riffle", "[", 
    RowBox[{
     RowBox[{"{", "expr", "}"}], ",", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<+\>\"", ",", "30"}], "]"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.506792044097077*^9, 3.506792044099337*^9}, {
  3.50679207624828*^9, 3.506792083877836*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"rowExpr", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Style", "[", 
      RowBox[{"\"\<(\>\"", ",", "30"}], "]"}], ",", 
     RowBox[{"myPlus", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Show", "[", 
          RowBox[{
           RowBox[{"twoColorGraph", "[", 
            RowBox[{"gg1", ",", "#"}], "]"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", "25"}]}], "]"}], "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "}"}], ",", 
          RowBox[{"{", "1", "}"}], ",", 
          RowBox[{"{", "2", "}"}]}], "}"}]}], ")"}]}], ",", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<)\>\"", ",", "30"}], "]"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.506792167488199*^9, 3.506792169914085*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"expr", "=", 
  RowBox[{"Row", "[", 
   RowBox[{"rowExpr", "~", "Join", "~", 
    RowBox[{"{", 
     RowBox[{"Style", "[", 
      RowBox[{"\"\<\[Times]\>\"", ",", "30"}], "]"}], "}"}], "~", "Join", "~",
     "rowExpr"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5067920546233263`*^9, 3.506792056998622*^9}, {
  3.506792096845396*^9, 3.5067921970136147`*^9}, {3.506792231115589*^9, 
  3.5067922421393757`*^9}}],

Cell[BoxData[
 TemplateBox[{
  StyleBox["\"(\"", StripOnInput -> False, FontSize -> 30],TemplateBox[{
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25]}, "Row", 
    DisplayFunction -> (
     RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
       "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5}]& ), 
    InterpretationFunction -> (RowBox[{"Row", "[", 
       RowBox[{"{", 
         RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5}], "}"}], "]"}]& )],
   StyleBox["\")\"", StripOnInput -> False, FontSize -> 30],StyleBox[
   "\"\[Times]\"", StripOnInput -> False, FontSize -> 30],StyleBox[
   "\"(\"", StripOnInput -> False, FontSize -> 30],TemplateBox[{
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25], 
     StyleBox["\"+\"", StripOnInput -> False, FontSize -> 30], 
     GraphicsBox[{
       GraphicsGroupBox[{{
          Hue[0.6, 0.2, 0.8], 
          EdgeForm[{
            GrayLevel[0], 
            Opacity[0.7]}], {
           GrayLevel[1], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 0.}, 0.25]}, {
           RGBColor[1, 0.5, 0.5], 
           EdgeForm[
            Thickness[Large]], 
           DiskBox[{0., 1.}, 0.25]}}, {
          Hue[0.6, 0.7, 0.5], 
          Opacity[0.7], 
          
          LineBox[{{-5.551115123125783*^-17, 
           0.258827683615819}, {-5.551115123125783*^-17, 
           0.7411723163841804}}]}}], {}}, FrameTicks -> None, ImageSize -> 
      25]}, "Row", 
    DisplayFunction -> (
     RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
       "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5}]& ), 
    InterpretationFunction -> (RowBox[{"Row", "[", 
       RowBox[{"{", 
         RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5}], "}"}], "]"}]& )],
   StyleBox["\")\"", StripOnInput -> False, FontSize -> 30]},
  "Row",
  DisplayFunction->(
   RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
     "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
     "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7}], 
       "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.506792057902824*^9, 3.506792085655045*^9}, {
   3.506792123349189*^9, 3.5067921508544273`*^9}, 3.506792242631999*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"twoColorGraph", "[", 
    RowBox[{
     RowBox[{"CycleGraph", "[", "4", "]"}], ",", 
     RowBox[{"{", "}"}]}], "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "80"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5067922980125313`*^9, 3.506792303789339*^9}, {
  3.506792343070878*^9, 3.506792356451932*^9}}],

Cell[BoxData[
 GraphicsBox[{GraphicsGroupBox[{
     {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[0.7]}], 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{1., 6.123233995736766*^-17}, 0.25]}, 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{1.2246467991473532`*^-16, -1.}, 0.25]}, 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{-1., -1.8369701987210297`*^-16}, 0.25]}, 
      {GrayLevel[1], EdgeForm[Thickness[Large]], 
       DiskBox[{-2.4492935982947064`*^-16, 1.}, 0.25]}}, 
     {Hue[0.6, 0.7, 0.5], Opacity[0.7], 
      LineBox[{{{0.7920127299687871, -0.2079872700312126}, {
       0.20798727003121237`, -0.7920127299687874}}, {{0.7920127299687871, 
       0.20798727003121256`}, {0.20798727003121212`, 
       0.7920127299687872}}, {{-0.20798727003121265`, -0.7920127299687874}, \
{-0.7920127299687874, -0.20798727003121298`}}, {{-0.7920127299687875, 
       0.2079872700312122}, {-0.20798727003121292`, 
       0.7920127299687871}}}]}}], {}},
  FrameTicks->None,
  ImageSize->80]], "Output",
 CellChangeTimes->{
  3.506792304260956*^9, {3.506792338369906*^9, 3.506792356959231*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"graphCoords", "[", 
  RowBox[{"CycleGraph", "[", "4", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.506792312938933*^9, 3.506792316142395*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1.`", ",", "6.123233995736766`*^-17"}], "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1.2246467991473532`*^-16", ",", 
      RowBox[{"-", "1.`"}]}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1.`"}], ",", 
      RowBox[{"-", "1.8369701987210297`*^-16"}]}], "}"}]}], ",", 
   RowBox[{"4", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "2.4492935982947064`*^-16"}], ",", "1.`"}], "}"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.506792316560843*^9}]
}, Open  ]]
},
WindowSize->{740, 752},
WindowMargins->{{Automatic, 259}, {Automatic, 27}},
ShowSelection->True,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 6, \
2010)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3506709453-9620136"->{
  Cell[37881, 887, 122, 2, 39, "Print",
   CellTags->"Info3506709453-9620136"],
  Cell[38006, 891, 1177, 33, 20, "Print",
   CellTags->"Info3506709453-9620136"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3506709453-9620136", 252594, 6487}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 202, 5, 27, "Input"],
Cell[784, 29, 3814, 83, 374, "Output"]
}, Open  ]],
Cell[4613, 115, 378, 10, 27, "Input"],
Cell[CellGroupData[{
Cell[5016, 129, 219, 5, 27, "Input"],
Cell[5238, 136, 28527, 620, 375, "Output"]
}, Open  ]],
Cell[33780, 759, 120, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[33925, 765, 95, 1, 27, "Input"],
Cell[34023, 768, 1304, 31, 58, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35364, 804, 99, 1, 27, "Input"],
Cell[35466, 807, 675, 17, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36178, 829, 102, 1, 27, "Input"],
Cell[36283, 832, 1267, 39, 58, "Output"]
}, Open  ]],
Cell[37565, 874, 150, 3, 27, "Input"],
Cell[CellGroupData[{
Cell[37740, 881, 116, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[37881, 887, 122, 2, 39, "Print",
 CellTags->"Info3506709453-9620136"],
Cell[38006, 891, 1177, 33, 20, "Print",
 CellTags->"Info3506709453-9620136"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[39232, 930, 237, 5, 27, "Input"],
Cell[39472, 937, 2883, 58, 374, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42392, 1000, 253, 5, 43, "Input"],
Cell[42648, 1007, 34688, 751, 374, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77373, 1763, 101, 1, 27, "Input"],
Cell[77477, 1766, 667, 17, 84, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78181, 1788, 100, 1, 27, "Input"],
Cell[78284, 1791, 643, 17, 84, "Output"]
}, Open  ]],
Cell[78942, 1811, 96, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[79063, 1816, 176, 3, 27, "Input"],
Cell[79242, 1821, 6866, 132, 329, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86145, 1958, 200, 5, 27, "Input"],
Cell[86348, 1965, 3814, 83, 374, "Output"]
}, Open  ]],
Cell[90177, 2051, 238, 6, 27, "Input"],
Cell[CellGroupData[{
Cell[90440, 2061, 416, 10, 43, "Input"],
Cell[90859, 2073, 11000, 258, 326, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[101896, 2336, 476, 11, 43, "Input"],
Cell[102375, 2349, 1507, 24, 110, "Message"],
Cell[103885, 2375, 16502, 369, 447, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120424, 2749, 101, 1, 27, "Input"],
Cell[120528, 2752, 1513, 49, 58, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122078, 2806, 161, 3, 27, "Input"],
Cell[122242, 2811, 1115, 37, 58, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123394, 2853, 160, 3, 27, "Input"],
Cell[123557, 2858, 294, 6, 328, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123888, 2869, 6702, 209, 373, "Input"],
Cell[130593, 3080, 2151, 33, 129, "Message"],
Cell[132747, 3115, 1274, 19, 328, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134058, 3139, 282, 6, 27, "Input"],
Cell[134343, 3147, 966, 18, 328, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[135346, 3170, 143, 2, 27, "Input"],
Cell[135492, 3174, 2047, 35, 103, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[137576, 3214, 190, 3, 27, "Input"],
Cell[137769, 3219, 2147, 36, 103, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139953, 3260, 583, 13, 27, "Input"],
Cell[140539, 3275, 988, 15, 354, "Output"]
}, Open  ]],
Cell[141542, 3293, 163, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[141730, 3299, 92, 1, 27, "Input"],
Cell[141825, 3302, 2001, 30, 176, "Message"],
Cell[143829, 3334, 1714, 28, 125, "Message"],
Cell[145546, 3364, 1999, 30, 176, "Message"],
Cell[147548, 3396, 1717, 28, 125, "Message"],
Cell[149268, 3426, 2001, 30, 176, "Message"],
Cell[151272, 3458, 533, 11, 23, "Message"],
Cell[151808, 3471, 1715, 28, 125, "Message"],
Cell[153526, 3501, 534, 11, 23, "Message"],
Cell[154063, 3514, 34157, 1011, 1327, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[188257, 4530, 123, 2, 27, "Input"],
Cell[188383, 4534, 350, 11, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[188770, 4550, 98, 1, 27, "Input"],
Cell[188871, 4553, 1544, 51, 73, "Output"]
}, Open  ]],
Cell[190430, 4607, 90, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[190545, 4612, 92, 1, 27, "Input"],
Cell[190640, 4615, 25397, 861, 1166, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[216074, 5481, 98, 1, 27, "Input"],
Cell[216175, 5484, 559, 15, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[216771, 5504, 208, 5, 27, "Input"],
Cell[216982, 5511, 7383, 220, 193, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[224402, 5736, 129, 2, 27, "Input"],
Cell[224534, 5740, 116, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[224687, 5748, 127, 2, 27, "Input"],
Cell[224817, 5752, 70, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[224924, 5758, 914, 25, 43, "Input"],
Cell[225841, 5785, 2358, 65, 200, "Output"]
}, Open  ]],
Cell[228214, 5853, 1807, 44, 148, "Input"],
Cell[CellGroupData[{
Cell[230046, 5901, 167, 4, 27, "Input"],
Cell[230216, 5907, 162, 4, 27, "Output"]
}, Open  ]],
Cell[230393, 5914, 117, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[230535, 5920, 1878, 53, 88, "Input"],
Cell[232416, 5975, 7247, 138, 217, "Output"]
}, Open  ]],
Cell[239678, 6116, 602, 18, 27, "Input"],
Cell[CellGroupData[{
Cell[240305, 6138, 431, 13, 27, "Input"],
Cell[240739, 6153, 1657, 37, 86, "Output"]
}, Open  ]],
Cell[242411, 6193, 425, 11, 27, "Input"],
Cell[242839, 6206, 809, 23, 73, "Input"],
Cell[CellGroupData[{
Cell[243673, 6233, 432, 10, 27, "Input"],
Cell[244108, 6245, 5717, 159, 86, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[249862, 6409, 363, 9, 27, "Input"],
Cell[250228, 6420, 1152, 22, 95, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[251417, 6447, 167, 3, 27, "Input"],
Cell[251587, 6452, 649, 20, 53, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
